/**  memory_stm32f1xx.ld **********************************************
 *
 *                          The ToolChain
 *
 *  The ToolChain has been originally developed by Gregor Rebel 2010-2019.
 *
 *  Architecture dependend memory layout for stm32f1xx.
 *
 */

/* memory.ld will define memory spaces */
INCLUDE configs/memory_current.ld
INCLUDE ttc-lib/_linker/memory_cortexm3.ld
INCLUDE configs/memory_project.ld

/* moving register variables to fixed addresses
 *
 * Reference: RM0008 p.50, p.119
 * Compare with registers_stm32f1xx.c
 */

register_stm32f1xx_RCC         = 0x40021000;
register_stm32f1xx_TIMER1      = 0x40012c00;
register_stm32f1xx_TIMER2      = 0x40000000;
register_stm32f1xx_TIMER3      = 0x40000400;
register_stm32f1xx_TIMER4      = 0x40000800;
register_stm32f1xx_TIMER5      = 0x40000c00;
register_stm32f1xx_TIMER6      = 0x40001000;
register_stm32f1xx_TIMER7      = 0x40001400;
register_stm32f1xx_TIMER8      = 0x40013400;
register_stm32f1xx_TIMER9      = 0x40014c00;
register_stm32f1xx_TIMER10     = 0x40015000;
register_stm32f1xx_TIMER11     = 0x40015400;
register_stm32f1xx_TIMER12     = 0x40001800;
register_stm32f1xx_TIMER13     = 0x40001c00;
register_stm32f1xx_TIMER14     = 0x40002000;
register_stm32f1xx_TIMER15     = 0x40014000;
register_stm32f1xx_TIMER16     = 0x40014400;
register_stm32f1xx_TIMER17     = 0x40014800;

register_stm32f1xx_USART1      = 0x40013800;
register_stm32f1xx_USART2      = 0x40004400;
register_stm32f1xx_USART3      = 0x40004800;
register_stm32f1xx_UART4       = 0x40004c00;
register_stm32f1xx_UART5       = 0x40005000;
register_stm32f1xx_SPI1        = 0x40013000;
register_stm32f1xx_SPI2        = 0x40003800;
register_stm32f1xx_SPI3        = 0x40003c00;
register_stm32f1xx_I2C1        = 0x40005400;
register_stm32f1xx_I2C2        = 0x40005800;
register_stm32f1xx_CAN1        = 0x40006400;
register_stm32f1xx_CAN2        = 0x40006800;
register_stm32f1xx_ADC1        = 0x40012400;
register_stm32f1xx_ADC2        = 0x40012800;
register_stm32f1xx_ADC3        = 0x40013C00;
register_stm32f1xx_GPIOA       = 0x40010800;
register_stm32f1xx_GPIOB       = 0x40010c00;
register_stm32f1xx_GPIOC       = 0x40011000;
register_stm32f1xx_GPIOD       = 0x40011400;
register_stm32f1xx_GPIOE       = 0x40011800;
register_stm32f1xx_GPIOF       = 0x40011c00;
register_stm32f1xx_GPIOG       = 0x40012000;
register_stm32f1xx_AFIO        = 0x40010000;
register_stm32f1xx_EXTI        = 0x40010400;
register_stm32f1xx_DGBMCU      = 0xe0042000;
register_stm32f1xx_USB         = 0x40005c00;
