/**  memory_stm32f1xx.ld **********************************************
 *
 *                          The ToolChain
 *
 *  The ToolChain has been originally developed by Gregor Rebel 2010-2019.
 *
 *  Architecture dependend memory layout for stm32l1xx.
 *
 */
 
/* memory.ld will define memory spaces */
INCLUDE configs/memory_current.ld
INCLUDE ttc-lib/_linker/memory_cortexm3.ld
INCLUDE configs/memory_project.ld


/* moving register variables to fixed addresses
 *
 * Reference: RM0038 p.50, p.119
 * Compare with registers_stm32l1xx.c
 */

register_stm32l1xx_RCC           = 0x40023800;
register_stm32l1xx_DAC           = 0x40007400;
register_stm32l1xx_PWR           = 0x40007000;
register_stm32l1xx_RTC           = 0x40002800;
register_stm32l1xx_DMA           = 0x40026000;
register_stm32l1xx_DMA_CHANNEL1  = 0x40026000 + 0x0008;
register_stm32l1xx_DMA_CHANNEL2  = 0x40026000 + 0x001C;
register_stm32l1xx_DMA_CHANNEL3  = 0x40026000 + 0x0030;
register_stm32l1xx_TIMER2        = 0x40000000;
register_stm32l1xx_TIMER3        = 0x40000400;
register_stm32l1xx_TIMER4        = 0x40000800;
register_stm32l1xx_TIMER5        = 0x40000c00;
register_stm32l1xx_TIMER6        = 0x40001000;
register_stm32l1xx_TIMER7        = 0x40001400;
register_stm32l1xx_TIMER9        = 0x40010800;
register_stm32l1xx_TIMER10       = 0x40010c00;
register_stm32l1xx_TIMER11       = 0x40011000;
register_stm32l1xx_USART1        = 0x40013800;
register_stm32l1xx_USART2        = 0x40004400;
register_stm32l1xx_USART3        = 0x40004800;
register_stm32l1xx_UART4         = 0x40004c00;
register_stm32l1xx_UART5         = 0x40005000;
register_stm32l1xx_SPI1          = 0x40013000;
register_stm32l1xx_SPI2          = 0x40003800;
register_stm32l1xx_SPI3          = 0x40003C00;
register_stm32l1xx_I2C1          = 0x40005400;
register_stm32l1xx_I2C2          = 0x40005800;
register_stm32l1xx_ADC1          = 0x40012400;
register_stm32l1xx_GPIOA         = 0x40020000 + 0x00000;
register_stm32l1xx_GPIOB         = 0x40020000 + 0x00400;
register_stm32l1xx_GPIOC         = 0x40020000 + 0x00800;
register_stm32l1xx_GPIOD         = 0x40020000 + 0x00C00;
register_stm32l1xx_GPIOE         = 0x40020000 + 0x01000;
register_stm32l1xx_GPIOH         = 0x40020000 + 0x01400;
register_stm32l1xx_GPIOF         = 0x40020000 + 0x01800;
register_stm32l1xx_GPIOG         = 0x40020000 + 0x01C00;
register_stm32l1xx_EXTI          = 0x40010400;
register_stm32l1xx_DGBMCU        = 0xE0042000;
register_stm32l1xx_RI_ASCR1      = 0x40007c00 + 0x04;
register_stm32l1xx_RI_ASCR2      = 0x40007c00 + 0x0c;
register_stm32l1xx_RI_HYSCR1     = 0x40007c00 + 0x10;
register_stm32l1xx_RI_HYSCR2     = 0x40007c00 + 0x14;
register_stm32l1xx_RI_HYSCR3     = 0x40007c00 + 0x18;
register_stm32l1xx_RI_HYSCR4     = 0x40007c00 + 0x1c;
register_stm32l1xx_RI_ASMR1      = 0x40007c00 + 0x20;
register_stm32l1xx_RI_CMR1       = 0x40007c00 + 0x24;
register_stm32l1xx_RI_CICR1      = 0x40007c00 + 0x28;
register_stm32l1xx_RI_ASMR2      = 0x40007c00 + 0x2c;
register_stm32l1xx_RI_CMR2       = 0x40007c00 + 0x30;
register_stm32l1xx_RI_CICR2      = 0x40007c00 + 0x34;
register_stm32l1xx_RI_ASMR3      = 0x40007c00 + 0x38;
register_stm32l1xx_RI_CMR3       = 0x40007c00 + 0x3c;
register_stm32l1xx_RI_CICR3      = 0x40007c00 + 0x40;
register_stm32l1xx_RI_ASMR4      = 0x40007c00 + 0x44;
register_stm32l1xx_RI_CMR4       = 0x40007c00 + 0x48;
register_stm32l1xx_RI_CICR4      = 0x40007c00 + 0x4c;
register_stm32l1xx_RI_ASMR5      = 0x40007c00 + 0x50;
register_stm32l1xx_RI_CMR5       = 0x40007c00 + 0x54;
register_stm32l1xx_RI_CICR5      = 0x40007c00 + 0x58;
register_stm32l1xx_RI_CMR5       = 0x40007c00 + 0x54;
