#ifndef GYROSCOPE_MPU6050_TYPES_H
#define GYROSCOPE_MPU6050_TYPES_H

/** { gyroscope_mpu6050.h ************************************************
 *
 *                          The ToolChain
 *
 *  The ToolChain has been originally developed by Gregor Rebel 2010-2019.
 *                     
 *  Low-Level datatypes for GYROSCOPE devices on mpu6050 architectures.
 *  Structures, Enums and Defines being required by ttc_gyroscope_types.h
 *
 *  Created from template device_architecture_types.h revision 21 at 20150121 10:09:22 UTC
 *
 *  Note: See ttc_gyroscope.h for description of architecture independent GYROSCOPE implementation.
 * 
 *  Authors: Gregor Rebel
 *
}*/
//{ Defines/ TypeDefs **********************************************************

//InsertDefines above (DO NOT DELETE THIS LINE!)

//InsertEnums above (DO NOT DELETE THIS LINE!)

//InsertTypeDefs above (DO NOT DELETE THIS LINE!)

//} Defines
//{ Includes *******************************************************************

#include "../ttc_basic_types.h"
#include "../ttc_i2c.h"
//InsertIncludes above (DO NOT DELETE THIS LINE!)

//} Includes
//{ Structures/ Enums required by ttc_gyroscope_types.h *************************
typedef struct {
    t_u16 who_am_i;
    t_u16 pwr_mgmt_1;
    t_u16 ctrl_reg1;
    t_u16 ctrl_reg2;
    t_u16 ctrl_reg3;
    t_u16 outx_l;
    t_u16 outx_h;
    t_u16 outy_l;
    t_u16 outy_h;
    t_u16 outz_l;
    t_u16 outz_h;
}__attribute__((__packed__))t_gyroscope_mpu6050_registers;

typedef struct { // register description (adapt according to mpu6050 registers)
  unsigned Reserved1 : 16; 
  unsigned Reserved2 : 16; 
} t_gyroscope_register;

typedef struct {  // mpu6050 specific configuration data of single GYROSCOPE device
    t_gyroscope_mpu6050_registers t_register;
    t_u16 address;
} __attribute__((__packed__)) t_gyroscope_mpu6050_config;

// t_ttc_gyroscope_architecture is required by ttc_gyroscope_types.h
#define t_ttc_gyroscope_architecture t_gyroscope_mpu6050_config

//} Structures/ Enums


#endif //GYROSCOPE_MPU6050_TYPES_H
