#ifndef LIGHT_COMMON_H
#define LIGHT_COMMON_H

/** light_common.h ****************************************************{
 *
 *                          The ToolChain
 *
 *  Common source code available to light low-level drivers of all architectures.
 *  The functions provided here are common in two ways:
 *  1) They can be called from high-level driver ttc_light.c and from current low-level driver light_*.c.
 *  2) All common_light_*() functions can call low-level driver functions as _driver_light_*().
 *
 *  Created from template ttc-lib/templates/device_common.h revision 15 at 20191218 12:21:38 UTC
 *
 *  Authors: Gregor Rebel
 *
 *  Description of light_common (Do not delete this line!)
 *
 *  PLACE_YOUR_DESCRIPTION_HERE
}*/
//  Defines/ TypeDefs ****************************************************{

//InsertDefines above (DO NOT DELETE THIS LINE!)

//InsertEnums above (DO NOT DELETE THIS LINE!)

//InsertTypeDefs above (DO NOT DELETE THIS LINE!)

//} Defines
/** Includes *************************************************************{
 *
 * Header files include all header files that are required to include this
 * header file. Includes that provide function declarations should be placed
 * in "light_gpio.c"
 */

#include "../ttc_basic.h"
#include "../ttc_light_types.h" // will include light_common_types.h (do not include it directly!)
//InsertIncludes above (DO NOT DELETE THIS LINE!)

//} Includes
/** Macro definitions ****************************************************{
 *
 * define all supported low-level functions for ttc_light_interface.h
 *
 * Note: ttc_driver_*() functions not being implemented must be undefined via #undef
 * Example: #undef ttc_driver_light_foo
 */

//InsertLowLevelMacros above (DO NOT DELETE THIS LINE!)

//}MacroDefinitions
/** Function prototypes **************************************************{
 *
 * The prototypes listed below have been created automatically by create_Driver.pl based
 * on section "Prototypes of low-level driver functions" in file ttc_light.h.
 * You may remove all prototypes here and have them reconstructed automatically.
 * Check file ttc_light.h for details.
 *
 * You normally should not need to add functions here.
 * Global feature functions must be added in ttc_light.h and propagated into
 * all low-level drivers via "./create_DeviceDriver.pl light UPDATE".
 */

/** Delivers access to configuration data of individual channel
 *
 * ttc_light devices each support one or more channels.
 * The size of configuration structure varies for the different light types.
 * Using this function to access t_ttc_light_config.Light is safer than accessing this union directly.
 *
 * Typical light provide either one (monochromatic) or three (full color rgb) channels.
 * Four channel lights may provide red+green+blue+white colors.
 *
 * Note: This function will not assert if ChannelIndex > Config->AmountChannels
 *       But it will assert if (ChannelIndex == 0) || (Config->AmountChannels == 0)
 *
 * @param Config       (t_ttc_light_config*)          pointer to initialized configuration of ttc_light device
 * @param ChannelIndex (t_u8)                         Logical index of channel to configure (1..ttc_light_get_configuration(LogicalIndex)->AmountChannels)
 * @return             (t_ttc_light_channel_config*)  ==NULL: desired channel not available for this light; !=NULL: configuration data (call ttc_light_init() after changing fields!)
 */
t_ttc_light_channel_config* light_common_get_channel_configuration( t_ttc_light_config* Config, t_u8 ChannelIndex );

//InsertFunctionDeclarations above (DO NOT DELETE THIS LINE!)

//}Function prototypes

#endif //LIGHT_COMMON_H
