#ifndef LIGHT_GPIO_TYPES_H
#define LIGHT_GPIO_TYPES_H

/** { light_gpio.h ************************************************
 *
 *                          The ToolChain
 *
 *  The ToolChain has been originally developed by Gregor Rebel 2010-2019.
 *
 *  Low-level driver for ttc_light.h providing
 *  Structures, Enums and Defines being required by ttc_light_types.h
 *
 *  control multiple light emitting diodes (led)
 *
 *  Created from template device_architecture_types.h revision 27 at 20191218 12:21:38 UTC
 *
 *  Note: See ttc_light.h for description of high-level light implementation!
 *  Note: See light_gpio.h for description of gpio specific light implementation!
 *
 *  Authors: Gregor Rebel
 *
}*/
//{ Defines/ TypeDefs **********************************************************

#ifndef TTC_LIGHT1   // device not defined in makefile
    #define TTC_LIGHT1    E_ttc_light_architecture_gpio   // example device definition for current architecture (Disable line if not desired!)
#endif
//InsertDefines above (DO NOT DELETE THIS LINE!)

//InsertEnums above (DO NOT DELETE THIS LINE!)

//InsertTypeDefs above (DO NOT DELETE THIS LINE!)

//} Defines
//{ Includes *******************************************************************

#ifndef TTC_LIGHT_TYPES_H
    #  error Do not include light_common_types.h directly. Include ttc_light_types.h instead!
#endif

#include "../ttc_basic_types.h"
#include "../ttc_gpio_types.h"
//InsertIncludes above (DO NOT DELETE THIS LINE!)

//} Includes
//{ Structures/ Enums required by ttc_light_types.h *************************

typedef struct {  // gpio specific configuration data of single channel of light device
    e_ttc_gpio_pin  Pin;        // gpio pin to which this LIGHT is connected to
    e_ttc_gpio_mode ModeGPIO;   // gpio mode to use for given Pin (default = E_ttc_gpio_mode_output_push_pull)
    t_bool          LowActive;  // ==TRUE: gpio pin must be cleared (set to 0V) to enable LED; ==FALSE; ... set ...
} __attribute__( ( __packed__ ) ) t_light_gpio_channel_config;

typedef struct {
    t_u8 unused; // yet unused for gpio controlled lights
} t_light_gpio_config;

//} Structures/ Enums

#endif //LIGHT_GPIO_TYPES_H
