#ifndef USART_STM32L1XX_TYPES_H
#define USART_STM32L1XX_TYPES_H

/** { usart_stm32l1xx.h ************************************************
 *
 *                          The ToolChain
 *
 *  The ToolChain has been originally developed by Gregor Rebel 2010-2019.
 *
 *  Low-Level datatypes for USART devices on stm32l1xx architectures.
 *  Structures, Enums and Defines being required by ttc_usart_types.h
 *
 *  Created from template device_architecture_types.h revision 20 at 20140423 01:03:12 UTC
 *
 *  Note: See ttc_usart.h for description of architecture independent USART implementation.
 *
 *  Authors: Greg Knoll 2014.
 *
}*/


//{ Includes *******************************************************************

#include "../ttc_basic.h"
#include "../gpio/gpio_stm32l1xx.h"
#include "../register/register_stm32l1xx.h"

//InsertIncludes above (DO NOT DELETE THIS LINE!)
//} Includes
//{ Defines/ TypeDefs **********************************************************

#define TTC_USART_MAX_AMOUNT 3

#define _driver_usart_isr_rx         _usart_stm32l1xx_rx_isr // define function pointer for receive interrupt service routine
#define _driver_usart_isr_tx         _usart_stm32l1xx_tx_isr // define function pointer for transmit interrupt service routine
#define t_ttc_usart_register         t_register_stm32l1xx_usart
#define t_ttc_usart_register_tx      t_register_stm32l1xx_usart_dr
#define t_ttc_usart_register_rx      t_register_stm32l1xx_usart_dr

//InsertDefines above (DO NOT DELETE THIS LINE!)

//InsertEnums above (DO NOT DELETE THIS LINE!)

//InsertTypeDefs above (DO NOT DELETE THIS LINE!)

//} Defines

//{ Structures/ Enums required by ttc_usart_types.h *************************
#if 1==0
typedef struct {  // stm32l1xx specific configuration data of single USART device

    unused..
} __attribute__( ( __packed__ ) ) t_usart_stm32l1xx_config;

// t_ttc_usart_architecture is required by ttc_usart_types.h
#define t_ttc_usart_architecture t_usart_stm32l1xx_config
#else
#define t_ttc_usart_architecture t_u8 // unused

#endif

//} Structures/ Enums


#endif //USART_STM32L1XX_TYPES_H
