/** { memory_cortexm3.ld **********************************************
 *
 *                          The ToolChain
 *
 *  The ToolChain has been originally developed by Gregor Rebel 2010-2019.
 *
 *  Architecture independend memory section definitions.
 *
 *  This file defines all memory sections being required by TheToolChain.
 *  If your architecture requires additional sections, you have to insert some 
 *  of the names from here into your own linker script.
 *
 */

/* _ttc_size_stack - The main stack size
 *
 * The main stack is used at system startup and for single tasking applications (if FreeRTOS is disabled).
 * If a multitasking scheduler is activated then this defines the stack size being used for the task scheduler.
 * In many cases this allows to reduce the stack size as the scheduler may not use that much memory.
 * Stack sizes must be choosen for each application individually for optimal RAM usage!
 */
_ttc_size_stack = 0x400;

/* Include basic memory layout.
 * You may disable this line and define your own, project specific memory layout here.
 * Please read and understand the basic memory layout to define all symbols required by TTC library!
 */ 
INCLUDE ttc-lib/_linker/memory_basic.ld
