#!/bin/bash
#
# The ToolChain v1.0.52
#
# Update script for changes introduced in v1.0.52 of The ToolChain.
#
# This script shall help you in porting your project to compile with a newer release of The ToolChain.
# Updatescripts must be run in order starting at first version released after your current project.
# In addtion to run this script, you should compile and check your project for every version update.
#
ttc_manage.pl replace "500_ttc_font" "510_ttc_font"
ttc_manage.pl replace "./_/" "_/"
ttc_manage.pl replace "ttc_SemaphoreHandle" "ttc_semaphore_t*"
ttc_manage.pl replace "ttc_template.c" "ttc_DRIVER.c"
ttc_manage.pl replace "ttc_template.h" "ttc_DRIVER.h"
ttc_manage.pl replace "ttc_template_types.h" "ttc_DRIVER_types.h"
ttc_manage.pl replace "ttc_DRIVER.c" "ttc_template.c"
ttc_manage.pl replace "ttc_DRIVER.h" "ttc_template.h"
ttc_manage.pl replace "ttc_DRIVER_types.h" "ttc_template_types.h"
ttc_manage.pl replace "ttc_template.c" "ttc_driver.c"
ttc_manage.pl replace "ttc_template.h" "ttc_driver.h"
ttc_manage.pl replace "ttc_template_types.h" "ttc_driver_types.h"
ttc_manage.pl replace "ttc_memory_init_heap" "aaa_ttc_memory_init_heap"
ttc_manage.pl replace "stm32w_regs.h" "stm32w_registers.h"
ttc_manage.pl replace "ttc_task_is_scheduler_running" "ttc_task_is_scheduler_started"
ttc_manage.pl replace "GPIOx_t" "stm32f1_register_gpio_t"
ttc_manage.pl replace "I2C_t" "stm32f1_register_i2c_t"
ttc_manage.pl replace "SPI_t" "stm32f1_register_spi_t"
ttc_manage.pl replace "USART_t" "stm32f1_register_usart_t"
ttc_manage.pl replace "TIMER_t" "stm32f1_register_timer_t"
ttc_manage.pl replace "RCC_APB2ENR_t" "stm32f1_register_rcc_apb2enr_t"
ttc_manage.pl replace "RCC_APB1ENR_t" "stm32f1_register_rcc_apb1enr_t"
ttc_manage.pl replace "AFIO_t" "stm32f1_register_afio_t"
ttc_manage.pl replace "EXTI_t" "stm32f1_register_exti_t"
ttc_manage.pl replace "openlink_r11" "openglink_r11"
ttc_manage.pl replace "OpenLink" "OpenGLink"
ttc_manage.pl replace "openlink" "openglink"
ttc_manage.pl replace "em357_basic.c" "DEPRECATED_em357_basic.c"
ttc_manage.pl replace "em357_basic.h" "DEPRECATED_em357_basic.h"
ttc_manage.pl replace "em357_gpio.c" "DEPRECATED_em357_gpio.c"
ttc_manage.pl replace "em357_gpio.h" "DEPRECATED_em357_gpio.h"
ttc_manage.pl replace "stm32w_gpio.c" "DEPRECATED_stm32w_gpio.c"
ttc_manage.pl replace "stm32w_gpio.h" "DEPRECATED_stm32w_gpio.h"
ttc_manage.pl replace "em357_spi.c" "DEPRECATED_em357_spi.c"
ttc_manage.pl replace "em357_spi.h" "DEPRECATED_em357_spi.h"
ttc_manage.pl replace "TARGET_ARCHITECTURE_EM357" "TARGET_ARCHITECTURE_STM32W1xx"
ttc_manage.pl replace "DEPRECATED_em357_basic.c" "stm32w_basic.c"
ttc_manage.pl replace "DEPRECATED_em357_basic.h" "stm32w_basic.h"
ttc_manage.pl replace "em357/em357_" "stm32w/stm32w_"
ttc_manage.pl replace "TARGET_ARCHITECTURE_STM32W" "TARGET_ARCHITECTURE_STM32W1xx"
ttc_manage.pl replace "TARGET_ARCHITECTURE_STM32W1xx1xx" "TARGET_ARCHITECTURE_STM32W1xx"
ttc_manage.pl replace "em357_basic" "stm32w_basic"
ttc_manage.pl replace "em357_gpio" "stm32w_gpio"
ttc_manage.pl replace "stm32_usart_init" "DRIVER_ttc_usart_init"
ttc_manage.pl replace "TARGET_ARCHITECTURE_STM32" "TARGET_ARCHITECTURE_STM32F1xx"
ttc_manage.pl replace "TARGET_ARCHITECTURE_STM32F1xxW1xx" "TARGET_ARCHITECTURE_STM32W1xx"
ttc_manage.pl replace "stm32_calc_peripheral_BitBandAddress" "cm3_calc_peripheral_BitBandAddress"
ttc_manage.pl replace "common/" "ttc-lib/"
ttc_manage.pl warn_deleted ToolChain/scripts/dfu_flash.sh
ttc_manage.pl replace "CommonLibraries" "TTC-Library"
ttc_manage.pl replace "crt_stm32w108.c" "startup_stm32w108.c"
ttc_manage.pl replace "crt_stm32w108" "startup_stm32w108"
ttc_manage.pl replace "Ember_AN710_Bringing_up_Custom_Devices_for_the_EM35x_SoC_Platform" "Ember_AN710_Bringing_up_Custom_Devices_for_the_EM35x_SoC_Platform.pdf"
ttc_manage.pl replace "Ember_AN703_Using_the_Simulated_EEPROM" "Ember_AN703_Using_the_Simulated_EEPROM.pdf"
ttc_manage.pl replace "Ember_AN698_PCB_Design_with_an_EM35x" "Ember_AN698_PCB_Design_with_an_EM35x.pdf"
ttc_manage.pl replace "Ember_AN713_Measuring_EM35x_Power_Consumption" "Ember_AN713_Measuring_EM35x_Power_Consumption.pdf"
ttc_manage.pl replace "Ember_AN715_Using_the_EM35x_ADC" "Ember_AN715_Using_the_EM35x_ADC.pdf"
ttc_manage.pl replace "ln -sv" "createLink"
ttc_manage.pl replace "ln -s" "createLink"
ttc_manage.pl replace "ttc_task_get_tick_count" "ttc_task_get_elapsed_usecs"
