#!/bin/bash
#
# The ToolChain v1.0.53
#
# Update script for changes introduced in v1.0.53 of The ToolChain.
#
# This script shall help you in porting your project to compile with a newer release of The ToolChain.
# Updatescripts must be run in order starting at first version released after your current project.
# In addtion to run this script, you should compile and check your project for every version update.
#
ttc_manage.pl replace "#warn " "#warning "
ttc_manage.pl replace "include "cm3_semaphore.h"" "include "cm3/cm3_semaphore.h""
ttc_manage.pl replace "example_interrupt.c" "example_ttc_interrupt.c"
ttc_manage.pl replace "example_interrupt.h" "example_ttc_interrupt.h"
ttc_manage.pl replace "500_ttc_watchdogs" "500_ttc_watchdog"
ttc_manage.pl replace "ToolChain/" "InstallData/"
ttc_manage.pl replace "em357" "stm32w"
ttc_manage.pl replace "ToolChain_STM32" "TheToolChain"
ttc_manage.pl replace "TheToolChain_devel/ToolChain" "TheToolChain_devel/TheToolChain"
ttc_manage.pl replace "ttc_memory_pool_alloc" "ttc_memory_pool_block_get"
ttc_manage.pl replace "ttc_memory_pool_release" "ttc_memory_pool_block_free"
ttc_manage.pl replace "pvParameters" "TaskArgument"
ttc_manage.pl replace "example_ttc_network_6lowpan.c" "example_ttc_network_driver_6lowpan.c"
ttc_manage.pl replace "example_ttc_network_6lowpan.h" "example_ttc_network_driver_6lowpan.h"
ttc_manage.pl warn_deleted TTC-Library/ttc_network_6lowpan_types.h
ttc_manage.pl replace "ttc_network_6lowpan.c" "ttc_network_driver_6lowpan.c"
ttc_manage.pl replace "ttc_network_6lowpan.h" "ttc_network_driver_6lowpan.h"
ttc_manage.pl replace "architecture_driver_types.h" "driver_architecture_types.h"
ttc_manage.pl replace "architecture_driver.h" "driver_architecture.h"
ttc_manage.pl replace "architecture_driver.c" "driver_architecture.c"
ttc_manage.pl replace "6lowpan_adapt_clock.c" "network_adapt_clock.c"
ttc_manage.pl replace "6lowpan_adapt_clock.h" "network_adapt_clock.h"
ttc_manage.pl replace "6lowpan_adapt_ctimer.c" "network_adapt_ctimer.c"
ttc_manage.pl replace "6lowpan_adapt_ctimer.h" "network_adapt_ctimer.h"
ttc_manage.pl replace "6lowpan_adapt_list.c" "network_adapt_list.c"
ttc_manage.pl replace "6lowpan_adapt_list.h" "network_adapt_list.h"
ttc_manage.pl replace "6lowpan_adapt_memb.c" "network_adapt_memb.c"
ttc_manage.pl replace "6lowpan_adapt_memb.h" "network_adapt_memb.h"
ttc_manage.pl replace "6lowpan_adapt_random.c" "network_adapt_random.c"
ttc_manage.pl replace "6lowpan_adapt_random.h" "network_adapt_random.h"
ttc_manage.pl replace "6lowpan_adapt_rtimer.c" "network_adapt_rtimer.c"
ttc_manage.pl replace "6lowpan_adapt_rtimer.h" "network_adapt_rtimer.h"
ttc_manage.pl replace "6lowpan_mac_csma.c" "mac_ieee802_15_4_csma.c"
ttc_manage.pl replace "6lowpan_mac_csma.h" "mac_ieee802_15_4_csma.h"
ttc_manage.pl replace "6lowpan_mac_frame802154.c" "mac_ieee802_15_4_frame802154.c"
ttc_manage.pl replace "6lowpan_mac_frame802154.h" "mac_ieee802_15_4_frame802154.h"
ttc_manage.pl replace "6lowpan_mac_framer.h" "mac_ieee802_15_4_framer.h"
ttc_manage.pl replace "6lowpan_mac_mac.c" "mac_ieee802_15_4.c"
ttc_manage.pl replace "6lowpan_mac_mac.h" "mac_ieee802_15_4.h"
ttc_manage.pl replace "6lowpan_mac_nullmac.c" "mac_ieee802_15_4_nullmac.c"
ttc_manage.pl replace "6lowpan_mac_nullmac.h" "mac_ieee802_15_4_nullmac.h"
ttc_manage.pl replace "6lowpan_mac_nullrdc.h" "mac_ieee802_15_4_nullrdc.c"
ttc_manage.pl replace "6lowpan_mac_nullrdc.c" "mac_ieee802_15_4_nullrdc.c"
ttc_manage.pl replace "6lowpan_mac_nullrdc.h" "mac_ieee802_15_4_nullrdc.h"
ttc_manage.pl replace "6lowpan_mac_rdc.c" "mac_ieee802_15_4_rdc.c"
ttc_manage.pl replace "6lowpan_mac_rdc.h" "mac_ieee802_15_4_rdc.h"
ttc_manage.pl replace "6lowpan_radio_nullradio.c" "network_nullradio.c"
ttc_manage.pl replace "6lowpan_radio_nullradio.h" "network_nullradio.h"
ttc_manage.pl replace "6lowpan_radio_serialradio.c" "network_serialradio.c"
ttc_manage.pl replace "6lowpan_radio_serialradio.h" "network_serialradio.h"
ttc_manage.pl replace "6lowpan_radio_radio.h" "network_radio.h"
ttc_manage.pl replace "6lowpan_rime_rimeaddr.c" "network_rimeaddr.c"
ttc_manage.pl replace "6lowpan_rime_rimeaddr.h" "network_rimeaddr.h"
ttc_manage.pl replace "6lowpan_net_packetbuf.c" "network_rime_packetbuf.c"
ttc_manage.pl replace "6lowpan_net_packetbuf.h" "network_rime_packetbuf.h"
ttc_manage.pl replace "6lowpan_rime_rime.c" "network_rime.c"
ttc_manage.pl replace "6lowpan_rime_rime.h" "network_rime.h"
ttc_manage.pl replace "6lowpan_mac_nullrdc-noframer.c" "mac_ieee802_15_4_nullrdc-noframer.c"
ttc_manage.pl replace "6lowpan_mac_nullrdc-noframer.h" "mac_ieee802_15_4_nullrdc-noframer.h"
ttc_manage.pl replace "6lowpan_conf.h" "network_conf.h"
ttc_manage.pl replace "6lowpan_net_netstack.h" "network_6lowpan_netstack.h"
ttc_manage.pl replace "6lowpan_net_queuebuf.h" "network_6lowpan_queuebuf.h"
ttc_manage.pl replace "EXTENSION_450_network_IEEE_802.15.4" "EXTENSION_450_network_IEEE_802_15_4"
ttc_manage.pl replace "network_6lowpan_queuebuf.h" "network_rime_queuebuf.h"
ttc_manage.pl replace "stm32f1_timer_logical_2_physical_index" "stm32f1_timer_logical_2_physical_address"
ttc_manage.pl replace "# installPackage libgmp3-dev" "# installPackageSafe which"
ttc_manage.pl replace "# installPackage libgmp3-dev" "# installPackageSafe 'which autoreconf' autoreconf"
ttc_manage.pl replace "_create_DriverSet.pl" "create_DriverSet.pl"
ttc_manage.pl replace "driver_installs" "installs_low_level"
ttc_manage.pl replace "driver_install" "installs_low_level"
ttc_manage.pl warn_deleted InstallData/DEPRECATED_install_XXX_Template.sh
ttc_manage.pl replace "example_timer.h" "example_ttc_timer.h"
ttc_manage.pl replace "example_timer.c" "example_ttc_timer.c"
ttc_manage.pl replace "example_timer_init" "example_ttc_timer_init"
ttc_manage.pl replace "example_timer_start" "example_ttc_timer_start"
ttc_manage.pl replace "<driver>" "<device>"
ttc_manage.pl replace "driver_architecture.c" "device_architecture.c"
ttc_manage.pl replace "driver_architecture.h" "device_architecture.h"
ttc_manage.pl replace "driver_architecture_types.h" "device_architecture_types.h"
ttc_manage.pl replace "_install_NN_TTC_DRIVER.sh" "_install_NN_TTC_DEVICE.sh"
ttc_manage.pl replace "_install_NN_TTC_DRIVER_ARCHITECTURE.sh" "_install_NN_TTC_DEVICE_ARCHITECTURE.sh"
ttc_manage.pl replace "ttc_driver.c" "ttc_device.c"
ttc_manage.pl replace "ttc_driver.h" "ttc_device.h"
ttc_manage.pl replace "ttc_driver_interface.c" "ttc_device_interface.c"
ttc_manage.pl replace "ttc_driver_interface.h" "ttc_device_interface.h"
ttc_manage.pl replace "ttc_driver_types.h" "ttc_device_types.h"
ttc_manage.pl replace "create_DriverSet.pl" "create_DeviceDriver.pl"
ttc_manage.pl replace "<architecture>_<device>" "<device>_<architecture>"
ttc_manage.pl replace "<DRIVER>" "<DEVICE>"
ttc_manage.pl replace "struct memb" "ttc_memory_t*"
ttc_manage.pl replace "definditions" "definitions"
ttc_manage.pl replace "InsertArchitectureIncludesAbove" "InsertArchitectureIncludes above"
ttc_manage.pl replace "stm32_gpio.h" "../gpio/gpio_stm32f1xx.h"
ttc_manage.pl replace "stm32_gpio.c" "DEPRECATED_stm32_gpio.c"
ttc_manage.pl replace "stm32_gpio.h" "DEPRECATED_stm32_gpio.h"
ttc_manage.pl replace "stm32_gpio.o" "gpio_stm32f1xx.o"
ttc_manage.pl replace "stm32_gpio_create_index8" "gpio_stm32_create_index8"
ttc_manage.pl replace "stm32_gpio_from_index8" "gpio_stm32_from_index8"
ttc_manage.pl replace "gpio_stm32_from_index8" "gpio_stm32f1xx_from_index8"
ttc_manage.pl replace "gpio_stm32_create_index8" "gpio_stm32f1xx_create_index8"
ttc_manage.pl replace "gpio_stm32f1xx_from_index8" "gpio_stm32f1xx_from_index"
ttc_manage.pl replace "stm32_gpio_e" "gpio_stm32f1xx_bank_e"
ttc_manage.pl replace "ttc_GPIO_BANK" "ttc_gpio_bank_t"
ttc_manage.pl replace "LCD_LI9320_DEPTH" "TTC_GFX1_LI9320_DEPTH"
ttc_manage.pl replace "LCD_LI9320_HEIGHT" "TTC_GFX1_LI9320_HEIGHT"
ttc_manage.pl replace "LCD_LI9320_WIDTH" "TTC_GFX1_LI9320_WIDTH"
ttc_manage.pl replace "TTC_GFX_ILI9320_PIN_" "TTC_GFX1_ILI9320_PIN_"
ttc_manage.pl replace "stm32_Port_t" "ttc_gpio_pin_e"
ttc_manage.pl replace "GPIO_BANK_A" "TTC_GPIO_BANK_A"
ttc_manage.pl replace "GPIO_BANK_B" "TTC_GPIO_BANK_B"
ttc_manage.pl replace "GPIO_BANK_C" "TTC_GPIO_BANK_C"
ttc_manage.pl replace "GPIO_BANK_D" "TTC_GPIO_BANK_D"
ttc_manage.pl replace "GPIO_BANK_E" "TTC_GPIO_BANK_E"
ttc_manage.pl replace "GPIO_BANK_F" "TTC_GPIO_BANK_F"
ttc_manage.pl replace "GPIO_BANK_G" "TTC_GPIO_BANK_G"
ttc_manage.pl replace "TTC_LCD_PIN_" "TTC_GFX1_ILI9320_PIN_"
ttc_manage.pl replace "GPIO_Speed_50MHz" "tgs_Max"
ttc_manage.pl replace "gdb_ttc_gpio_get_configuration" "ttc_gpio_get_configuration_gdb"
ttc_manage.pl replace "ttc_gpio_pin_" "tgp_"
ttc_manage.pl replace "tgp_e " "ttc_gpio_pin_e "
ttc_manage.pl replace "PortBit" "PortPin"
ttc_manage.pl replace "ttc_gpio_mode_e Type" "ttc_gpio_mode_e Mode"
ttc_manage.pl replace "ttc_usart_generic_t" "ttc_usart_config_t"
ttc_manage.pl replace "ttc_usart_Error_t" "ttc_usart_errorcode_e"
ttc_manage.pl replace "600_example_usart" "600_example_ttc_usart"
ttc_manage.pl replace "stm32f1_register_" "register_stm32f1xx_"
ttc_manage.pl replace "InsrtPrivatePrototypes" "InsertPrivatePrototypes"
ttc_manage.pl replace "example_device.c" "example_ttc_device.c"
ttc_manage.pl replace "example_device.h" "example_ttc_device.h"
ttc_manage.pl replace "DRIVER_" "_driver_"
ttc_manage.pl replace "stm32_registers.c" "DEPRECATED_stm32_registers.c"
ttc_manage.pl replace "stm32_registers.h" "DEPRECATED_stm32_registers.h"
ttc_manage.pl replace "_SIZE_K" "_SIZEK"
ttc_manage.pl replace "stm32w.ld" "memory_stm32w1xx.ld"
ttc_manage.pl replace "stm32.ld" "memory_stm32f1xx.ld"
ttc_manage.pl replace "sysclock_stm32w1xx_wait" "sysclock_stm32w1xx_udelay"
ttc_manage.pl replace "_sysclock_wait" "_sysclock_udelay"
ttc_manage.pl replace "stm32/stm32_registers.h" "register/register_stm32f1xx.h"
ttc_manage.pl replace "free_rtos" "freertos"
ttc_manage.pl replace "mSleep(" "ttc_task_msleep("
ttc_manage.pl replace "example_usart.c" "DEPRECATED_example_usart.c"
ttc_manage.pl replace "example_usart.o" "DEPRECATED_example_usart.o"
ttc_manage.pl replace "example_usart.h" "DEPRECATED_example_usart.h"
ttc_manage.pl replace "stm32w_registers.c" "DEPRECATED_stm32w_registers.c"
ttc_manage.pl replace "stm32w_registers.o" "DEPRECATED_stm32w_registers.o"
ttc_manage.pl replace "stm32w_registers.h" "DEPRECATED_stm32w_registers.h"
ttc_manage.pl replace "ttc_syclock" "ttc_sysclock"
ttc_manage.pl replace "TTC_AMOUNT_TIMERS" "TTC_INTERRUPT_TIMER_AMOUNT"
ttc_manage.pl replace "gpio_stm32w1xx_create_index" "interrupt_stm32w1xx_gpio_create_index"
ttc_manage.pl replace "stm32w_gpio.h" "DEPRECATED_stm32w_gpio.h"
ttc_manage.pl replace "stm32w_gpio.c" "DEPRECATED_stm32w_gpio.c"
ttc_manage.pl replace "stm32w_gpio.o" "DEPRECATED_stm32w_gpio.o"
ttc_manage.pl replace "stm32f10x_flash.cfg" "stm32f1x.cfg"
ttc_manage.pl replace "gpio_stm32f1xx_from_index" "interrupt_stm32f1xx_gpio_from_index"
ttc_manage.pl replace "stm32_registers.h" "../register/register_stm32f1xx.h"
ttc_manage.pl replace "tsp_MOSI" "ttc_spi_MOSI"
ttc_manage.pl replace "ttc_memory_alloc" "ttc_heap_alloc"
ttc_manage.pl replace "_memory_alloc" "_heap_alloc"
ttc_manage.pl replace "ttc_memory_heap" "ttc_heap"
ttc_manage.pl replace "ttc_array" "ttc_heap_array"
ttc_manage.pl replace "TTC_SAFE_ARRAYS" "TTC_HEAP_SAFE_ARRAYS"
ttc_manage.pl replace "cm3/cm3_registers.h" "register/register_cm3.h"
ttc_manage.pl replace "cm3_registers.o" "register_cm3.o"
ttc_manage.pl replace "cm3_registers.h" "register_cm3.h"
ttc_manage.pl replace "register_cm3.h" "register_cortexm3.h"
ttc_manage.pl replace "register_cm3.o" "register_cortexm3.o"
ttc_manage.pl replace "register_stm32w1xx_SC1_CFG" "register_stm32w1xx_INT_SC1CFG"
ttc_manage.pl replace "register_stm32w1xx_SC2_CFG" "register_stm32w1xx_INT_SC2CFG"
ttc_manage.pl replace "register_stm32w1xx_SC1_FLAG" "register_stm32w1xx_INT_SC1FLAG"
ttc_manage.pl replace "register_stm32w1xx_SC2_FLAG" "register_stm32w1xx_INT_SC2FLAG"
ttc_manage.pl replace "tt_SchedulerRunning" "ttc_task_SchedulerIsRunning"
ttc_manage.pl replace "ttc_task_CriticalSection_LockedBy" "ttc_task_CriticalSection_LastCaller"
ttc_manage.pl replace "ttc_task_begin_criticalsection_owner" "_ttc_task_begin_criticalsection"
ttc_manage.pl replace "ttc_queue_create" "ttc_queue_generic_create"
ttc_manage.pl replace "ttc_queue_push_back" "ttc_queue_generic_push_back"
ttc_manage.pl replace "ttc_queue_pop_front" "ttc_queue_generic_pull_front"
ttc_manage.pl replace "ttc_QueueHandle" "ttc_queue_generic_t"
ttc_manage.pl replace "interrupt_stm32f1xx_all_enable" "basic_cm3_interrupt_all_enable"
ttc_manage.pl replace "interrupt_stm32f1xx_all_disable" "basic_cm3_interrupt_all_disable"
ttc_manage.pl warn_deleted TTC-Library/ttc_switches.h
ttc_manage.pl warn_deleted TTC-Library/ttc_switches.c
ttc_manage.pl warn_deleted TTC-Library/gfx/gfx_image.c
ttc_manage.pl replace "420_" "170_"
ttc_manage.pl replace "ttc_h224ap" "ttc_heap"
ttc_manage.pl replace "timer_logical_2_physical_address" "timer_physical_index_2_address"
ttc_manage.pl replace "stm32_timer.c" "DEPRECATED_stm32_timer.c"
ttc_manage.pl replace "stm32_timer.h" "DEPRECATED_stm32_timer.h"
ttc_manage.pl replace "stm32f1_timer.h" "DEPRECATED_stm32f1_timer.h"
ttc_manage.pl replace "stm32f1_timer.c" "DEPRECATED_stm32f1_timer.c"
ttc_manage.pl replace "usb_stm32f1" "usb_stm32f1xx"
ttc_manage.pl replace "Config_ISRs->Common.PhysicalIndex" "Config_ISRs->PhysicalIndex"
ttc_manage.pl replace "GPIO_INT_FLAG" "INT_GPIOFLAG"
ttc_manage.pl replace "Assert_REGISTER_SAME" "Assert_SAME_ADDRESS"
ttc_manage.pl replace "Assert_SAME_ADDRESS" "Assert_SameAddress"
ttc_manage.pl replace "INSTALLPATH" "Install_Dir"
ttc_manage.pl replace "InstallDir" "Install_Path"
ttc_manage.pl replace "ttc_radio.c" "DEPRECATED_ttc_radio.c"
ttc_manage.pl replace "ttc_radio.o" "DEPRECATED_ttc_radio.o"
ttc_manage.pl replace "ttc_radio.h" "DEPRECATED_ttc_radio.h"
ttc_manage.pl replace "ttc_memory_from_pool_t" "ttc_heap_block_from_pool_t"
ttc_manage.pl replace "cm3_hard_fault_handler_c" "interrupt_cortexm3_HardFault_Handler"
ttc_manage.pl replace "TTC_RADIO_PACKET_POOL_SIZE" "TTC_RADIO_MAX_AMOUNT_PACKETS"
ttc_manage.pl replace "TTC_RADIO_PACKET_MAX_SIZE" "TTC_RADIO_MAX_PACKET_SIZE"
ttc_manage.pl replace "parseReceivedPacket" "functionReceivedPacket"
ttc_manage.pl replace "ttc_radio_initalize_packet" "ttc_radio_packet_initialize"
ttc_manage.pl replace "cm3/cm3_basic.h" "basic/basic_cm3.h"
ttc_manage.pl replace "500_ttc_basic" "000_ttc_basic"
ttc_manage.pl replace "000_ttc_basic" "500_ttc_basic"
ttc_manage.pl replace "basic_cm3_interrupt_all" "interrupt_cortexm3_all"
ttc_manage.pl replace "cm3_atomic_" "basic_cm3_atomic_"
ttc_manage.pl replace "basic_basic_cm3" "basic_cm3"
ttc_manage.pl replace "example_radio.c" "DEPRECATED_example_radio.c"
ttc_manage.pl replace "ttc_list_pop_front_single" "ttc_list_wait_pop_front_single"
ttc_manage.pl replace "RT_SCHEDULER" "TTC_MULTITASKING_SCHEDULER"
ttc_manage.pl replace "ttc_mutex_trylock" "ttc_mutex_lock_try"
ttc_manage.pl replace "mutex_trylock" "mutex_lock_try"
ttc_manage.pl replace "semaphore_try_take" "semaphore_take_try"
ttc_manage.pl replace "pointer_try_push_back" "pointer_push_back_try"
ttc_manage.pl replace "try_push_back" "push_back_try"
ttc_manage.pl replace "try_pull_front" "pull_front_try"
ttc_manage.pl replace "try_pop_front_single" "pop_front_single_try"
ttc_manage.pl replace "try_take" "take_try"
ttc_manage.pl replace "ttc_radio_get_payload_size" "ttc_radio_get_payload_size_max"
ttc_manage.pl replace "wsn3_stm32w108" "wsn3_etrx357"
ttc_manage.pl replace "ttc_channel.c" "DEPRECATED_ttc_channel.c"
ttc_manage.pl replace "ttc_channel.o" "DEPRECATED_ttc_channel.o"
ttc_manage.pl replace "dependant" "dependent"
ttc_manage.pl replace "sysclock_update_register" "sysclock_register_for_update"
ttc_manage.pl replace "interrupt_driver_config_usart_tx_isr" "_driver_usart_tx_isr"
ttc_manage.pl replace "ttc_heap_array_define" "ttc_heap_array_static"
ttc_manage.pl replace "ttc_heap_array_static" "ttc_heap_array_define"
ttc_manage.pl replace "ttc_heap_array_" "A_"
ttc_manage.pl replace "ttc_input.c" "DEPRECATED_ttc_input.c"
ttc_manage.pl replace "ttc_input.h" "DEPRECATED_ttc_input.h"
ttc_manage.pl replace "input_ads7843.c" "DEPRECATED_input_ads7843.c"
ttc_manage.pl replace "input_ads7843.o" "DEPRECATED_input_ads7843.o"
ttc_manage.pl replace "example_gui.o" "DEPRECATED_example_gui.o"
ttc_manage.pl replace "touchpad_analog" "touchpad_analog4"
ttc_manage.pl replace "ttc_input_types.h" "DEPRECATED_ttc_input_types.h"
ttc_manage.pl replace "input_analog.h" "DEPRECATED_input_analog.h"
ttc_manage.pl replace "input_analog.o" "DEPRECATED_input_analog.o"
ttc_manage.pl replace "example_input.h" "DEPRECATED_example_input.h"
ttc_manage.pl replace "ttc_adc_find_configuration" "ttc_adc_find_configuration_by_pin"
ttc_manage.pl replace "ttc_adc_get_configuration" "ttc_adc_find_configuration_by_index"
ttc_manage.pl replace "ttc_adc_find_configuration_by_index" "ttc_adc_get_configuration"
ttc_manage.pl replace "TTC_ADC_AMOUNT" "TTC_ADC_AMOUNT_STATIC"
ttc_manage.pl replace "ta_cpi_stm32" "ta_cpu_stm32"
ttc_manage.pl replace "TTC_CPU_TYPE" "TTC_CPU_VARIANT"
ttc_manage.pl replace "TTC_SYSCLOCK_FREQUENCY_MAX" "TTC_CPU_MAX_FREQUENCY"
ttc_manage.pl replace "STM32F10X_CL" "TTC_CPU_STM32F1_CL"
ttc_manage.pl replace "STM32F10X_LD" "TTC_CPU_STM32F1_LD"
ttc_manage.pl replace "STM32F10X_MD" "TTC_CPU_STM32F1_MD"
ttc_manage.pl replace "STM32F10X_HD" "TTC_CPU_STM32F1_HD"
ttc_manage.pl replace "TTC_CPU_STM32F1_HD" "STM32F10X_HD"
ttc_manage.pl replace "TTC_CPU_STM32F1_MD" "STM32F10X_MD"
ttc_manage.pl replace "TTC_CPU_STM32F1_LD" "STM32F10X_LD"
ttc_manage.pl replace "TTC_CPU_STM32F1_CL" "STM32F10X_CL"
ttc_manage.pl warn_deleted TTC-Library/i2c/i2c_stm32l1_types.h
ttc_manage.pl replace "IndiceI2C" "LogicalIndex_I2C"
ttc_manage.pl replace "LogicalIndex_I2C" "LogicalIndex_Interface"
ttc_manage.pl replace "=TTC_INDEX_SPI" "ttc_device_"
ttc_manage.pl replace "=TTC_INDEX_ADC" "ttc_device_"
ttc_manage.pl replace "=TTC_INDEX_DAC" "ttc_device_"
ttc_manage.pl replace "=TTC_INDEX_DMA" "ttc_device_"
ttc_manage.pl replace "=TTC_INDEX_ACCELEROMETER" "ttc_device_"
ttc_manage.pl replace "=TTC_INDEX_ETHERNET" "ttc_device_"
ttc_manage.pl replace "=TTC_INDEX_RADIO" "ttc_device_"
ttc_manage.pl replace "=TTC_INDEX_INTERFACE" "ttc_device_"
ttc_manage.pl replace "=TTC_INDEX_GYROSCOPE" "ttc_device_"
ttc_manage.pl replace "=TTC_INDEX_PWR" "ttc_device_"
ttc_manage.pl replace "=TTC_INDEX_LAYER_PHY" "ttc_device_"
ttc_manage.pl replace "pin_AF_config" "alternate_function"
ttc_manage.pl replace "AFMapping" "AlternateFunction"
ttc_manage.pl replace "Rebel" "Rebel (RiP)"
ttc_manage.pl replace "Rebel \(RiP\)" "Rebel"
ttc_manage.pl replace "//} Function definitions" "//}FunctionDefinitions"
ttc_manage.pl replace "//}private functions" "//}PrivateFunctions"
ttc_manage.pl replace "SmallBase_t" "base_small_t"
ttc_manage.pl replace "SmallBaseSigned_t" "base_small_signed_t"
ttc_manage.pl replace "I2C_CR1_t" "register_stm32l1xx_i2c_cr1_t"
ttc_manage.pl replace "stm32l1_GPIOx_MODER_t" "register_stm32l1xx_gpiox_moder_t"
ttc_manage.pl replace "stm32l1_GPIOx_OTYPER_t" "register_stm32l1xx_gpiox_otyper_t"
ttc_manage.pl replace "stm32l1_GPIOx_OSPEEDR_t" "register_stm32l1xx_gpiox_ospeedr_t"
ttc_manage.pl replace "stm32l1_GPIOx_PUPDR_t" "register_stm32l1xx_gpiox_pupdr_t"
ttc_manage.pl replace "stm32l1_GPIOx_IDR_t" "register_stm32l1xx_gpiox_idr_t"
ttc_manage.pl replace "stm32l1_GPIOx_ODR_t" "register_stm32l1xx_gpiox_odr_t"
ttc_manage.pl replace "stm32l1_GPIOx_BSRR_t" "register_stm32l1xx_gpiox_bsrr_t"
ttc_manage.pl replace "stm32l1_GPIOx_LCKR_t" "register_stm32l1xx_gpiox_lckr_t"
ttc_manage.pl replace "stm32l1_GPIOx_AFRL_t" "register_stm32l1xx_gpiox_afrl_t"
ttc_manage.pl replace "stm32l1_GPIOx_AFRH_t" "register_stm32l1xx_gpiox_afrh_t"
ttc_manage.pl replace "stm32l1xx_USART_SR_t" "register_stm32l1xx_usart_sr_t"
ttc_manage.pl replace "stm32l1xx_USART_DR_t" "register_stm32l1xx_usart_dr_t"
ttc_manage.pl replace "stm32l1xx_USART_BRR_t" "register_stm32l1xx_usart_brr_t"
ttc_manage.pl replace "stm32l1xx_USART_CR1_t" "register_stm32l1xx_usart_cr1_t"
ttc_manage.pl replace "stm32l1xx_USART_CR2_t" "register_stm32l1xx_usart_cr2_t"
ttc_manage.pl replace "stm32l1xx_USART_CR3_t" "register_stm32l1xx_usart_cr3_t"
ttc_manage.pl replace "stm32l1xx_USART_GTPR_t" "register_stm32l1xx_usart_gtpr_t"
ttc_manage.pl replace "I2C_CR2_t" "register_stm32l1xx_i2c_cr2_t"
ttc_manage.pl replace "I2C_OAR1_t" "register_stm32l1xx_i2c_oar1_t"
ttc_manage.pl replace "I2C_OAR2_t" "register_stm32l1xx_i2c_oar2_t"
ttc_manage.pl replace "I2C_DR_t" "register_stm32l1xx_i2c_dr_t"
ttc_manage.pl replace "I2C_SR1_t" "register_stm32l1xx_i2c_sr1_t"
ttc_manage.pl replace "I2C_SR2_t" "register_stm32l1xx_i2c_sr2_t"
ttc_manage.pl replace "I2C_CCR_t" "register_stm32l1xx_i2c_ccr_t"
ttc_manage.pl replace "I2C_TRISE_t" "register_stm32l1xx_i2c_trise_t"
ttc_manage.pl replace "EXTI_IMR_t" "register_stm32l1xx_exti_imr_t"
ttc_manage.pl replace "EXTI_EMR_t" "register_stm32l1xx_exti_emr_t"
ttc_manage.pl replace "EXTI_RTSR_t" "register_stm32l1xx_exti_rtsr_t"
ttc_manage.pl replace "EXTI_FTSR_t" "register_stm32l1xx_exti_ftsr_t"
ttc_manage.pl replace "EXTI_SWIER_t" "register_stm32l1xx_exti_swier_t"
ttc_manage.pl replace "EXTI_PR_t" "register_stm32l1xx_exti_pr_t"
ttc_manage.pl replace "RCC_CR_t" "register_stm32l1xx_rcc_cr_t"
ttc_manage.pl replace "RCC_ICSCR_t" "register_stm32l1xx_rcc_icscr_t"
ttc_manage.pl replace "RCC_CFGR_t" "register_stm32l1xx_rcc_cfgr_t"
ttc_manage.pl replace "RCC_CIR_t" "register_stm32l1xx_rcc_cir_t"
ttc_manage.pl replace "RCC_APB2RSTR_t" "register_stm32l1xx_rcc_apb2rstr_t"
ttc_manage.pl replace "RCC_APB1RSTR_t" "register_stm32l1xx_rcc_apb1rstr_t"
ttc_manage.pl replace "RCC_AHBLPENR_t" "register_stm32l1xx_rcc_ahblpenr_t"
ttc_manage.pl replace "RCC_CSR_t" "register_stm32l1xx_rcc_csr_t"
ttc_manage.pl replace "RCC_AHBRSTR_t" "register_stm32l1xx_rcc_ahbrstr_t"
ttc_manage.pl replace "RCC_AHBENR_t" "register_stm32l1xx_rcc_ahbenr_t"
ttc_manage.pl replace "RCC_APB2ENR_t" "register_stm32l1xx_rcc_apb2enr_t"
ttc_manage.pl replace "RCC_APB1ENR_t" "register_stm32l1xx_rcc_apb1enr_t"
ttc_manage.pl replace "RCC_APB2LPENR_t" "register_stm32l1xx_rcc_apb2lpenr_t"
ttc_manage.pl replace "RCC_APB1LPENR_t" "register_stm32l1xx_rcc_apb1lpenr_t"
ttc_manage.pl replace "RTC_TR_t" "register_stm32l1xx_rtc_tr_t"
ttc_manage.pl replace "RTC_DR_t" "register_stm32l1xx_rtc_dr_t"
ttc_manage.pl replace "RTC_CR_t" "register_stm32l1xx_rtc_cr_t"
ttc_manage.pl replace "RTC_ISR_t" "register_stm32l1xx_rtc_isr_t"
ttc_manage.pl replace "RTC_PRER_t" "register_stm32l1xx_rtc_prer_t"
ttc_manage.pl replace "RTC_WUTR_t" "register_stm32l1xx_rtc_wutr_t"
ttc_manage.pl replace "RTC_CALIBR_t" "register_stm32l1xx_rtc_calibr_t"
ttc_manage.pl replace "RTC_ALRMAR_t" "register_stm32l1xx_rtc_alrmar_t"
ttc_manage.pl replace "RTC_ALRMBR_t" "register_stm32l1xx_rtc_alrmbr_t"
ttc_manage.pl replace "RTC_WPR_t" "register_stm32l1xx_rtc_wpr_t"
ttc_manage.pl replace "RTC_SSR_t" "register_stm32l1xx_rtc_ssr_t"
ttc_manage.pl replace "RTC_SHIFTR_t" "register_stm32l1xx_rtc_shiftr_t"
ttc_manage.pl replace "RTC_TSTR_t" "register_stm32l1xx_rtc_tstr_t"
ttc_manage.pl replace "RTC_TSDR_t" "register_stm32l1xx_rtc_tsdr_t"
ttc_manage.pl replace "RTC_TSSSR_T" "register_stm32l1xx_rtc_tsssr_t"
ttc_manage.pl replace "RTC_CALR_t" "register_stm32l1xx_rtc_calr_t"
ttc_manage.pl replace "RTC_TAFCR_t" "register_stm32l1xx_rtc_tafcr_t"
ttc_manage.pl replace "RTC_ALRMASSR_t" "register_stm32l1xx_rtc_alrmassr_t"
ttc_manage.pl replace "RTC_ALRMBSSR_t" "register_stm32l1xx_rtc_alrmbssr_t"
ttc_manage.pl replace "RTC_BKPOR_t" "register_stm32l1xx_rtc_bkpor_t"
ttc_manage.pl replace "PWR_CR_t" "register_stm32l1xx_pwr_cr_t"
ttc_manage.pl replace "PWR_SCR_t" "register_stm32l1xx_pwr_scr_t"
ttc_manage.pl replace "DMA_ISR_t" "register_stm32l1xx_dma_isr_t"
ttc_manage.pl replace "DMA_IFCR_t" "register_stm32l1xx_dma_ifcr_t"
ttc_manage.pl replace "DMA_CCR1_t" "register_stm32l1xx_dma_ccr1_t"
ttc_manage.pl replace "DMA_CNDTR1_t" "register_stm32l1xx_dma_cndtr1_t"
ttc_manage.pl replace "DMA_CPAR1_t" "register_stm32l1xx_dma_cpar1_t"
ttc_manage.pl replace "DMA_CMAR1_t" "register_stm32l1xx_dma_cmar1_t"
ttc_manage.pl replace "TIMx_CR1_t" "register_stm32l1xx_timx_cr1_t"
ttc_manage.pl replace "TIMx_CR2_t" "register_stm32l1xx_timx_cr2_t"
ttc_manage.pl replace "TIMx_SMCR_t" "register_stm32l1xx_timx_smcr_t"
ttc_manage.pl replace "TIMx_DIER_t" "register_stm32l1xx_timx_dier_t"
ttc_manage.pl replace "TIMx_SR_t" "register_stm32l1xx_timx_sr_t"
ttc_manage.pl replace "TIMx_EGR_t" "register_stm32l1xx_timx_egr_t"
ttc_manage.pl replace "TIMx_CCMR1_compare_mode_t" "register_stm32l1xx_timx_ccmr1_compare_mode_t"
ttc_manage.pl replace "TIMx_CCMR2_compare_mode_t" "register_stm32l1xx_timx_ccmr2_compare_mode_t"
ttc_manage.pl replace "TIMx_CCER_t" "register_stm32l1xx_timx_ccer_t"
ttc_manage.pl replace "TIMx_CNT_t" "register_stm32l1xx_timx_cnt_t"
ttc_manage.pl replace "TIMx_PSC_t" "register_stm32l1xx_timx_psc_t"
ttc_manage.pl replace "TIMx_ARR_t" "register_stm32l1xx_timx_arr_t"
ttc_manage.pl replace "TIMx_CCR1_t" "register_stm32l1xx_timx_ccr1_t"
ttc_manage.pl replace "TIMx_CCR2_t" "register_stm32l1xx_timx_ccr2_t"
ttc_manage.pl replace "TIMx_CCR3_t" "register_stm32l1xx_timx_ccr3_t"
ttc_manage.pl replace "TIMx_CCR4_t" "register_stm32l1xx_timx_ccr4_t"
ttc_manage.pl replace "TIMx_DCR_t" "register_stm32l1xx_timx_dcr_t"
ttc_manage.pl replace "TIMx_DMAR_t" "register_stm32l1xx_timx_dmar_t"
ttc_manage.pl replace "TIM10_to_TIM11_CR1_t" "register_stm32l1xx_tim10_to_tim11_cr1_t"
ttc_manage.pl replace "TIM10_to_TIM11_SMCR_t" "register_stm32l1xx_tim10_to_tim11_smcr_t"
ttc_manage.pl replace "TIM10_to_TIM11_DIER_t" "register_stm32l1xx_tim10_to_tim11_dier_t"
ttc_manage.pl replace "TIM10_to_TIM11_SR_t" "register_stm32l1xx_tim10_to_tim11_sr_t"
ttc_manage.pl replace "TIM10_to_TIM11_EGR_t" "register_stm32l1xx_tim10_to_tim11_egr_t"
ttc_manage.pl replace "TIM10_to_TIM11_CCMR1_input_capture_mode_t" "register_stm32l1xx_tim10_to_tim11_ccmr1_input_capture_mode_t"
ttc_manage.pl replace "TIM10_to_TIM11_CCER_t" "register_stm32l1xx_tim10_to_tim11_ccer_t"
ttc_manage.pl replace "TIM10_to_TIM11_CNT_t" "register_stm32l1xx_tim10_to_tim11_cnt_t"
ttc_manage.pl replace "TIM10_to_TIM11_PSC_t" "register_stm32l1xx_tim10_to_tim11_psc_t"
ttc_manage.pl replace "TIM10_to_TIM11_ARR_t" "register_stm32l1xx_tim10_to_tim11_arr_t"
ttc_manage.pl replace "TIM10_to_TIM11_CCR1_t" "register_stm32l1xx_tim10_to_tim11_ccr1_t"
ttc_manage.pl replace "TIM10_to_TIM11_OR_t" "register_stm32l1xx_tim10_to_tim11_or_t"
ttc_manage.pl replace "DAC_CR_t" "register_stm32l1xx_dac_cr_t"
ttc_manage.pl replace "DAC_SWTRIGR_t" "register_stm32l1xx_dac_swtrigr_t"
ttc_manage.pl replace "DAC_DHR12R1_t" "register_stm32l1xx_dac_dhr12r1_t"
ttc_manage.pl replace "DAC_DHR12L1_t" "register_stm32l1xx_dac_dhr12l1_t"
ttc_manage.pl replace "DAC_DHR8R1_t" "register_stm32l1xx_dac_dhr8r1_t"
ttc_manage.pl replace "DAC_DHR12R2_t" "register_stm32l1xx_dac_dhr12r2_t"
ttc_manage.pl replace "DAC_DHR12L2_t" "register_stm32l1xx_dac_dhr12l2_t"
ttc_manage.pl replace "DAC_DHR8R2_t" "register_stm32l1xx_dac_dhr8r2_t"
ttc_manage.pl replace "DAC_DHR12RD_t" "register_stm32l1xx_dac_dhr12rd_t"
ttc_manage.pl replace "DAC_DHR12LD_t" "register_stm32l1xx_dac_dhr12ld_t"
ttc_manage.pl replace "DAC_DHR8RD_t" "register_stm32l1xx_dac_dhr8rd_t"
ttc_manage.pl replace "DAC_DOR1_t" "register_stm32l1xx_dac_dor1_t"
ttc_manage.pl replace "DAC_DOR2_t" "register_stm32l1xx_dac_dor2_t"
ttc_manage.pl replace "DAC_SR_t" "register_stm32l1xx_dac_sr_t"
ttc_manage.pl replace "SPI_CR1_t" "register_stm32l1xx_spi_cr1_t"
ttc_manage.pl replace "SPI_CR2_t" "register_stm32l1xx_spi_cr2_t"
ttc_manage.pl replace "SPI_SR_t" "register_stm32l1xx_spi_sr_t"
ttc_manage.pl replace "SPI_DR_t" "register_stm32l1xx_spi_dr_t"
ttc_manage.pl replace "SPI_CRC_t" "register_stm32l1xx_spi_crc_t"
ttc_manage.pl replace "SPI_RX_CRC_t" "register_stm32l1xx_spi_rx_crc_t"
ttc_manage.pl replace "SPI_TX_CRC_t" "register_stm32l1xx_spi_tx_crc_t"
ttc_manage.pl replace "SPI_I2SCFGR_t" "register_stm32l1xx_spi_i2scfgr_t"
ttc_manage.pl replace "SPI_I2SPR_t" "register_stm32l1xx_spi_i2spr_t"
ttc_manage.pl replace "ADC_SR_t" "register_stm32l1xx_adc_sr_t"
ttc_manage.pl replace "ADC_CR1_t" "register_stm32l1xx_adc_cr1_t"
ttc_manage.pl replace "ADC_CR2_t" "register_stm32l1xx_adc_cr2_t"
ttc_manage.pl replace "ADC_SMPR1_t" "register_stm32l1xx_adc_smpr1_t"
ttc_manage.pl replace "ADC_SMPR2_t" "register_stm32l1xx_adc_smpr2_t"
ttc_manage.pl replace "ADC_SMPR3_t" "register_stm32l1xx_adc_smpr3_t"
ttc_manage.pl replace "ADC_JOFR1_t" "register_stm32l1xx_adc_jofr1_t"
ttc_manage.pl replace "ADC_JOFR2_t" "register_stm32l1xx_adc_jofr2_t"
ttc_manage.pl replace "ADC_JOFR3_t" "register_stm32l1xx_adc_jofr3_t"
ttc_manage.pl replace "ADC_JOFR4_t" "register_stm32l1xx_adc_jofr4_t"
ttc_manage.pl replace "ADC_HTR_t" "register_stm32l1xx_adc_htr_t"
ttc_manage.pl replace "ADC_LTR_t" "register_stm32l1xx_adc_ltr_t"
ttc_manage.pl replace "ADC_SQR1_t" "register_stm32l1xx_adc_sqr1_t"
ttc_manage.pl replace "ADC_SQR2_t" "register_stm32l1xx_adc_sqr2_t"
ttc_manage.pl replace "ADC_SQR3_t" "register_stm32l1xx_adc_sqr3_t"
ttc_manage.pl replace "ADC_SQR4_t" "register_stm32l1xx_adc_sqr4_t"
ttc_manage.pl replace "ADC_SQR5_t" "register_stm32l1xx_adc_sqr5_t"
ttc_manage.pl replace "ADC_JSQR_t" "register_stm32l1xx_adc_jsqr_t"
ttc_manage.pl replace "ADC_JDR1_t" "register_stm32l1xx_adc_jdr1_t"
ttc_manage.pl replace "ADC_JDR2_t" "register_stm32l1xx_adc_jdr2_t"
ttc_manage.pl replace "ADC_JDR3_t" "register_stm32l1xx_adc_jdr3_t"
ttc_manage.pl replace "ADC_JDR4_t" "register_stm32l1xx_adc_jdr4_t"
ttc_manage.pl replace "ADC_DR_t" "register_stm32l1xx_adc_dr_t"
ttc_manage.pl replace "ADC_SMPR0_t" "register_stm32l1xx_adc_smpr0_t"
ttc_manage.pl replace "1ttc_device_1" "1=ttc_device_1"
ttc_manage.pl replace "2ttc_device_2" "2=ttc_device_2"
ttc_manage.pl replace "//InsertFunctions" "//InsertFunctionDefinitions"
ttc_manage.pl replace "ttc_i2c_master_send_address" "ttc_i2c_master_send_slave_address"
ttc_manage.pl replace "master_send_address" "master_send_slave_address"
ttc_manage.pl replace "ttc_i2c_write_register" "ttc_i2c_master_write_register"
ttc_manage.pl replace "ttc_i2c_read_register" "ttc_i2c_master_read_register"
ttc_manage.pl replace "ta_accelerometer_mpu6050" "ta_accelerometer_mpu6050_i2c"
ttc_manage.pl replace "_master_write_bytes" "_master_send_bytes"
ttc_manage.pl replace "_slave_write_bytes" "_slave_send_bytes"
ttc_manage.pl replace "Adress_10Bit" "Address_10Bit"
ttc_manage.pl replace "tifc_smbalert" "tifc_smbus_alert_occured"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_SMBALERT" "TTC_I2C_FLAG_CODE_SMBUS_ALERT_OCCURED"
ttc_manage.pl replace "tifc_timeout" "tifc_smbus_timeout"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_TIMEOUT" "TTC_I2C_FLAG_CODE_SMBUS_TIMEOUT"
ttc_manage.pl replace "tifc_pecerr" "tifc_crc_error"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_PECERR" "TTC_I2C_FLAG_CODE_CRC_ERROR"
ttc_manage.pl replace "tifc_ovr" "tifc_buffer_overrun"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_OVR" "TTC_I2C_FLAG_CODE_BUFFER_OVERRUN"
ttc_manage.pl replace "tifc_af" "tifc_acknowledge_failure"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_AF" "TTC_I2C_FLAG_CODE_ACKNOWLEDGE_FAILURE"
ttc_manage.pl replace "tifc_arlo" "tifc_arbitration_lost"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_ARLO" "TTC_I2C_FLAG_CODE_ARBITRATION_LOST"
ttc_manage.pl replace "tifc_berr" "tifc_bus_error"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_BERR" "TTC_I2C_FLAG_CODE_BUS_ERROR"
ttc_manage.pl replace "tifc_txe" "tifc_transmit_buffer_empty"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_TXE" "TTC_I2C_FLAG_CODE_TRANSMIT_BUFFER_EMPTY"
ttc_manage.pl replace "tifc_rxne" "tifc_receive_buffer_not_empty"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_RXNE" "TTC_I2C_FLAG_CODE_RECEIVE_BUFFER_NOT_EMPTY"
ttc_manage.pl replace "tifc_stopf" "tifc_stop_detected"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_STOPF" "TTC_I2C_FLAG_CODE_STOP_DETECTED"
ttc_manage.pl replace "tifc_add10" "tifc_10_bit_address"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_ADD10" "TTC_I2C_FLAG_CODE_10_BIT_ADDRESS"
ttc_manage.pl replace "tifc_btf" "tifc_byte_transfer_finished"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_BTF" "TTC_I2C_FLAG_CODE_BYTE_TRANSFER_FINISHED"
ttc_manage.pl replace "tifc_addr" "tifc_address_sent"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_ADDR" "TTC_I2C_FLAG_CODE_ADDRESS_SENT"
ttc_manage.pl replace "tifc_sb" "tifc_start_bit_detected"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_SB" "TTC_I2C_FLAG_CODE_START_BIT_DETECTED"
ttc_manage.pl replace "tifc_dualf" "tifc_ownaddress1_matched"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_DUALF" "TTC_I2C_FLAG_CODE_OWNADDRESS1_MATCHED"
ttc_manage.pl replace "tifc_smbhost" "tifc_smbus_host_header_received"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_SMBHOST" "TTC_I2C_FLAG_CODE_SMBUS_HOST_HEADER_RECEIVED"
ttc_manage.pl replace "tifc_smbdefault" "tifc_smbus_default_address_received"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_SMBDEFAULT" "TTC_I2C_FLAG_CODE_SMBUS_DEFAULT_ADDRESS_RECEIVED"
ttc_manage.pl replace "tifc_gencall" "tifc_smbus_general_call_address_received"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_GENCALL" "TTC_I2C_FLAG_CODE_SMBUS_GENERAL_CALL_ADDRESS_RECEIVED"
ttc_manage.pl replace "tifc_tra" "tifc_read_mode_detected"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_TRA" "TTC_I2C_FLAG_CODE_READ_MODE_DETECTED"
ttc_manage.pl replace "tifc_busy" "tifc_bus_busy"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_BUSY" "TTC_I2C_FLAG_CODE_BUS_BUSY"
ttc_manage.pl replace "tifc_msl" "tifc_master_mode"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_MS" "TTC_I2C_FLAG_CODE_MASTER_MODE"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_SMBUS_ALERT_OCCURED" "TTC_I2C_FLAG_CODE_SMBUS_ALERT"
ttc_manage.pl replace "tifc_smbus_alert_occured" "tifc_smbus_alert"
ttc_manage.pl replace "READ_MODE_DETECTEDNSMIT_BUFFER_EMPTY" "TRANSMIT_BUFFER_EMPTY"
ttc_manage.pl replace "tifc_read_mode_detectednsmit_buffer_empty" "tifc_transmit_buffer_empty"
ttc_manage.pl replace "TTC_I2C_FLAG_CODE_MASTER_MODEL" "TTC_I2C_FLAG_CODE_MASTER_MODE"
ttc_manage.pl replace "i2c_common_wait_for_event_" "i2c_common_wait_until_event"
ttc_manage.pl replace "i2c_common_wait_for_events_" "i2c_common_wait_until_events"
ttc_manage.pl replace "slave_detected_read_mode" "slave_check_read_mode"
ttc_manage.pl replace "hclk_frequency" "frequency_hclk"
ttc_manage.pl replace "pclk1_frequency" "frequency_pclk1"
ttc_manage.pl replace "pclk2_frequency" "frequency_pclk2"
ttc_manage.pl replace "rtc_frequency" "frequency_rtc"
ttc_manage.pl replace "systick_frequency" "frequency_systick"
ttc_manage.pl replace "Frequency_SysTick" "frequency_systick"
ttc_manage.pl replace "Frequency_APB2" "frequency_pclk2"
ttc_manage.pl replace "Frequency_APB1" "frequency_pclk1"
ttc_manage.pl replace "Frequency_AHB" "frequency_hclk"
ttc_manage.pl replace "Frequency_ADC" "frequency_adc"
ttc_manage.pl replace "Divider_ADC" "divider_adc"
ttc_manage.pl replace "Divider_APB1" "divider_apb1"
ttc_manage.pl replace "Divider_APB2" "divider_apb2"
ttc_manage.pl replace "Divider_AHB" "divider_hclk"
ttc_manage.pl replace "sysclock__stm32l1xx_RCC_GetITStatus" "sysclock_stm32l1xx_RCC_GetITStatus"
ttc_manage.pl replace "gfx_clr_pixel" "gfx_pixel_bg"
ttc_manage.pl replace "gfx_set_pixel()" "gfx_pixel_fg()"
ttc_manage.pl replace "gfx_pixel_fg()" "gfx_set_pixel()"
ttc_manage.pl replace "gfx_put_pixel()" "gfx_pixel_fg()"
ttc_manage.pl replace "gfx_set_pixel()" "gfx_set_pixel_at()"
ttc_manage.pl replace "gfx_clr_pixel" "gfx_clr_pixel_at"
ttc_manage.pl replace "gfx_pixel_fg" "gfx_set_pixel"
ttc_manage.pl replace "gfx_pixel_bg" "gfx_clr_pixel"
ttc_manage.pl replace "clr_pixel" "clr_pixel_at"
ttc_manage.pl replace "set_pixel" "set_pixel_at"
ttc_manage.pl replace "put_pixel" "set_pixel"
ttc_manage.pl replace "pixel_at_at" "pixel_at"
ttc_manage.pl replace "STM32xxxxx" "STM32xxxx"
ttc_manage.pl replace "InsertPrivatePrototypes" "InsertPrivateFunctionDelcarations"
ttc_manage.pl replace "InsertPrivateDefinitions" "InsertPrivateFunctionDefinitions"
ttc_manage.pl replace "math_basic.h" "DEPRECATED_math_basic.h"
ttc_manage.pl replace "math_trigonometry.o" "DEPRECATED_math_trigonometry.o"
ttc_manage.pl replace "math_trigonometry.h" "DEPRECATED_math_trigonometry.h"
ttc_manage.pl replace "TTC_GFX_ORIENTATION" "TTC_GFX_ROTATION_CLOCKWISE"
ttc_manage.pl replace "CAN_MCR_t" "register_stm32l1xx_can_mcr_t"
ttc_manage.pl replace "CAN_MSR_t" "register_stm32l1xx_can_msr_t"
ttc_manage.pl replace "CAN_TSR_t" "register_stm32l1xx_can_tsr_t"
ttc_manage.pl replace "CAN_RF0R_t" "register_stm32l1xx_can_rf0r_t"
ttc_manage.pl replace "CAN_RF1R_t" "register_stm32l1xx_can_rf1r_t"
ttc_manage.pl replace "CAN_IER_t" "register_stm32l1xx_can_ier_t"
ttc_manage.pl replace "CAN_ESR_t" "register_stm32l1xx_can_esr_t"
ttc_manage.pl replace "CAN_BTR_t" "register_stm32l1xx_can_btr_t"
ttc_manage.pl replace "CAN_TIxR_t" "register_stm32l1xx_can_tixr_t"
ttc_manage.pl replace "CAN_TDTxR_t" "register_stm32l1xx_can_tdtxr_t"
ttc_manage.pl replace "CAN_RIxR_t" "register_stm32l1xx_can_rixr_t"
ttc_manage.pl replace "CAN_RDTxR_t" "register_stm32l1xx_can_rdtxr_t"
ttc_manage.pl replace "USB_cntr_t" "register_stm32l1xx_usb_cntr_t"
ttc_manage.pl replace "USB_istr_t" "register_stm32l1xx_usb_istr_t"
ttc_manage.pl replace "USB_fnr_t" "register_stm32l1xx_usb_fnr_t"
ttc_manage.pl replace "TTC_CPU_MAX_FREQUENCY" "TTC_SYSCLOCK_FREQUENCY_MAX"
ttc_manage.pl replace "inidividual" "individual"
ttc_manage.pl replace "DBOARD" "DTTC_BOARD"
ttc_manage.pl replace "cm3/cm3_" "cpu/cm3_"
ttc_manage.pl replace "activate.190_cpu_" "# activate.190_cpu_"
ttc_manage.pl replace "# activate.190" "#X activate.190"
ttc_manage.pl replace "EXTENSION_190_cpu_cortexm3" "EXTENSION_450_cpu_cortexm3"
ttc_manage.pl replace "EXTENSION_200_cpu_" "EXTENSION_450_cpu_"
ttc_manage.pl replace "put_char_solid_180p" "put_char_solid_180"
ttc_manage.pl replace "put_char_solid_cw" "put_char_solid_090"
ttc_manage.pl replace "put_char_solid_ccw" "put_char_solid_270"
ttc_manage.pl replace "put_char_180p" "put_char_180"
ttc_manage.pl replace "put_char_90ccw" "put_char_270"
ttc_manage.pl replace "put_char_90cw" "put_char_090"
ttc_manage.pl replace "_90ccw" "_270"
ttc_manage.pl replace "rect_180p" "rect_180"
ttc_manage.pl replace "rect_90cw" "rect_090"
ttc_manage.pl replace "horizontal_90cw" "horizontal_090"
ttc_manage.pl replace "vertical_90cw" "vertical_090"
ttc_manage.pl replace "Transmiter" "Transmitter"
ttc_manage.pl replace "StarOfFrame_TimeOut" "TimeOut_StartOfFrame"
ttc_manage.pl replace "ttc_gpio_arch_t" "ttc_gpio_config_t"
ttc_manage.pl replace "ttc_gpio_architecture_t" "ttc_gpio_register_t"
ttc_manage.pl replace "register_cortexm3_NVIC_t" "register_cortexm3_nvic_t"
ttc_manage.pl replace "register_cortexm3_SCB_t" "register_cortexm3_scb_t"
ttc_manage.pl replace "ttc_radio_get_payload_802154" "ttc_packet_get_payload"
ttc_manage.pl replace "ttc_radio_get_payload_size" "ttc_packet_get_payload_size"
ttc_manage.pl replace "trpt_802154_type" "ta_packet_802154"
ttc_manage.pl replace "ttc_radio_get_received_packet_try" "ttc_radio_received_packet_tryget"
ttc_manage.pl replace "recreacting" "recreating"
ttc_manage.pl replace "radio_dw1000_write_spi" "radio_dw1000_spi_send"
ttc_manage.pl replace "radio_dw1000_read_spi" "radio_dw1000_spi_read"
ttc_manage.pl replace "ttc_packet_data" "ttc_packet_mac"
ttc_manage.pl replace "ttc_packet_info" "ttc_packet_meta"
ttc_manage.pl replace "_get_pointer_payload_size" "_get_payload_size"
ttc_manage.pl replace "ttc_math_log_int" "ttc_math_int_log"
ttc_manage.pl replace "ttc_math_int_log" "ttc_math_rank"
ttc_manage.pl replace "activate.000_" "activate.060_"
ttc_manage.pl replace "PACKET_802154_RANGING" "TTC_PACKET_RANGING"
ttc_manage.pl replace "ttc_radio_address_t" "ttc_packet_address_t"
ttc_manage.pl replace "Address16_index" "logical_index"
ttc_manage.pl replace "000_basic_extensions_" "060_basic_extensions_"
ttc_manage.pl replace "ttc_rand\(" "ttc_random_generate("
ttc_manage.pl replace "_ttc_rand_16\(" "ttc_random_generate16("
ttc_manage.pl replace "_ttc_srand_16\(" "ttc_random_seed16("
ttc_manage.pl replace "ttc_srand\(" "ttc_random_seed("
ttc_manage.pl replace "ttc_testpoint" "ttc_basic_test_ok"
ttc_manage.pl replace "_gpio_set_u" "_gpio_put_u"
ttc_manage.pl replace "stm32_GPIOA" "tgb_bank_a"
ttc_manage.pl replace "stm32_GPIOB" "tgb_bank_b"
ttc_manage.pl replace "stm32_GPIOC" "tgb_bank_C"
ttc_manage.pl replace "stm32_GPIOD" "tgb_bank_D"
ttc_manage.pl replace "stm32_GPIOE" "tgb_bank_E"
ttc_manage.pl replace "stm32_GPIOF" "tgb_bank_F"
ttc_manage.pl replace "stm32_GPIOG" "tgb_bank_G"
ttc_manage.pl replace "stm32_GPIOH" "tgb_bank_H"
ttc_manage.pl replace "tgb_bank_C" "tgb_bank_c"
ttc_manage.pl replace "tgb_bank_D" "tgb_bank_d"
ttc_manage.pl replace "tgb_bank_E" "tgb_bank_e"
ttc_manage.pl replace "tgb_bank_F" "tgb_bank_f"
ttc_manage.pl replace "tgb_bank_G" "tgb_bank_g"
ttc_manage.pl replace "tgb_bank_H" "tgb_bank_h"
ttc_manage.pl replace "_u8_pin" "_u8_shift"
ttc_manage.pl replace "radio_dw1000_get_features" "radio_dw1000_check_features"
ttc_manage.pl replace "radio_get_features" "radio_config_check"
ttc_manage.pl replace "dw1000_check_features" "dw1000_config_check"
ttc_manage.pl replace "config_check" "configuration_check"
ttc_manage.pl replace "_get_header_size" "_get_size_mac_header"
ttc_manage.pl replace "ESYNCR_ExternalSyncClockReset" "ESYNCR"
ttc_manage.pl replace "AAT_AutomaticAcknowledeTrigger" "AAT"
ttc_manage.pl replace "TXFRB_TX_Frame_Begins" "TXFRB"
ttc_manage.pl replace "TXPRS_TX_Preamble_Sent" "TXPRS"
ttc_manage.pl replace "TXPHS_TX_Header_Sent" "TXPHS"
ttc_manage.pl replace "TXFRS_TX_Frame_Sent" "TXFRS"
ttc_manage.pl replace "RXPRD_RX_Preamble_Detected" "RXPRD"
ttc_manage.pl replace "RXSFD_RX_StartFrame_Detected" "RXSFD"
ttc_manage.pl replace "LDEDONE_LeadingEdgeDetection_Done" "LDEDONE"
ttc_manage.pl replace "RXPHD_RX_MAC_Header_Detected" "RXPHD"
ttc_manage.pl replace "RXPHE_RX_MAC_Header_Error" "RXPHE"
ttc_manage.pl replace "RXDFR_RX_DataFrame_Ready" "RXDFR"
ttc_manage.pl replace "RXFCG_RX_FrameCheckSum_Good" "RXFCG"
ttc_manage.pl replace "RXFCE_RX_FrameCheckSum_Error" "RXFCE"
ttc_manage.pl replace "RXRFSL_RX_ReedSolomonFrameSyncLoss" "RXRFSL"
ttc_manage.pl replace "RXRFTO_RX_FrameWaitTimeout" "RXRFTO"
ttc_manage.pl replace "LDEERR_LeadingEdgeDetection_Error" "LDEERR"
ttc_manage.pl replace "RXOVRR_RX_Overrun" "RXOVRR"
ttc_manage.pl replace "RXPTO_RX_PreambleDetectionTimout" "RXPTO"
ttc_manage.pl replace "GPIOIRQ_Interrupt_GPIO" "GPIOIRQ"
ttc_manage.pl replace "SLP2INIT_Sleep2Init" "SLP2INIT"
ttc_manage.pl replace "RFPLL_LoosingLock_RF" "RFPLL"
ttc_manage.pl replace "CLKPLL_LoosingLock_SYSCLK" "CLKPLL"
ttc_manage.pl replace "RXSFDTO_RX_StartFram_Timeout" "RXSFDTO"
ttc_manage.pl replace "HPDWARN_HalfPeriodDelay_Warning" "HPDWARN"
ttc_manage.pl replace "TXBERR_TX_Buffer_Error" "TXBERR"
ttc_manage.pl replace "AFFREJ_FrameRejectedByFilter" "AFFREJ"
ttc_manage.pl replace "HSRB_RX_BufferPointer_Host" "HSRB"
ttc_manage.pl replace "ICRB_RX_BufferPointer_IC" "ICRB"
ttc_manage.pl replace "RXRSCS_RX_ReedSolomonCorrection" "RXRSCS"
ttc_manage.pl replace "RXPREJ_RX_PreambleRejected" "RXPREJ"
ttc_manage.pl replace "TXPUTE_TX_PowerUpTime_Error" "TXPUTE"
ttc_manage.pl replace "TX_PGDELAY" "TC_PGDELAY"
ttc_manage.pl replace "example_ttc_radio_dw1000" "example_ttc_radio_ranging"
ttc_manage.pl replace "dest64" "target64"
ttc_manage.pl replace "dest16" "target16"
ttc_manage.pl replace "destpan16" "targetpan16"
ttc_manage.pl replace "activate.500_ttc_math_trigonometry.sh" "activate.500_ttc_math.sh"
ttc_manage.pl replace "provideFeature" "enableFeature"
ttc_manage.pl replace "complete_2d" "ring_2d"
ttc_manage.pl replace "COMPLETE_2D" "RING_2D"
ttc_manage.pl replace "2010-2015" "2010-2016"
ttc_manage.pl replace "2010-2014" "2010-2016"
ttc_manage.pl replace "2010-2013" "2010-2016"
ttc_manage.pl replace "2010-2012" "2010-2016"
ttc_manage.pl replace "2010-2011" "2010-2016"
ttc_manage.pl replace "ring_2d" "simple_2d"
ttc_manage.pl replace "RING_2D" "SIMPLE_2D"
ttc_manage.pl replace "_math_rank" "_math_int_rank"
ttc_manage.pl replace "math_interface_rank" "math_interface_int_rank"
ttc_manage.pl replace "math_atan" "math_arctan"
ttc_manage.pl replace "math_interface_atan" "math_interface_arctan"
ttc_manage.pl replace "ttc_gfx_print" "ttc_gfx_text"
ttc_manage.pl replace "math_reduce_angle" "math_angle_reduce"
ttc_manage.pl replace "_distance_2d" "_length_2d"
ttc_manage.pl replace "_distance_3d" "_length_3d"
ttc_manage.pl replace "InsertPrivateFunctionDelcarations" "InsertPrivateFunctionDeclarations"
ttc_manage.pl replace "msf_float_t" "math_float_t"
ttc_manage.pl replace "msf_double_t" "math_double_t"
ttc_manage.pl replace "ttc_task_get_elapsed_ticks" "ttc_systick_elapsed_ticks"
ttc_manage.pl replace "ttc_systick_elapsed_ticks" "ttc_systick_get_elapsed_ticks"
ttc_manage.pl replace "ttc_task_get_us_ticks" "ttc_systick_get_us_ticks"
ttc_manage.pl replace "<AUTHOR>" "Gregor Rebel"
ttc_manage.pl replace "ttc_task_get_elapsed_usecs" "ttc_systick_get_elapsed_usecs"
ttc_manage.pl replace "frequency_hclk" "frequency_ahb"
ttc_manage.pl replace "frequency_pclk1" "frequency_apb1"
ttc_manage.pl replace "frequency_pclk2" "frequency_apb2"
ttc_manage.pl replace "TA_CPU_" "TTC_CPU_VARIANT_"
ttc_manage.pl replace "sssp_SourcePLL" "sysclock_stm32f1xx_SourcePLL_e"
ttc_manage.pl replace "sssp_SourcePREDIV1_HSE" "sssp_SYSCLK_PLL1_HSE"
ttc_manage.pl replace "sssp_SourcePREDIV1_PREDIV2_HSE" "sssp_SYSCLK_PLL1_PLL2_HSE"
ttc_manage.pl replace "sssp_SourcePLLMUL_HSI" "sssp_SYSCLK_PLL1_HSI"
ttc_manage.pl replace "sssp_Source4MHz" "sssp_SYSCLK_4MHz"
ttc_manage.pl replace "sssp_SYSCLK_4MHz" "sssp_SYSCLK_8MHz"
ttc_manage.pl replace "sssp_SourceHSE" "sssp_SYSCLK_HSE"
ttc_manage.pl replace "get_available_frequencies" "frequency_get_all"
ttc_manage.pl replace "configs/memory_" "ttc-lib/.compiler/memory_"
ttc_manage.pl replace "ttc-lib/.compiler/memory_basic.ld" "configs/memory_project.ld"
ttc_manage.pl replace "ttc-lib/.compiler" "ttc-lib/_compiler"
ttc_manage.pl replace "ttc-lib/_compiler" "ttc-lib/_linker"
ttc_manage.pl replace "ttc-lib/_linker/memory_generic.ld" "configs/memory_project.ld"
ttc_manage.pl replace "configs/memory.ld" "configs/memory_current.ld"
ttc_manage.pl replace "ttc_task_MainStack_Start" "ttc_basic_MainStack_Start"
ttc_manage.pl replace "ttc_task_MainStack_End" "ttc_basic_MainStack_End"
ttc_manage.pl replace "configs/startscript" "configs/debug"
ttc_manage.pl replace "ttc_task_delay_init" "ttc_systick_delay_init"
ttc_manage.pl replace "ttc_task_delay_check" "ttc_systick_delay_check"
ttc_manage.pl replace "ttc_task_delay_t" "ttc_systick_delay_t"
ttc_manage.pl replace "ttc_task_delay" "ttc_systick_delay"
ttc_manage.pl replace "register_cortexm3_SYSTICK" "register_cortexm3_STK"
ttc_manage.pl replace "register_cortexm3_systick_t" "register_cortexm3_stk_t"
ttc_manage.pl replace "RCC_CR" "CR"
ttc_manage.pl replace "RCC_ICSCR" "ICSCR"
ttc_manage.pl replace "RCC_CFGR" "CFGR"
ttc_manage.pl replace "RCC_CIR" "CIR"
ttc_manage.pl replace "RCC_AHBRSTR" "AHBRSTR"
ttc_manage.pl replace "RCC_APB2RSTR" "APB2RSTR"
ttc_manage.pl replace "RCC_APB1RSTR" "APB1RSTR"
ttc_manage.pl replace "RCC_AHBENR" "AHBENR"
ttc_manage.pl replace "RCC_APB2ENR" "APB2ENR"
ttc_manage.pl replace "RCC_APB1ENR" "APB1ENR"
ttc_manage.pl replace "RCC_AHBLPENR" "AHBLPENR"
ttc_manage.pl replace "RCC_APB2LPENR" "APB2LPENR"
ttc_manage.pl replace "RCC_APB1LPENR" "APB1LPENR"
ttc_manage.pl replace "RCC_CSR" "CSR"
ttc_manage.pl replace "RTC_TR" "TR"
ttc_manage.pl replace "RTC_DR" "DR"
ttc_manage.pl replace "RTC_CR" "CR"
ttc_manage.pl replace "RTC_ISR" "ISR"
ttc_manage.pl replace "RTC_PRER" "PRER"
ttc_manage.pl replace "RTC_WUTR" "WUTR"
ttc_manage.pl replace "RTC_CALIBR" "CALIBR"
ttc_manage.pl replace "RTC_ALRMAR" "ALRMAR"
ttc_manage.pl replace "RTC_ALRMBR" "ALRMBR"
ttc_manage.pl replace "RTC_WPR" "WPR"
ttc_manage.pl replace "RTC_SSR" "SSR"
ttc_manage.pl replace "RTC_SHIFTR" "SHIFTR"
ttc_manage.pl replace "RTC_TSTR" "TSTR"
ttc_manage.pl replace "RTC_TSDR" "TSDR"
ttc_manage.pl replace "RTC_TSSSR" "TSSSR"
ttc_manage.pl replace "RTC_CALR" "CALR"
ttc_manage.pl replace "RTC_TAFCR" "TAFCR"
ttc_manage.pl replace "RTC_ALRMASSR" "ALRMASSR"
ttc_manage.pl replace "RTC_ALRMBSSR" "ALRMBSSR"
ttc_manage.pl replace "RTC_BKPOR" "BKPOR"
ttc_manage.pl replace "PWR_CR" "CR"
ttc_manage.pl replace "PWR_ICSCR" "ICSCR"
ttc_manage.pl replace "DAC_CR" "CR"
ttc_manage.pl replace "DAC_SWTRIGR" "SWTRIGR"
ttc_manage.pl replace "DAC_DAC_DHR12R1" "DHR12R1"
ttc_manage.pl replace "DAC_DHR12L1" "DHR12L1"
ttc_manage.pl replace "DAC_DHR8R1" "DHR8R1"
ttc_manage.pl replace "DAC_DHR12R2" "DHR12R2"
ttc_manage.pl replace "DAC_DHR12L2" "DHR12L2"
ttc_manage.pl replace "DAC_DHR8R2" "DHR8R2"
ttc_manage.pl replace "DAC_DHR12RD" "DHR12RD"
ttc_manage.pl replace "DAC_DHR12LD" "DHR12LD"
ttc_manage.pl replace "DAC_DHR8RD" "DHR8RD"
ttc_manage.pl replace "DAC_DOR1" "DOR1"
ttc_manage.pl replace "DAC_DOR2" "DOR2"
ttc_manage.pl replace "DAC_SR" "SR"
ttc_manage.pl replace "Amount_ReceiverRetart" "Amount_ReceiverRestart"
ttc_manage.pl replace "_Assert_SameAddress" "ttc_assert_same_address"
ttc_manage.pl replace "Assert_Is_Readable" "ttc_assert_is_readable"
ttc_manage.pl replace "Assert_Is_Writable" "ttc_assert_is_writable"
ttc_manage.pl replace "Assert_BIST" "ttc_assert_bist"
ttc_manage.pl replace "TTC_GPIO_ASSERT" "TTC_ASSERT_OUTPUT_PIN"
ttc_manage.pl replace "Assert_Test_EC" "ttc_assert_test_ec"
ttc_manage.pl replace "Assert_Halt_EC" "ttc_assert_halt_error_code"
ttc_manage.pl replace "ttc_assert_test_ec" "ttc_assert_test_error_code"
ttc_manage.pl replace "Assert_Test_BIST" "ttc_assert_test_BIST"
ttc_manage.pl replace "Assert_Halt_BIST" "ttc_assert_halt_BIST"
ttc_manage.pl replace "Assert_On_False" "ttc_assert_bist"
ttc_manage.pl replace "Assert_SameAddress" "ttc_assert_same_address"
ttc_manage.pl replace "ttc_assert_bist" "ttc_assert_test_bist"
ttc_manage.pl replace "ttc_assert_test_bist" "Assert_BIST"
ttc_manage.pl replace "ttc_assert_is_writable" "Assert_Writable"
ttc_manage.pl replace "ttc_assert_is_readable" "Assert_Readable"
ttc_manage.pl replace "ErrorCode_e" "ttc_assert_errorcode_e"
ttc_manage.pl replace "ec_Malloc" "ttc_error_Malloc"
ttc_manage.pl replace "ec_Debug" "ttc_error_Debug"
ttc_manage.pl replace "ec_NULL" "ttc_error_NULL"
ttc_manage.pl replace "ec_BIST" "ttc_error_BIST"
ttc_manage.pl replace "ec_StackOverflow" "ttc_error_StackOverflow"
ttc_manage.pl replace "ec_InvalidArgument" "ttc_error_InvalidArgument"
ttc_manage.pl replace "ec_InvalidConfiguration" "ttc_error_InvalidConfiguration"
ttc_manage.pl replace "ec_InvalidAddress" "ttc_error_InvalidAddress"
ttc_manage.pl replace "ec_InvalidImplementation" "ttc_error_InvalidImplementation"
ttc_manage.pl replace "ec_AddressDiffers" "ttc_error_AddressDiffers"
ttc_manage.pl replace "ec_AddressNotReadable" "ttc_error_AddressNotReadable"
ttc_manage.pl replace "ec_AddressNotWritable" "ttc_error_AddressNotWritable"
ttc_manage.pl replace "ec_ArrayIndexOutOfBound" "ttc_error_ArrayIndexOutOfBound"
ttc_manage.pl replace "ec_IllegalPointer" "ttc_error_IllegalPointer"
ttc_manage.pl replace "ec_NotImplemented" "ttc_error_NotImplemented"
ttc_manage.pl replace "ec_OutOfMemory" "ttc_error_OutOfMemory"
ttc_manage.pl replace "ec_OutOfResources" "ttc_error_OutOfResources"
ttc_manage.pl replace "ec_DeviceNotFound" "ttc_error_DeviceNotFound"
ttc_manage.pl replace "ec_HardFault" "ttc_error_HardFault"
ttc_manage.pl replace "ec_StackOverrun" "ttc_error_StackOverrun"
ttc_manage.pl replace "ec_TimeOut" "ttc_error_TimeOut"
ttc_manage.pl replace "ec_UnhandledInterrupt" "ttc_error_UnhandledInterrupt"
ttc_manage.pl replace "ec_DeviceInit" "ttc_error_DeviceInit"
ttc_manage.pl replace "ec_UNKNOWN" "ttc_error_UNKNOWN"
ttc_manage.pl replace "ttc_error_UNKNOWN" "ttc_error_Unknown"
ttc_manage.pl replace "ttc_assert_errorcode_e" "ttc_error_e"
ttc_manage.pl replace "ttc_error_IllegalPointer" "ttc_error_NULL"
ttc_manage.pl replace "PicoSecondsPerSysTick" "NanoSecondsPerSysTick"
ttc_manage.pl replace "ttc_error_" "ttc_assert_code_"
ttc_manage.pl replace "ttc_assert_test_error_code" "ttc_assert_test_origin"
ttc_manage.pl replace "ttc_assert_code_" "ttc_assert_origin_"
ttc_manage.pl replace "ttc_assert_halt_error_code" "ttc_assert_halt_origin"
ttc_manage.pl replace "ttc_assert_origin_e ErrorCode" "ttc_assert_origin_e Origin"
ttc_manage.pl replace "ttc_assert_test_BIST" "ttc_assert_test"
ttc_manage.pl replace "ttc_assert_halt_BIST" "ttc_assert_halt"
ttc_manage.pl replace "ttc_assert_is_readable" "ttc_assert_address_readable"
ttc_manage.pl replace "ttc_assert_is_writable" "ttc_assert_address_writable"
ttc_manage.pl replace "ttc_assert_same_address" "ttc_assert_address_matches"
ttc_manage.pl replace "ttc_assert_is_not_null" "ttc_assert_address_not_null"
ttc_manage.pl replace "Writable\(Address\)" "Writable(Address, Origin)"
ttc_manage.pl replace "Readable\(Address\)" "Readable(Address, Origin)"
ttc_manage.pl replace "Assert_BIST\(Condition\)" "Assert(Condition, Origin)"
ttc_manage.pl replace "\(Condition\)" "(Condition, Origin)"
ttc_manage.pl replace " \(Condition, Origin\)" "(Condition)"
ttc_manage.pl replace "\(Condition\)" " (Condition)"
ttc_manage.pl replace "ttc_assert_origin_NULL" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_InvalidArgument" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_input_InvalidImplementation" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_spi_NULL" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_register_NULL" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_can_DeviceNotFound" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_timer_InvalidArgument" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_timer_DeviceNotFound" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_timer_InvalidImplementation" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_timer_NotImplemented" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_usart_InvalidArgument" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_gfx_InvalidArgument" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_basic_CommunicationError" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_i2c_InvalidImplementation" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_adc_InvalidConfiguration" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_adc_InvalidImplementation" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_basic_DeviceNotFound" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_can_NoFilterAvailable" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_radio_Unknown" "ttc_assert_origin_auto"
ttc_manage.pl replace "ec_touchpad_InvalidImplementation" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_Unknown" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_InvalidConfiguration" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_InvalidImplementation" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_DeviceNotFound" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_HardFault" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_UnhandledInterrupt" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_NotImplemented" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_Malloc" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_AddressDiffers" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_AddressNotReadable" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_AddressNotWritable" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_ArrayIndexOutOfBound" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_BIST" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_Debug" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_DeviceInit" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_StackOverflow" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_InvalidAddress" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_OutOfMemory" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_OutOfResources" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_StackOverrun" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_origin_TimeOut" "ttc_assert_origin_auto"
ttc_manage.pl replace "Assert_BIST" "Assert"
ttc_manage.pl replace "ttc_list_wait_pop_front_single" "ttc_list_pop_front_single_wait"
ttc_manage.pl replace "ttc_list_pop_front_single_wait_isr" "ttc_list_pop_front_single_isr"
ttc_manage.pl replace "Assert\(Condition, Origin\)" "Assert( ((Condition) != 0), Origin)"
ttc_manage.pl replace "if \(! \(Condition\) \) { ttc_assert_halt\(\); }" "if (! (Condition) ) { ttc_assert_halt(Origin); }"
ttc_manage.pl replace "ttc_assert_origin_none" "ttc_assert_origin_auto"
ttc_manage.pl replace "ttc_assert_halt\(Origin\)" "ttc_assert_halt_origin(Origin)"
ttc_manage.pl replace "startExtensions" "ttc_extensions_start"
ttc_manage.pl replace "ttc_extensions_init" "ttc_extensions_prepare"
ttc_manage.pl replace "example_benchmarkss" "example_benchmarks"
ttc_manage.pl replace "example_benchmarks_start" "example_benchmarks_prepare"
ttc_manage.pl replace "example_can_start" "example_can_prepare"
ttc_manage.pl replace "example_channel_start" "example_channel_prepare"
ttc_manage.pl replace "example_gfx_benchmark_start" "example_gfx_benchmark_prepare"
ttc_manage.pl replace "example_gfx_boxes_start" "example_gfx_boxes_prepare"
ttc_manage.pl replace "example_gfx_printf_start" "example_gfx_printf_prepare"
ttc_manage.pl replace "example_gui_start" "example_gui_prepare"
ttc_manage.pl replace "example_i2c_start" "example_i2c_prepare"
ttc_manage.pl replace "example_input_start" "example_input_prepare"
ttc_manage.pl replace "example_leds_start" "example_leds_prepare"
ttc_manage.pl replace "example_radio_serial_start" "example_radio_serial_prepare"
ttc_manage.pl replace "example_radio_start" "example_radio_prepare"
ttc_manage.pl replace "example_spi_start" "example_spi_prepare"
ttc_manage.pl replace "example_threading_queues_start" "example_threading_queues_prepare"
ttc_manage.pl replace "example_threading_semaphores_start" "example_threading_semaphores_prepare"
ttc_manage.pl replace "example_ttc_accelerometer_start" "example_ttc_accelerometer_prepare"
ttc_manage.pl replace "example_ttc_adc_start" "example_ttc_adc_prepare"
ttc_manage.pl replace "example_ttc_assert_none_start" "example_ttc_assert_none_prepare"
ttc_manage.pl replace "example_ttc_assert_start" "example_ttc_assert_prepare"
ttc_manage.pl replace "example_ttc_basic_start" "example_ttc_basic_prepare"
ttc_manage.pl replace "example_ttc_basic_stm32f1xx_start" "example_ttc_basic_stm32f1xx_prepare"
ttc_manage.pl replace "example_ttc_can_start" "example_ttc_can_prepare"
ttc_manage.pl replace "example_ttc_cpu_start" "example_ttc_cpu_prepare"
ttc_manage.pl replace "example_ttc_cpu_stm32f1xx_start" "example_ttc_cpu_stm32f1xx_prepare"
ttc_manage.pl replace "example_ttc_dac_start" "example_ttc_dac_prepare"
ttc_manage.pl replace "example_ttc_dma_start" "example_ttc_dma_prepare"
ttc_manage.pl replace "example_ttc_ethernet_start" "example_ttc_ethernet_prepare"
ttc_manage.pl replace "example_ttc_gfx_ili9320_start" "example_ttc_gfx_ili9320_prepare"
ttc_manage.pl replace "example_ttc_gfx_start" "example_ttc_gfx_prepare"
ttc_manage.pl replace "example_ttc_gyroscope_start" "example_ttc_gyroscope_prepare"
ttc_manage.pl replace "example_ttc_heap_pool_start" "example_ttc_heap_pool_prepare"
ttc_manage.pl replace "example_ttc_heap_start" "example_ttc_heap_prepare"
ttc_manage.pl replace "example_ttc_i2c_master_receiver_start" "example_ttc_i2c_master_receiver_prepare"
ttc_manage.pl replace "example_ttc_i2c_master_start" "example_ttc_i2c_master_prepare"
ttc_manage.pl replace "example_ttc_i2c_master_transmitter_start" "example_ttc_i2c_master_transmitter_prepare"
ttc_manage.pl replace "example_ttc_i2c_slave_receiver_start" "example_ttc_i2c_slave_receiver_prepare"
ttc_manage.pl replace "example_ttc_i2c_slave_transmitter_start" "example_ttc_i2c_slave_transmitter_prepare"
ttc_manage.pl replace "example_ttc_i2c_start" "example_ttc_i2c_prepare"
ttc_manage.pl replace "example_ttc_input_start" "example_ttc_input_prepare"
ttc_manage.pl replace "example_ttc_interface_start" "example_ttc_interface_prepare"
ttc_manage.pl replace "example_ttc_interrupt_start" "example_ttc_interrupt_prepare"
ttc_manage.pl replace "example_ttc_layer_phy_start" "example_ttc_layer_phy_prepare"
ttc_manage.pl replace "example_ttc_list_start" "example_ttc_list_prepare"
ttc_manage.pl replace "example_ttc_math_software_float_start" "example_ttc_math_software_float_prepare"
ttc_manage.pl replace "example_ttc_math_start" "example_ttc_math_prepare"
ttc_manage.pl replace "example_ttc_memory_start" "example_ttc_memory_prepare"
ttc_manage.pl replace "example_ttc_network_layer_start" "example_ttc_network_layer_prepare"
ttc_manage.pl replace "example_ttc_network_start" "example_ttc_network_prepare"
ttc_manage.pl replace "example_ttc_packet_start" "example_ttc_packet_prepare"
ttc_manage.pl replace "example_ttc_pwr_start" "example_ttc_pwr_prepare"
ttc_manage.pl replace "example_ttc_radio_ranging_start" "example_ttc_radio_ranging_prepare"
ttc_manage.pl replace "example_ttc_radio_start" "example_ttc_radio_prepare"
ttc_manage.pl replace "example_ttc_rcc_start" "example_ttc_rcc_prepare"
ttc_manage.pl replace "example_ttc_register_start" "example_ttc_register_prepare"
ttc_manage.pl replace "example_ttc_sdcard_start" "example_ttc_sdcard_prepare"
ttc_manage.pl replace "example_ttc_slam_covalent_bond_start" "example_ttc_slam_covalent_bond_prepare"
ttc_manage.pl replace "example_ttc_slam_simple_2d_start" "example_ttc_slam_simple_2d_prepare"
ttc_manage.pl replace "example_ttc_slam_start" "example_ttc_slam_prepare"
ttc_manage.pl replace "example_ttc_spi_master_start" "example_ttc_spi_master_prepare"
ttc_manage.pl replace "example_ttc_spi_slave_start" "example_ttc_spi_slave_prepare"
ttc_manage.pl replace "example_ttc_spi_start" "example_ttc_spi_prepare"
ttc_manage.pl replace "example_ttc_string_start" "example_ttc_string_prepare"
ttc_manage.pl replace "example_ttc_sysclock_start" "example_ttc_sysclock_prepare"
ttc_manage.pl replace "example_ttc_sysclock_stm32f1xx_start" "example_ttc_sysclock_stm32f1xx_prepare"
ttc_manage.pl replace "example_ttc_systick_cortexm3_start" "example_ttc_systick_cortexm3_prepare"
ttc_manage.pl replace "example_ttc_systick_freertos_start" "example_ttc_systick_freertos_prepare"
ttc_manage.pl replace "example_ttc_systick_start" "example_ttc_systick_prepare"
ttc_manage.pl replace "example_ttc_tcpip_start" "example_ttc_tcpip_prepare"
ttc_manage.pl replace "example_ttc_timer_pwm_start" "example_ttc_timer_pwm_prepare"
ttc_manage.pl replace "example_ttc_timer_start" "example_ttc_timer_prepare"
ttc_manage.pl replace "example_ttc_touchpad_start" "example_ttc_touchpad_prepare"
ttc_manage.pl replace "example_ttc_usart_start" "example_ttc_usart_prepare"
ttc_manage.pl replace "example_ttc_usb_start" "example_ttc_usb_prepare"
ttc_manage.pl replace "example_ttc_watchdog_start" "example_ttc_watchdog_prepare"
ttc_manage.pl replace "example_usart_start" "example_usart_prepare"
ttc_manage.pl replace "example_usb_host_hid_start" "example_usb_host_hid_prepare"
ttc_manage.pl replace "example_usb_vcp_start" "example_usb_vcp_prepare"
ttc_manage.pl replace "regression_ttc_<device>_<architecture>_start" "regression_ttc_<device>_<architecture>_prepare"
ttc_manage.pl replace "example_ttc_<device>_start" "example_ttc_<device>_prepare"
ttc_manage.pl replace "egression_ttc_<device>_start" "egression_ttc_<device>_prepare"
ttc_manage.pl replace "example_ttc_<device>_<architecture>_start" "example_ttc_<device>_<architecture>_prepare"
ttc_manage.pl replace "example_\${EXTENSION_NAME}_start\(\)" "example_${EXTENSION_NAME}_start()"
ttc_manage.pl replace "main_start" "main_prepare"
ttc_manage.pl replace "ttc_interrupt_get_critical_section" "ttc_interrupt_critical_value"
ttc_manage.pl replace "ttc_assert_halt_origin\(\)" "ttc_assert_halt_origin( ttc_assert_origin_auto )"
ttc_manage.pl replace "ttc_assert_halt\(\)" "ttc_assert_halt_origin( ttc_assert_origin_auto )"
ttc_manage.pl replace "ttc_task_end_criticalsection_owner" "_ttc_task_end_criticalsection"
ttc_manage.pl replace "task_begin_criticalsection" "task_critical_begin"
ttc_manage.pl replace "task_end_criticalsection" "task_critical_end"
ttc_manage.pl replace "task_end_all_criticalsections" "task_critical_all_end"
ttc_manage.pl replace "task_restore_criticalsections" "task_critical_all_restore"
ttc_manage.pl replace "interrupt_critical_value" "interrupt_critical_level"
ttc_manage.pl replace "Assert\( TaskArgument" "Assert_Writable( TaskArgument"
ttc_manage.pl replace "ttc_math_int_multiply_divide3" "ttc_base_int_multiply_divide3"
ttc_manage.pl replace "ttc_base_int_multiply_divide3" "ttc_basic_int_multiply_divide3"
ttc_manage.pl replace "ttc_basic_int_multiply_divide3" "ttc_basic_u32_multiply_divide3"
ttc_manage.pl replace "ttc_math_int_rank" "ttc_basic_int_rank"
ttc_manage.pl replace "ttc_basic_int_rank\(" "ttc_basic_int_rankN("
ttc_manage.pl replace "ttc_basic_u32_multiply_divide3" "ttc_basic_multiply_divide_u32x3"
ttc_manage.pl replace "ttc_math_int_rank2" "ttc_basic_int_rank2"
ttc_manage.pl replace "_radio_dw1000_softreset" "_radio_dw1000_reset_soft"
ttc_manage.pl replace "ttc_basic_MainStack_Start" "ttc_memory_MainStack_Start"
ttc_manage.pl replace "ttc_basic_MainStack_End" "ttc_memory_MainStack_End"
ttc_manage.pl replace "ttc_systick_delay_check" "ttc_systick_delay_expired"
ttc_manage.pl replace "slamradio_simple_2d" "slamradio_crtof_simple_2d"
ttc_manage.pl replace "_alloc_temporary" "_temporary_alloc"
ttc_manage.pl replace "ta_packet_802154" "tpt_802154"
ttc_manage.pl replace "NODE_IS_OBSERVER" "EXAMPLE_TTC_RADIO_NODE_IS_OBSERVER"
ttc_manage.pl replace "TARGET_MAX_" "TTC_BASIC_MAX_"
ttc_manage.pl replace "TTC_MEMORY_POOL_STATISTICS" "TTC_HEAP_POOL_STATISTICS"
ttc_manage.pl replace "ttc_slamradio_packet_invalid" "ttc_slamradio_packet_2anchor_"
ttc_manage.pl replace "ttc_slamradio_packet_builtup_start" "ttc_slamradio_packet_2anchor_builtup_start"
ttc_manage.pl replace "ttc_slamradio_packet_distances_request" "ttc_slamradio_packet_2anchor_distances_request"
ttc_manage.pl replace "ttc_slamradio_packet_distances_report" "ttc_slamradio_packet_2anchor_distances_report"
ttc_manage.pl replace ">AllStates" ">Init_AllStates"
ttc_manage.pl replace ">StateData" ">Init_StateData"
ttc_manage.pl replace ">MonitorTransition" ">Init_MonitorTransition"
ttc_manage.pl replace ">Stack_Size" ">Init_Stack_Size"
ttc_manage.pl replace "ttc_states_push" "ttc_states_call"
ttc_manage.pl replace "ttc_states_pull" "ttc_states_return"
ttc_manage.pl replace "states_transition_Pull" "states_transition_Return"
ttc_manage.pl replace "ttc_state_pull" "ttc_state_return"
ttc_manage.pl replace "ttc_states_return_value" "ttc_states_get_return"
ttc_manage.pl replace "Flags.Bits.DelayedTransmits" "Init.Flags.DelayedTransmits"
ttc_manage.pl replace "Flags.Bits.DelayedReceives" "Init.Flags.DelayedReceives"
ttc_manage.pl replace "Flags.Bits.AppendCRC" "Init.Flags.AppendCRC"
ttc_manage.pl replace "Flags.Bits.AutoAcknowledge" "Init.Flags.AutoAcknowledge"
ttc_manage.pl replace "Flags.Bits.AddressFilter" "Init.Flags.AddressFilter"
ttc_manage.pl replace "Flags.Bits.UseAlternateTxPath" "Init.Flags.UseAlternateTxPath"
ttc_manage.pl replace "Flags.Bits.PinTxActive_LowLevel" "Init.Flags.PinTxActive_LowLevel"
ttc_manage.pl replace "Flags.Bits.PinTxActive_LowActive" "Init.Flags.PinTxActive_LowActive"
ttc_manage.pl replace "Flags.Bits.PinAmp_LowActive" "Init.Flags.PinAmp_LowActive"
ttc_manage.pl replace "Flags.Bits.RxAutoReenable" "Init.Flags.RxAutoReenable"
ttc_manage.pl replace "Flags.Bits.EnableRX" "Init.Flags.EnableRX"
ttc_manage.pl replace "Flags.Bits.EnableTX" "Init.Flags.EnableTX"
ttc_manage.pl replace "Flags.Bits.EnableDoubleBuffering" "Init.Flags.EnableDoubleBuffering"
ttc_manage.pl replace "Flags.Bits.EnableRanging" "Init.Flags.EnableRanging"
ttc_manage.pl replace "Flags.Bits.EnableRSSI" "Init.Flags.EnableRSSI"
ttc_manage.pl replace "Flags.Bits.Enable_LED_RXOK" "Init.Flags.Enable_LED_RXOK"
ttc_manage.pl replace "Flags.Bits.Enable_LED_RX" "Init.Flags.Enable_LED_RX"
ttc_manage.pl replace "Flags.Bits.Enable_LED_TX" "Init.Flags.Enable_LED_TX"
ttc_manage.pl replace "Flags.Bits.Enable_Output_PA" "Init.Flags.Enable_Output_PA"
ttc_manage.pl replace "Flags.Bits.Enable_Output_IRQ" "Init.Flags.Enable_Output_IRQ"
ttc_manage.pl replace "Flags.Bits.FlagReceiverOn" "Init.Flags.FlagReceiverOn"
ttc_manage.pl replace "Config->LevelTX" "Config->Init.LevelTX"
ttc_manage.pl replace "Config->LevelRX" "Config->Init.LevelRX"
ttc_manage.pl replace "Config->MaxPacketSize" "Config->Init.MaxPacketSize"
ttc_manage.pl replace "Config->function_preamble_detected_isr" "Config->Init.function_preamble_detected_isr"
ttc_manage.pl replace "Config->function_start_rx_isr" "Config->Init.function_start_rx_isr"
ttc_manage.pl replace "Config->function_end_rx_isr" "Config->Init.function_end_rx_isr"
ttc_manage.pl replace "Config->function_start_tx_isr" "Config->Init.function_start_tx_isr"
ttc_manage.pl replace "Config->function_end_tx_isr" "Config->Init.function_end_tx_isr"
ttc_manage.pl replace "Config->Pin_TxActive" "Config->Init.Pin_TxActive"
ttc_manage.pl replace "Config->Pin_Enable_Amplifier" "Config->Init.Pin_Enable_Amplifier"
ttc_manage.pl replace "Config->RawBitrate" "Config->Init.RawBitrate"
ttc_manage.pl replace "ConfigRadio->LevelTX" "ConfigRadio->Init.LevelTX"
ttc_manage.pl replace "ConfigRadio->MaxPacketSize" "ConfigRadio->Init.MaxPacketSize"
ttc_manage.pl replace "->WordLength" "->Init.WordLength"
ttc_manage.pl replace "->HalfStopBits" "->Init.HalfStopBits"
ttc_manage.pl replace "->activity_rx_isr" "->Init.activity_rx_isr"
ttc_manage.pl replace "->activity_tx_isr" "->Init.activity_tx_isr"
ttc_manage.pl replace "->receiveBlock" "->Init.receiveBlock"
ttc_manage.pl replace "->receiveSingleByte" "->Init.receiveSingleByte"
ttc_manage.pl replace "->BaudRate" "->Init.BaudRate"
ttc_manage.pl replace "->TimeOut" "->Init.TimeOut"
ttc_manage.pl replace "->CRC_Polynom" "->Init.CRC_Polynom"
ttc_manage.pl replace "->Pin_MOSI" "->Init.Pin_MOSI"
ttc_manage.pl replace "->Pin_MISO" "->Init.Pin_MISO"
ttc_manage.pl replace "->Pin_SCLK" "->Init.Pin_SCLK"
ttc_manage.pl replace "->Pins_NSS" "->Init.Pins_NSS"
ttc_manage.pl replace "Init.Flags.Initialized" "Flags.Initialized"
ttc_manage.pl replace "Config->Char_EndOfLine" "Config->Init.Char_EndOfLine"
ttc_manage.pl replace "ttc_math_rotate_3d_" "ttc_math_vector3d_rotate_"
ttc_manage.pl replace "ttc_math_rotate_2d" "ttc_math_vector2d_rotate"
ttc_manage.pl replace "math_length_3d" "math_vector3d_length"
ttc_manage.pl replace "math_distance_3d" "math_vector3d_distance"
ttc_manage.pl replace "math_interface_length_3d" "math_interface_vector3d_length"
ttc_manage.pl replace "math_interface_length_2d" "math_interface_vector2d_length"
ttc_manage.pl replace "_distance_3d" "_vector3d_distance"
ttc_manage.pl replace "_length_2d" "_vector2d_length"
ttc_manage.pl replace "_distance_2d" "_vector2d_distance"
ttc_manage.pl replace "_angle_2d" "_vector2d_angle"
ttc_manage.pl replace "_vector2d_distance" "_distance_2d"
ttc_manage.pl replace "_vector2d_length" "_length_2d"
ttc_manage.pl replace "rcrt_Request_SSTOF_" "rcrt_Request_SSTOFCR_"
ttc_manage.pl replace "rcrt_Reply_SSTOF_" "rcrt_Reply_SSTOFCR_"
ttc_manage.pl replace "ttc_radio_ranging_request_t" "ttc_radio_packet_request_sstof_t"
ttc_manage.pl replace "ttc_radio_basic_reply_t" "ttc_radio_packet_reply_ranging_t"
ttc_manage.pl replace "ttc_radio_ranging_header_t" "ttc_radio_packet_ranging_header_t"
ttc_manage.pl replace "ttc_radio_ranging_reply_t" "ttc_radio_packet_reply_sstof_t"
ttc_manage.pl replace "ttc_radio_localization_request_t" "ttc_radio_packet_reply_localization_sstofcr_t"
ttc_manage.pl replace "ttc_radio_packet_reply_localization_sstofcr_t" "ttc_radio_packet_request_localization_sstofcr_t"
ttc_manage.pl replace "ttc_radio_localization_reply_t" "ttc_radio_packet_reply_localization_sstofcr_t"
ttc_manage.pl replace "ttc_radio_localization_report_t" "ttc_radio_packet_report_localization_sstofcr_t"
ttc_manage.pl replace "ttc_radio_ranging_report_t" "ttc_radio_packet_report_ranging_sstof_t"
ttc_manage.pl replace "ttc_radio_packet_ranging_header_t" "ttc_radio_packet_ranging_t"
ttc_manage.pl replace "ttc_radio_packet_request_sstof" "ttc_radio_packet_request_ranging_sstof"
ttc_manage.pl replace "ttc_radio_packet_reply_sstof_t" "ttc_radio_packet_reply_ranging_sstof_t"
ttc_manage.pl replace "SSTOFCR_LocalizationRequest" "RequestLocalization_SSTOFCR"
ttc_manage.pl replace "SSTOF_RangingReport" "ReportRanging_SSTOF"
ttc_manage.pl replace "SSTOF_RangingReply" "Reply_Ranging_SSTOF"
ttc_manage.pl replace "SSTOF_RangingRequest" "Request_Ranging_SSTOF"
ttc_manage.pl replace "RequestLocalization_SSTOFCR" "Request_Localization_SSTOFCR"
ttc_manage.pl replace "SSTOFCR_LocalizationReply" "Reply_Localization_SSTOFCR"
ttc_manage.pl replace "SSTOFCR_LocalizationReport" "Report_Localization_SSTOFCR"
ttc_manage.pl replace "rcrt_Report_SSTOF_Localization" "rcrt_Report_SSTOFCR_Localization"
ttc_manage.pl replace "rcrt_Report_SSTOF_Ranging" "rcrt_Report_SSTOFCR_Ranging"
ttc_manage.pl replace "rcrt_Report_SSTOFCR_Ranging" "rcrt_Report_SSTOF_Ranging"
ttc_manage.pl replace "radio_common_ranging_request" "radio_common_ranging_transmit"
ttc_manage.pl replace "radio_common_ranging_transmit" "radio_common_ranging_measure"
ttc_manage.pl replace "TTM_NUMBER_MAX" "TTC_MATH_CONST_MAX_VALUE"
ttc_manage.pl replace "TTM_NUMBER_MIN" "TTC_MATH_CONST_MIN_VALUE"
ttc_manage.pl replace "TTM_NUMBER_" "TTC_MATH_CONST_"
ttc_manage.pl replace "TTC_MATH_CONST_MIN_VALUEUS_INFINITY" "TTC_MATH_CONST_MINUS_INFINITY"
ttc_manage.pl replace "ec_math_colinear_f2_f3" "ec_math_lateration3d_colinear_f2_f3"
ttc_manage.pl replace "ec_math_lateration_3d" "ec_math_lateration3d"
ttc_manage.pl replace "ec_math_lateration_2d" "ec_math_lateration2d"
ttc_manage.pl replace "ec_math_invalid_distance_on" "ec_math_lateration3d_distance_on"
ttc_manage.pl replace "ec_math_invalid_distance_f2n" "ec_math_lateration3d_distance_f2n"
ttc_manage.pl replace "ec_math_invalid_distance_f3n" "ec_math_lateration3d_distance_f3n"
ttc_manage.pl replace "ttc_radio_packet_free" "ttc_radio_packet_release"
ttc_manage.pl replace "radio_common_release_packet" "radio_common_packet_release"
ttc_manage.pl replace "2010-2016" "2010-2017"
ttc_manage.pl replace "EXTENSION_110_board_" "EXTENSION_board_"
ttc_manage.pl replace "EXTENSION_490_ttc_board" "EXTENSION_ttc_board"
ttc_manage.pl replace "EXTENSION_450_" "EXTENSION_"
ttc_manage.pl replace "EXTENSION_500_" "EXTENSION_"
ttc_manage.pl replace "TTC_RADIO_MAX_AMOUNT_PACKETS" "TTC_RADIO_INITIAL_AMOUNT_PACKETS"
ttc_manage.pl replace "ttc_radio_new_user" "ttc_radio_user_new"
ttc_manage.pl replace "ec_radio_RadioLocked" "ec_radio_IsLocked"
ttc_manage.pl replace "1\.Payload" "1\.Payload\.Raw"
ttc_manage.pl replace "1\\.Payload\\.Raw" "1.Payload.Raw"
ttc_manage.pl replace "0\.Payload" "0.Payload.Raw"
ttc_manage.pl replace "->Amount_Tx" "->Statistics.Amount_Tx"
ttc_manage.pl replace "->Amount_Rx" "->Statistics.Amount_Rx"
ttc_manage.pl replace "->Amount_DroppedRx" "->Statistics.Amount_DroppedRx"
ttc_manage.pl replace "->Amount_DroppedTx" "->Statistics.Amount_DroppedTx"
ttc_manage.pl replace "->Amount_FailedCRC" "->Statistics.Amount_FailedCRC"
ttc_manage.pl replace "->Amount_ReceiverRestart" "->Statistics.Amount_ReceiverRestart"
ttc_manage.pl replace "TTC_RADIO_COUNT" "RADIO_COMMON_COUNT"
ttc_manage.pl replace "tpp_" "ttc_packet_protocol_"
ttc_manage.pl replace "tpc_" "ttc_packet_category_"
ttc_manage.pl replace "tpt_" "ttc_packet_type_"
ttc_manage.pl replace "ttc_packet_category_none" "ttc_packet_category_None"
ttc_manage.pl replace "ttc_packet_category_beacon" "ttc_packet_category_Beacon"
ttc_manage.pl replace "ttc_packet_category_data" "ttc_packet_category_Data"
ttc_manage.pl replace "ttc_packet_category_command" "ttc_packet_category_Command"
ttc_manage.pl replace "ttc_packet_category_acknowledgement" "ttc_packet_category_Acknowledgement"
ttc_manage.pl replace "ttc_packet_category_unknown" "ttc_packet_category_Unknown"
ttc_manage.pl replace "tpaf_" "ttc_packet_address_"
ttc_manage.pl replace "ttc_packet_address_source16" "ttc_packet_address_Source16"
ttc_manage.pl replace "ttc_packet_address_target16" "ttc_packet_address_Target16"
ttc_manage.pl replace "ttc_packet_address_source16_sourcepan16" "ttc_packet_address_Source16_Sourcepan16"
ttc_manage.pl replace "ttc_packet_address_source16_target16" "ttc_packet_address_Source16_Target16"
ttc_manage.pl replace "ttc_packet_address_source16_targetpan16" "ttc_packet_address_Source16_Targetpan16"
ttc_manage.pl replace "ttc_packet_address_source64" "ttc_packet_address_Source64"
ttc_manage.pl replace "ttc_packet_address_target64" "ttc_packet_address_Target64"
ttc_manage.pl replace "ttc_packet_address_source16_target64" "ttc_packet_address_Source16_Target64"
ttc_manage.pl replace "ttc_packet_address_Source16_target16_sourcepan16_targetpan16" "ttc_packet_address_Source16_Target16_Sourcepan16_Targetpan16"
ttc_manage.pl replace "ttc_packet_address_Source16_target64_sourcepan16_targetpan16" "ttc_packet_address_Source16_Target64_Sourcepan16_Targetpan16"
ttc_manage.pl replace "ttc_packet_address_Source64_target16_sourcepan16_targetpan16" "ttc_packet_address_Source64_Target16_Sourcepan16_Targetpan16"
ttc_manage.pl replace "ttc_packet_address_Source64_target64_sourcepan16_targetpan16" "ttc_packet_address_Source64_Target64_Sourcepan16_Targetpan16"
ttc_manage.pl replace "ttc_packet_address_Source64_target16_targetpan16" "ttc_packet_address_Source64_Target16_Targetpan16"
ttc_manage.pl replace "ttc_packet_address_Source16_target64_targetpan16" "ttc_packet_address_Source16_Target64_Targetpan16"
ttc_manage.pl replace "ttc_packet_address_Source64_target64_targetpan16" "ttc_packet_address_Source64_Target64_Targetpan16"
ttc_manage.pl replace "ttc_packet_address_Source16_target16_targetpan16" "ttc_packet_address_Source16_Target16_targetpan16"
ttc_manage.pl replace "ttc_packet_address_Source16_sourcepan16" "ttc_packet_address_Source16_Sourcepan16"
ttc_manage.pl replace "ttc_packet_address_Source16_target16" "ttc_packet_address_Source16_Target16"
ttc_manage.pl replace "ttc_packet_address_Source16_targetpan16" "ttc_packet_address_Source16_Targetpan16"
ttc_manage.pl replace "ttc_packet_address_Target16_targetpan16" "ttc_packet_address_Target16_Targetpan16"
ttc_manage.pl replace "ttc_packet_address_Source64_target64" "ttc_packet_address_Source64_Target64"
ttc_manage.pl replace "ttc_packet_address_Source16_target64" "ttc_packet_address_Source16_Target64"
ttc_manage.pl replace "ttc_packet_address_Target64_targetpan16" "ttc_packet_address_Target64_Targetpan16"
ttc_manage.pl replace "ttc_packet_address_Source64_target16" "ttc_packet_address_Source64_Target16"
ttc_manage.pl replace "ttc_packet_address_Source64_targetpan16" "ttc_packet_address_Source64_Targetpan16"
ttc_manage.pl replace "ttc_packet_address_Source16_Target16_targetpan16" "ttc_packet_address_Source16_Target16_Targetpan16"
ttc_manage.pl replace "ttc_packet_type_802154_mhr_" "ttc_packet_type_802154_MHR_"
ttc_manage.pl replace "ttc_packet_type_802154_data_" "ttc_packet_type_802154_Data_"
ttc_manage.pl replace "ttc_packet_type_802154_command_" "ttc_packet_type_802154_Command_"
ttc_manage.pl replace "ttc_packet_type_802154_beacon_" "ttc_packet_type_802154_Beacon_"
ttc_manage.pl replace "ttc_packet_type_802154_unknown" "ttc_packet_type_802154_Unknown"
ttc_manage.pl replace "ttc_packet_address_none" "ttc_packet_address_None"
ttc_manage.pl replace "ttc_packet_protocol_Application" "ttc_packet_protocol_AnyOf_Application"
ttc_manage.pl replace "ttc_packet_protocol_NonApplication" "ttc_packet_protocol_AnyOf_NonApplication"
ttc_manage.pl replace "ttc_packet_protocol_Radio" "ttc_packet_protocol_AnyOf_Radio"
ttc_manage.pl replace "ttc_packet_protocol_NonRadio" "ttc_packet_protocol_AnyOf_NonRadio"
ttc_manage.pl replace "ttc_packet_protocol_Begin_Special" "ttc_packet_protocol_Begin_AnyOf"
ttc_manage.pl replace "ttc_packet_protocol_End_Special" "ttc_packet_protocol_End_AnyOf"
ttc_manage.pl replace "ttc_packet_protocol_AnyOf_Application1" "ttc_packet_protocol_Application1"
ttc_manage.pl replace "ttc_packet_protocol_AnyOf_Application2" "ttc_packet_protocol_Application2"
ttc_manage.pl replace "ttc_packet_protocol_AnyOf_Application3" "ttc_packet_protocol_Application3"
ttc_manage.pl replace "ttc_packet_protocol_AnyOf_Application4" "ttc_packet_protocol_Application4"
ttc_manage.pl replace "ttc_packet_protocol_AnyOf_Application5" "ttc_packet_protocol_Application5"
ttc_manage.pl replace "ttc_packet_protocol_AnyOf_Application6" "ttc_packet_protocol_Application6"
ttc_manage.pl replace "ttc_packet_protocol_AnyOf_Application7" "ttc_packet_protocol_Application7"
ttc_manage.pl replace "ttc_packet_protocol_AnyOf_Application8" "ttc_packet_protocol_Application8"
ttc_manage.pl replace "ttc_packet_protocol_AnyOf_Application9" "ttc_packet_protocol_Application9"
ttc_manage.pl replace "ttc_packet_protocol_AnyOf_RadioRanging" "ttc_packet_protocol_Radio_Ranging"
ttc_manage.pl replace "ttc_packet_protocol_SlamRadio" "ttc_packet_protocol_Radio_SlamRadio"
ttc_manage.pl replace "release_packet" "packet_release"
ttc_manage.pl replace "ttc_radio_received_packet_" "ttc_radio_packet_received_"
ttc_manage.pl replace "radio_get_empty_packet" "radio_packet_get_empty"
ttc_manage.pl replace "radio_common_get_empty_packet" "radio_common_packet_get_empty"
ttc_manage.pl replace "radio_received_packets_" "radio_packets_received_"
ttc_manage.pl replace "radio_common_received_packets_" "radio_common_packets_received_"
ttc_manage.pl replace "radio_common_received_packet_" "radio_common_packet_received_"
ttc_manage.pl replace "ttc_packet_check_protocol" "ttc_packet_protocol_check"
ttc_manage.pl replace "ttc_packet_get_protocol" "ttc_packet_protocol_get"
ttc_manage.pl replace "rcrt_Request_SSTOF_Ranging" "rcrt_Request_Ranging_SSTOF"
ttc_manage.pl replace "rcrt_Request_SSTOFCR_Ranging" "rcrt_Request_Ranging_SSTOFCR"
ttc_manage.pl replace "rcrt_Reply_SSTOFCR_Ranging" "rcrt_Reply_Ranging_SSTOFCR"
ttc_manage.pl replace "rcrt_Reply_SSTOF_Ranging" "rcrt_Reply_Ranging_SSTOF"
ttc_manage.pl replace "rcrt_Request_SSTOFCR_Localization" "rcrt_Request_Localization_SSTOFCR"
ttc_manage.pl replace "rcrt_Reply_SSTOFCR_Localization" "rcrt_Reply_Localization_SSTOFCR"
ttc_manage.pl replace "rcrt_Report_SSTOFCR_Localization" "rcrt_Report_Localization_SSTOFCR"
ttc_manage.pl replace "rcrt_Report_SSTOF_Ranging" "rcrt_Report_Ranging_SSTOF"
ttc_manage.pl replace "slamradio" "rtls"
ttc_manage.pl replace "SlamRadio" "RTLS"
ttc_manage.pl replace "SLAMRADIO" "RTLS"
ttc_manage.pl replace "Timeout_usecs" "Timeout_Transceiver_usecs"
ttc_manage.pl replace "packet_compare_target" "packet_target_compare"
ttc_manage.pl replace "packet_compare_source" "packet_source_compare"
ttc_manage.pl replace "packet_get_pointer_source" "packet_source_get_pointer"
ttc_manage.pl replace "packet_get_pointer_target" "packet_target_get_pointer"
ttc_manage.pl replace "packet_set_target" "packet_target_set"
ttc_manage.pl replace "packet_set_source" "packet_source_set"
ttc_manage.pl replace "packet_interface_set_source" "packet_interface_source_set"
ttc_manage.pl replace "packet_interface_set_target" "packet_interface_target_set"
ttc_manage.pl replace "packet_interface_get_pointer_target" "packet_interface_target_get_pointer"
ttc_manage.pl replace "packet_interface_get_pointer_source" "packet_interface_source_get_pointer"
ttc_manage.pl replace "packet_interface_compare_source" "packet_interface_source_compare"
ttc_manage.pl replace "packet_interface_compare_target" "packet_interface_target_compare"
ttc_manage.pl replace "get_pointer_payload" "payload_get_pointer"
ttc_manage.pl replace "get_payload_size" "payload_get_size"
ttc_manage.pl replace "set_payload_size" "payload_set_size"
ttc_manage.pl replace "get_size_mac_header" "mac_header_get_size"
ttc_manage.pl replace "extract_source" "source_extract"
ttc_manage.pl replace "extract_target" "target_extract"
ttc_manage.pl replace "Timeout_Acknowledge_usecs" "Acknowledge_Timeout_usecs"
ttc_manage.pl replace "Timeout_Transceiver_usecs" "Transceiver_Timeout_usecs"
ttc_manage.pl replace "Acknowledge_Amount_Retries" "Transmit_Amount_Retries"
ttc_manage.pl replace "#include "../examples/" "#include "examples/"
ttc_manage.pl replace "_frame_filter" "_configure_frame_filter"
ttc_manage.pl replace "ttc_radio_configure_frame_filter_u" "ttc_radio_frame_filter_u"
ttc_manage.pl replace "_switch_channel" "_configure_channel"
ttc_manage.pl replace "ttc_radio_configure_frame_filter_read" "ttc_radio_frame_filter_read"
ttc_manage.pl replace "ttc_radio_configure_frame_filter_disable" "ttc_radio_frame_filter_disable"
ttc_manage.pl replace "ttc_radio_configure_frame_filter_coordinator" "ttc_radio_frame_filter_coordinator"
ttc_manage.pl replace "ttc_radio_configure_frame_filter_sensor" "ttc_radio_frame_filter_sensor"
ttc_manage.pl replace "ttc_radio_configure_frame_filter_beacon" "ttc_radio_frame_filter_beacon"
ttc_manage.pl replace "ttc_radio_configure_frame_filter_data" "ttc_radio_frame_filter_data"
ttc_manage.pl replace "ttc_radio_configure_frame_filter_ack" "ttc_radio_frame_filter_ack"
ttc_manage.pl replace "ttc_radio_configure_frame_filter_mac" "ttc_radio_frame_filter_mac"
ttc_manage.pl replace "ttc_radio_configure_frame_filter_reserved" "ttc_radio_frame_filter_reserved"
ttc_manage.pl replace "_target_compare" "_address_target_compare"
ttc_manage.pl replace "_target_get" "_address_target_get"
ttc_manage.pl replace "_target_set" "_address_target_set"
ttc_manage.pl replace "_source_compare" "_address_source_compare"
ttc_manage.pl replace "_source_get" "_address_source_get"
ttc_manage.pl replace "_source_set" "_address_source_set"
ttc_manage.pl replace "_create_reply_address" "_address_swap"
ttc_manage.pl replace "_address_swap" "_address_reply"
ttc_manage.pl replace "_acknowlege_" "_acknowlege_request_"
ttc_manage.pl replace "acknowlege" "acknowledge"
ttc_manage.pl replace "ttc_packet_protocol_e" "ttc_packet_pattern_e"
ttc_manage.pl replace "ttc_packet_protocol_" "ttc_packet_pattern_protocol_"
ttc_manage.pl replace "ttc_packet_pattern_protocol_Acknowledge" "ttc_packet_pattern_type_Acknowledge"
ttc_manage.pl replace "ttc_packet_pattern_protocol_check" "ttc_packet_pattern_matches"
ttc_manage.pl replace "_pattern_protocol_matches" "_pattern_matches_protocol"
ttc_manage.pl replace "_pattern_type_matches" "_pattern_matches_type"
ttc_manage.pl replace "ttc_packet_pattern_protocol_get" "ttc_packet_protocol_get"
ttc_manage.pl replace "radio_common_pop_list_rx" "radio_common_pop_list_rx_try"
ttc_manage.pl replace "accelerometer_bno055_config_t" "t_accelerometer_bno055_config"
ttc_manage.pl replace "accelerometer_lis3lv02dl_config_t" "t_accelerometer_lis3lv02dl_config"
ttc_manage.pl replace "accelerometer_lis3lv02dlr_registers_t" "t_accelerometer_lis3lv02dlr_registers"
ttc_manage.pl replace "accelerometer_mpu6050_config_t" "t_accelerometer_mpu6050_config"
ttc_manage.pl replace "accelerometer_mpu6050_registers_t" "t_accelerometer_mpu6050_registers"
ttc_manage.pl replace "ACCELEROMETER_Register_t" "t_accelerometer_register"
ttc_manage.pl replace "ADC_Register_t" "t_adc_register"
ttc_manage.pl replace "adc_stm32f1xx_config_t" "t_adc_stm32f1xx_config"
ttc_manage.pl replace "adc_stm32f1xx_device_t" "t_adc_stm32f1xx_device"
ttc_manage.pl replace "adc_stm32l1xx_config_t" "t_adc_stm32l1xx_config"
ttc_manage.pl replace "AFIO_EVCR_t" "t_afio_evcr"
ttc_manage.pl replace "afio_event_pin_e" "e_afio_event_pin"
ttc_manage.pl replace "afio_event_port_e" "e_afio_event_port"
ttc_manage.pl replace "AFIO_EXTICR1_t" "t_afio_exticr1"
ttc_manage.pl replace "AFIO_EXTICR2_t" "t_afio_exticr2"
ttc_manage.pl replace "AFIO_EXTICR3_t" "t_afio_exticr3"
ttc_manage.pl replace "AFIO_EXTICR4_t" "t_afio_exticr4"
ttc_manage.pl replace "BaseRegister_output_compare_mode_t" "t_baseregister_output_compare_mode"
ttc_manage.pl replace "Base_t" "t_base"
ttc_manage.pl replace "basic_cm3_config_t" "t_basic_cm3_config"
ttc_manage.pl replace "BASIC_Register_t" "t_basic_register"
ttc_manage.pl replace "basic_stm32f1xx_config_t" "t_basic_stm32f1xx_config"
ttc_manage.pl replace "basic_stm32l0xx_config_t" "t_basic_stm32l0xx_config"
ttc_manage.pl replace "board_stm32l100c_discovery_config_t" "t_board_stm32l100c_discovery_config"
ttc_manage.pl replace "board_stm32l152_discovery_config_t" "t_board_stm32l152_discovery_config"
ttc_manage.pl replace "CAN_Register_t" "t_can_register"
ttc_manage.pl replace "can_stm32f1xx_config_t" "t_can_stm32f1xx_config"
ttc_manage.pl replace "CFGR2_t" "t_cfgr2"
ttc_manage.pl replace "CFGR_HPRE_e" "e_cfgr_hpre"
ttc_manage.pl replace "CFGR_MCOPRE_e" "e_cfgr_mcopre"
ttc_manage.pl replace "CFGR_MCOSEL_e" "e_cfgr_mcosel"
ttc_manage.pl replace "CFGR_PPRE1_e" "e_cfgr_ppre1"
ttc_manage.pl replace "CFGR_SW_e" "e_cfgr_sw"
ttc_manage.pl replace "CFGR_SWS_e" "e_cfgr_sws"
ttc_manage.pl replace "clock_time_t" "t_clock_time"
ttc_manage.pl replace "cm0_Semaphore_t" "t_cm0_semaphore"
ttc_manage.pl replace "cm3_Semaphore_t" "t_cm3_semaphore"
ttc_manage.pl replace "ConfigLED_t" "t_configled"
ttc_manage.pl replace "config_t" "t_config"
ttc_manage.pl replace "CPU_Register_t" "t_cpu_register"
ttc_manage.pl replace "dac_Register_t" "t_dac_register"
ttc_manage.pl replace "DAC_Register_t" "t_dac_register"
ttc_manage.pl replace "DAC_stm32l1_mask_or_amplitude_e" "e_dac_stm32l1_mask_or_amplitude"
ttc_manage.pl replace "DAC_stm32l1_output_buffer_e" "e_dac_stm32l1_output_buffer"
ttc_manage.pl replace "DAC_stm32l1_trigger_source_e" "e_dac_stm32l1_trigger_source"
ttc_manage.pl replace "DAC_stm32l1_wave_gen_e" "e_dac_stm32l1_wave_gen"
ttc_manage.pl replace "dac_stm32l1xx_mask_or_amplitude_e" "e_dac_stm32l1xx_mask_or_amplitude"
ttc_manage.pl replace "dac_stm32l1xx_output_buffer_e" "e_dac_stm32l1xx_output_buffer"
ttc_manage.pl replace "dac_stm32l1xx_trigger_source_e" "e_dac_stm32l1xx_trigger_source"
ttc_manage.pl replace "dac_stm32l1xx_wave_e" "e_dac_stm32l1xx_wave"
ttc_manage.pl replace "dac_stm32l1xx_wave_gen_e" "e_dac_stm32l1xx_wave_gen"
ttc_manage.pl replace "DMA_Register_t" "t_dma_register"
ttc_manage.pl replace "ETHERNET_Register_t" "t_ethernet_register"
ttc_manage.pl replace "et_PrintJob_t" "t_et_printjob"
ttc_manage.pl replace "Events_t" "t_events"
ttc_manage.pl replace "example_i2c_t" "t_example_i2c"
ttc_manage.pl replace "example_ttc_rtls_crtof_simple_2d_data_t" "t_example_ttc_rtls_crtof_simple_2d_data"
ttc_manage.pl replace "field_length_t" "t_field_length"
ttc_manage.pl replace "frame802154_aux_hdr_t" "t_frame802154_aux_hdr"
ttc_manage.pl replace "frame802154_fcf_t" "t_frame802154_fcf"
ttc_manage.pl replace "frame802154_scf_t" "t_frame802154_scf"
ttc_manage.pl replace "frame802154_t" "t_frame802154"
ttc_manage.pl replace "GFX_Register_t" "t_gfx_register"
ttc_manage.pl replace "gni_mt_NumberArea_t" "t_gni_mt_numberarea"
ttc_manage.pl replace "gni_NumberArea_t" "t_gni_numberarea"
ttc_manage.pl replace "gpio_interrupt_source_e" "e_gpio_interrupt_source"
ttc_manage.pl replace "gpio_port_input_e" "e_gpio_port_input"
ttc_manage.pl replace "gpio_port_mode_e" "e_gpio_port_mode"
ttc_manage.pl replace "gpio_port_output_e" "e_gpio_port_output"
ttc_manage.pl replace "GPIO_Register_t" "t_gpio_register"
ttc_manage.pl replace "gpio_stm32f1xx_alternate_function_e" "e_gpio_stm32f1xx_alternate_function"
ttc_manage.pl replace "gpio_stm32f1xx_bank_e" "e_gpio_stm32f1xx_bank"
ttc_manage.pl replace "gpio_stm32f1xx_mode_e" "e_gpio_stm32f1xx_mode"
ttc_manage.pl replace "gpio_stm32f1xx_pin_e" "e_gpio_stm32f1xx_pin"
ttc_manage.pl replace "gpio_stm32f1xx_values_t" "t_gpio_stm32f1xx_values"
ttc_manage.pl replace "gpio_stm32l0xx_bank_e" "e_gpio_stm32l0xx_bank"
ttc_manage.pl replace "gpio_stm32l0xx_pin_e" "e_gpio_stm32l0xx_pin"
ttc_manage.pl replace "gpio_stm32l0xx_values_t" "t_gpio_stm32l0xx_values"
ttc_manage.pl replace "gpio_stm32l1xx_alternate_function_e" "e_gpio_stm32l1xx_alternate_function"
ttc_manage.pl replace "gpio_stm32l1xx_bank_e" "e_gpio_stm32l1xx_bank"
ttc_manage.pl replace "gpio_stm32l1xx_mode_e" "e_gpio_stm32l1xx_mode"
ttc_manage.pl replace "gpio_stm32l1xx_pin_e" "e_gpio_stm32l1xx_pin"
ttc_manage.pl replace "gpio_stm32l1xx_pull_e" "e_gpio_stm32l1xx_pull"
ttc_manage.pl replace "gpio_stm32l1xx_values_t" "t_gpio_stm32l1xx_values"
ttc_manage.pl replace "gpio_stm32w1xx_alternate_function_e" "e_gpio_stm32w1xx_alternate_function"
ttc_manage.pl replace "gpio_stm32w1xx_bank_e" "e_gpio_stm32w1xx_bank"
ttc_manage.pl replace "gpio_stm32w1xx_pin_e" "e_gpio_stm32w1xx_pin"
ttc_manage.pl replace "gpio_stm32w1xx_values_t" "t_gpio_stm32w1xx_values"
ttc_manage.pl replace "GPIOx_BRR_t" "t_gpiox_brr"
ttc_manage.pl replace "GPIOx_BSRR_t" "t_gpiox_bsrr"
ttc_manage.pl replace "GPIOx_CRH_t" "t_gpiox_crh"
ttc_manage.pl replace "GPIOx_CRL_t" "t_gpiox_crl"
ttc_manage.pl replace "GPIOx_IDR_t" "t_gpiox_idr"
ttc_manage.pl replace "GPIOx_LCKR_t" "t_gpiox_lckr"
ttc_manage.pl replace "GPIOx_ODR_t" "t_gpiox_odr"
ttc_manage.pl replace "gui_Keyboard_t" "t_gui_keyboard"
ttc_manage.pl replace "gui_mt_Keyboard_t" "t_gui_mt_keyboard"
ttc_manage.pl replace "gyroscope_mpu6050_registers_t" "t_gyroscope_mpu6050_registers"
ttc_manage.pl replace "GYROSCOPE_Register_t" "t_gyroscope_register"
ttc_manage.pl replace "HEAP_Register_t" "t_heap_register"
ttc_manage.pl replace "I2C_OAR1_10b_t" "t_i2c_oar1_10b"
ttc_manage.pl replace "I2C_OAR1_7b_t" "t_i2c_oar1_7b"
ttc_manage.pl replace "I2C_Register_t" "t_i2c_register"
ttc_manage.pl replace "i2c_stm32l1xx_event_e" "e_i2c_stm32l1xx_event"
ttc_manage.pl replace "i2c_stm32l1xx_flag_sr1_e" "e_i2c_stm32l1xx_flag_sr1"
ttc_manage.pl replace "i2c_stm32l1xx_flag_sr2_e" "e_i2c_stm32l1xx_flag_sr2"
ttc_manage.pl replace "input_helper_list_t" "t_input_helper_list"
ttc_manage.pl replace "input_helper_types_e" "e_input_helper_types"
ttc_manage.pl replace "int16_t" "t_int16"
ttc_manage.pl replace "int32_t" "t_int32"
ttc_manage.pl replace "int8_t" "t_int8"
ttc_manage.pl replace "INTERFACE_Register_t" "t_interface_register"
ttc_manage.pl replace "interrupt_cortexm3_interrupt_faults_t" "t_interrupt_cortexm3_interrupt_faults"
ttc_manage.pl replace "interrupt_gpio_register_t" "t_interrupt_gpio_register"
ttc_manage.pl replace "INTERRUPT_Register_t" "t_interrupt_register"
ttc_manage.pl replace "interrupt_stm32l1xx_config_gpio_t" "t_interrupt_stm32l1xx_config_gpio"
ttc_manage.pl replace "interrupt_stm32l1xx_config_i2c_t" "t_interrupt_stm32l1xx_config_i2c"
ttc_manage.pl replace "interrupt_stm32l1xx_config_usart_t" "t_interrupt_stm32l1xx_config_usart"
ttc_manage.pl replace "interrupt_stm32w1xx_gpio_t" "t_interrupt_stm32w1xx_gpio"
ttc_manage.pl replace "interrupt_stm32w_interrupt_lines_e" "e_interrupt_stm32w_interrupt_lines"
ttc_manage.pl replace "LAYER_PHY_Register_t" "t_layer_phy_register"
ttc_manage.pl replace "MAC_Register_t" "t_mac_register"
ttc_manage.pl replace "math_double_t" "t_math_double"
ttc_manage.pl replace "math_float_t" "t_math_float"
ttc_manage.pl replace "MEMORY_Register_t" "t_memory_register"
ttc_manage.pl replace "my_my_state_number_e" "e_my_my_state_number"
ttc_manage.pl replace "my_state_number_e" "e_my_state_number"
ttc_manage.pl replace "my_states_data_t" "t_my_states_data"
ttc_manage.pl replace "my_type_t" "t_my_type"
ttc_manage.pl replace "name_e" "e_name"
ttc_manage.pl replace "NETWORK_LAYER_Register_t" "t_network_layer_register"
ttc_manage.pl replace "NETWORK_Register_t" "t_network_register"
ttc_manage.pl replace "packet_802154_ack_000000_t" "t_packet_802154_ack_000000"
ttc_manage.pl replace "packet_802154_auxiliary_security_s00_t" "t_packet_802154_auxiliary_security_s00"
ttc_manage.pl replace "packet_802154_auxiliary_security_s01_t" "t_packet_802154_auxiliary_security_s01"
ttc_manage.pl replace "packet_802154_auxiliary_security_s10_t" "t_packet_802154_auxiliary_security_s10"
ttc_manage.pl replace "packet_802154_auxiliary_security_s11_t" "t_packet_802154_auxiliary_security_s11"
ttc_manage.pl replace "packet_802154_beacon_000010_t" "t_packet_802154_beacon_000010"
ttc_manage.pl replace "packet_802154_beacon_000011_t" "t_packet_802154_beacon_000011"
ttc_manage.pl replace "packet_802154_beacon_address_spec_t" "t_packet_802154_beacon_address_spec"
ttc_manage.pl replace "packet_802154_beacon_gts_descriptor_t" "t_packet_802154_beacon_gts_descriptor"
ttc_manage.pl replace "packet_802154_beacon_gts_directions_t" "t_packet_802154_beacon_gts_directions"
ttc_manage.pl replace "packet_802154_beacon_gts_spec_t" "t_packet_802154_beacon_gts_spec"
ttc_manage.pl replace "packet_802154_beacon_superframe_spec_t" "t_packet_802154_beacon_superframe_spec"
ttc_manage.pl replace "packet_802154_command_000010_t" "t_packet_802154_command_000010"
ttc_manage.pl replace "packet_802154_command_000011_t" "t_packet_802154_command_000011"
ttc_manage.pl replace "packet_802154_command_001000_t" "t_packet_802154_command_001000"
ttc_manage.pl replace "packet_802154_command_001010_t" "t_packet_802154_command_001010"
ttc_manage.pl replace "packet_802154_command_001100_t" "t_packet_802154_command_001100"
ttc_manage.pl replace "packet_802154_command_001110_t" "t_packet_802154_command_001110"
ttc_manage.pl replace "packet_802154_command_001111_t" "t_packet_802154_command_001111"
ttc_manage.pl replace "packet_802154_command_011000_t" "t_packet_802154_command_011000"
ttc_manage.pl replace "packet_802154_command_011010_t" "t_packet_802154_command_011010"
ttc_manage.pl replace "packet_802154_command_011100_t" "t_packet_802154_command_011100"
ttc_manage.pl replace "packet_802154_command_011110_t" "t_packet_802154_command_011110"
ttc_manage.pl replace "packet_802154_command_011111_t" "t_packet_802154_command_011111"
ttc_manage.pl replace "packet_802154_data_000010_t" "t_packet_802154_data_000010"
ttc_manage.pl replace "packet_802154_data_000011_t" "t_packet_802154_data_000011"
ttc_manage.pl replace "packet_802154_data_001000_t" "t_packet_802154_data_001000"
ttc_manage.pl replace "packet_802154_data_001010_t" "t_packet_802154_data_001010"
ttc_manage.pl replace "packet_802154_data_001100_t" "t_packet_802154_data_001100"
ttc_manage.pl replace "packet_802154_data_001110_t" "t_packet_802154_data_001110"
ttc_manage.pl replace "packet_802154_data_001111_t" "t_packet_802154_data_001111"
ttc_manage.pl replace "packet_802154_data_011000_t" "t_packet_802154_data_011000"
ttc_manage.pl replace "packet_802154_data_011010_t" "t_packet_802154_data_011010"
ttc_manage.pl replace "packet_802154_data_011100_t" "t_packet_802154_data_011100"
ttc_manage.pl replace "packet_802154_data_011110_t" "t_packet_802154_data_011110"
ttc_manage.pl replace "packet_802154_data_011111_t" "t_packet_802154_data_011111"
ttc_manage.pl replace "packet_802154_fcf_address_type_e" "e_packet_802154_fcf_address_type"
ttc_manage.pl replace "packet_802154_fcf_frame_type_e" "e_packet_802154_fcf_frame_type"
ttc_manage.pl replace "packet_802154_fcf_frame_version_e" "e_packet_802154_fcf_frame_version"
ttc_manage.pl replace "packet_802154_generic_t" "t_packet_802154_generic"
ttc_manage.pl replace "packet_802154_key_identifier_mode_e" "e_packet_802154_key_identifier_mode"
ttc_manage.pl replace "packet_802154_mac_t" "t_packet_802154_mac"
ttc_manage.pl replace "packet_802154_meta_t" "t_packet_802154_meta"
ttc_manage.pl replace "packet_802154_mhr_000010_t" "t_packet_802154_mhr_000010"
ttc_manage.pl replace "packet_802154_mhr_000011_t" "t_packet_802154_mhr_000011"
ttc_manage.pl replace "packet_802154_mhr_001000_t" "t_packet_802154_mhr_001000"
ttc_manage.pl replace "packet_802154_mhr_001010_t" "t_packet_802154_mhr_001010"
ttc_manage.pl replace "packet_802154_mhr_001100_t" "t_packet_802154_mhr_001100"
ttc_manage.pl replace "packet_802154_mhr_001110_t" "t_packet_802154_mhr_001110"
ttc_manage.pl replace "packet_802154_mhr_001111_t" "t_packet_802154_mhr_001111"
ttc_manage.pl replace "packet_802154_mhr_010010_t" "t_packet_802154_mhr_010010"
ttc_manage.pl replace "packet_802154_mhr_010011_t" "t_packet_802154_mhr_010011"
ttc_manage.pl replace "packet_802154_mhr_011000_t" "t_packet_802154_mhr_011000"
ttc_manage.pl replace "packet_802154_mhr_011010_t" "t_packet_802154_mhr_011010"
ttc_manage.pl replace "packet_802154_mhr_011100_t" "t_packet_802154_mhr_011100"
ttc_manage.pl replace "packet_802154_mhr_011110_t" "t_packet_802154_mhr_011110"
ttc_manage.pl replace "packet_802154_mhr_011111_t" "t_packet_802154_mhr_011111"
ttc_manage.pl replace "packet_802154_security_level_e" "e_packet_802154_security_level"
ttc_manage.pl replace "packetbuf_attr_t" "t_packetbuf_attr"
ttc_manage.pl replace "packet_common_types_list_t" "t_packet_common_types_list"
ttc_manage.pl replace "packet_common_types_types_e" "e_packet_common_types_types"
ttc_manage.pl replace "pEnetDmaDesc_t" "t_penetdmadesc"
ttc_manage.pl replace "PHR_t" "t_phr"
ttc_manage.pl replace "pRecDesc0_t" "t_precdesc0"
ttc_manage.pl replace "pRecDesc1_t" "t_precdesc1"
ttc_manage.pl replace "process_data_t" "t_process_data"
ttc_manage.pl replace "process_event_t" "t_process_event"
ttc_manage.pl replace "process_num_events_t" "t_process_num_events"
ttc_manage.pl replace "pTranDesc0_t" "t_ptrandesc0"
ttc_manage.pl replace "pTranDesc1_t" "t_ptrandesc1"
ttc_manage.pl replace "PWM_Cfg_t" "t_pwm_cfg"
ttc_manage.pl replace "PWM_Command_e" "e_pwm_command"
ttc_manage.pl replace "PWM_Status_t" "t_pwm_status"
ttc_manage.pl replace "PWM_TimerCfg_t" "t_pwm_timercfg"
ttc_manage.pl replace "PWR_Register_t" "t_pwr_register"
ttc_manage.pl replace "pwr_stm32l1xx_mode_e" "e_pwr_stm32l1xx_mode"
ttc_manage.pl replace "QueueItem_t" "t_queueitem"
ttc_manage.pl replace "radio_common_protocol_iterator_t" "t_radio_common_protocol_iterator"
ttc_manage.pl replace "radio_common_ranging_type_e" "e_radio_common_ranging_type"
ttc_manage.pl replace "radio_dw1000_chan_ctrl_rxprf_e" "e_radio_dw1000_chan_ctrl_rxprf"
ttc_manage.pl replace "radio_dw1000_changed_t" "t_radio_dw1000_changed"
ttc_manage.pl replace "radio_dw1000_channel_t" "t_radio_dw1000_channel"
ttc_manage.pl replace "radio_dw1000_clocking_scheme_e" "e_radio_dw1000_clocking_scheme"
ttc_manage.pl replace "radio_dw1000_clock_input_e" "e_radio_dw1000_clock_input"
ttc_manage.pl replace "radio_dw1000_datarates_e" "e_radio_dw1000_datarates"
ttc_manage.pl replace "radio_dw1000_frame_meta_t" "t_radio_dw1000_frame_meta"
ttc_manage.pl replace "radio_dw1000_max_payload_size_e" "e_radio_dw1000_max_payload_size"
ttc_manage.pl replace "radio_dw1000_otp_address_e" "e_radio_dw1000_otp_address"
ttc_manage.pl replace "radio_dw1000_otp_data_t" "t_radio_dw1000_otp_data"
ttc_manage.pl replace "radio_dw1000_otp_parameter_set_e" "e_radio_dw1000_otp_parameter_set"
ttc_manage.pl replace "radio_dw1000_pmsc_control_e" "e_radio_dw1000_pmsc_control"
ttc_manage.pl replace "radio_dw1000_pmsc_state_e" "e_radio_dw1000_pmsc_state"
ttc_manage.pl replace "radio_dw1000_preamble_configuration_e" "e_radio_dw1000_preamble_configuration"
ttc_manage.pl replace "radio_dw1000_pulse_repetition_frequency_e" "e_radio_dw1000_pulse_repetition_frequency"
ttc_manage.pl replace "radio_dw1000_register_e" "e_radio_dw1000_register"
ttc_manage.pl replace "radio_dw1000_registers_list_t" "t_radio_dw1000_registers_list"
ttc_manage.pl replace "radio_dw1000_registers_t" "t_radio_dw1000_registers"
ttc_manage.pl replace "radio_dw1000_rx_state_e" "e_radio_dw1000_rx_state"
ttc_manage.pl replace "radio_dw1000_spi_speed_e" "e_radio_dw1000_spi_speed"
ttc_manage.pl replace "radio_dw1000_status_isr_e" "e_radio_dw1000_status_isr"
ttc_manage.pl replace "radio_dw1000_transaction_t" "t_radio_dw1000_transaction"
ttc_manage.pl replace "radio_dw1000_transmit_power_t" "t_radio_dw1000_transmit_power"
ttc_manage.pl replace "radio_dw1000_tx_state_e" "e_radio_dw1000_tx_state"
ttc_manage.pl replace "radio_dw1000_virtual_channel_e" "e_radio_dw1000_virtual_channel"
ttc_manage.pl replace "radio_foo_virtualchannel_e" "e_radio_foo_virtualchannel"
ttc_manage.pl replace "RCC_ICSR_MSIRANGE_e" "e_rcc_icsr_msirange"
ttc_manage.pl replace "REAL_TIME_CLOCK_Register_t" "t_real_time_clock_register"
ttc_manage.pl replace "register_cortexm3_actlr_t" "t_register_cortexm3_actlr"
ttc_manage.pl replace "register_cortexm3_AIRCR_PRIGROUP_e" "e_register_cortexm3_aircr_prigroup"
ttc_manage.pl replace "register_cortexm3_calib_t" "t_register_cortexm3_calib"
ttc_manage.pl replace "register_cortexm3_ctrl_t" "t_register_cortexm3_ctrl"
ttc_manage.pl replace "register_cortexm3_load_t" "t_register_cortexm3_load"
ttc_manage.pl replace "register_cortexm3_NVIC_Interrupts0_t" "t_register_cortexm3_nvic_interrupts0"
ttc_manage.pl replace "register_cortexm3_NVIC_Interrupts1_t" "t_register_cortexm3_nvic_interrupts1"
ttc_manage.pl replace "register_cortexm3_NVIC_Interrupts2_t" "t_register_cortexm3_nvic_interrupts2"
ttc_manage.pl replace "register_cortexm3_NVIC_IP_t" "t_register_cortexm3_nvic_ip"
ttc_manage.pl replace "register_cortexm3_NVIC_STIR_t" "t_register_cortexm3_nvic_stir"
ttc_manage.pl replace "register_cortexm3_nvic_t" "t_register_cortexm3_nvic"
ttc_manage.pl replace "register_cortexm3_SCB_CCR_t" "t_register_cortexm3_scb_ccr"
ttc_manage.pl replace "register_cortexm3_SCB_CFSR_BFSR_t" "t_register_cortexm3_scb_cfsr_bfsr"
ttc_manage.pl replace "register_cortexm3_SCB_CFSR_MMFSR_t" "t_register_cortexm3_scb_cfsr_mmfsr"
ttc_manage.pl replace "register_cortexm3_SCB_CFSR_t" "t_register_cortexm3_scb_cfsr"
ttc_manage.pl replace "register_cortexm3_SCB_CFSR_UFSR_t" "t_register_cortexm3_scb_cfsr_ufsr"
ttc_manage.pl replace "register_cortexm3_SCB_HFSR_t" "t_register_cortexm3_scb_hfsr"
ttc_manage.pl replace "register_cortexm3_SCB_SCR_t" "t_register_cortexm3_scb_scr"
ttc_manage.pl replace "register_cortexm3_SCB_SHCSR_t" "t_register_cortexm3_scb_shcsr"
ttc_manage.pl replace "register_cortexm3_scb_t" "t_register_cortexm3_scb"
ttc_manage.pl replace "register_cortexm3_stk_t" "t_register_cortexm3_stk"
ttc_manage.pl replace "register_cortexm3_SYST_CALIB_t" "t_register_cortexm3_syst_calib"
ttc_manage.pl replace "register_cortexm3_SYST_CSR_t" "t_register_cortexm3_syst_csr"
ttc_manage.pl replace "register_cortexm3_SYST_CVR_t" "t_register_cortexm3_syst_cvr"
ttc_manage.pl replace "register_cortexm3_SYST_RVR_t" "t_register_cortexm3_syst_rvr"
ttc_manage.pl replace "register_cortexm3_val_t" "t_register_cortexm3_val"
ttc_manage.pl replace "REGISTER_Register_t" "t_register_register"
ttc_manage.pl replace "register_stm32f1xx_adc_cr1_t" "t_register_stm32f1xx_adc_cr1"
ttc_manage.pl replace "register_stm32f1xx_adc_cr2_t" "t_register_stm32f1xx_adc_cr2"
ttc_manage.pl replace "register_stm32f1xx_adc_dr_t" "t_register_stm32f1xx_adc_dr"
ttc_manage.pl replace "register_stm32f1xx_adc_htr_t" "t_register_stm32f1xx_adc_htr"
ttc_manage.pl replace "register_stm32f1xx_adc_jdr1_t" "t_register_stm32f1xx_adc_jdr1"
ttc_manage.pl replace "register_stm32f1xx_adc_jdr2_t" "t_register_stm32f1xx_adc_jdr2"
ttc_manage.pl replace "register_stm32f1xx_adc_jdr3_t" "t_register_stm32f1xx_adc_jdr3"
ttc_manage.pl replace "register_stm32f1xx_adc_jdr4_t" "t_register_stm32f1xx_adc_jdr4"
ttc_manage.pl replace "register_stm32f1xx_adc_jofr1_t" "t_register_stm32f1xx_adc_jofr1"
ttc_manage.pl replace "register_stm32f1xx_adc_jofr2_t" "t_register_stm32f1xx_adc_jofr2"
ttc_manage.pl replace "register_stm32f1xx_adc_jofr3_t" "t_register_stm32f1xx_adc_jofr3"
ttc_manage.pl replace "register_stm32f1xx_adc_jofr4_t" "t_register_stm32f1xx_adc_jofr4"
ttc_manage.pl replace "register_stm32f1xx_adc_jsqr_t" "t_register_stm32f1xx_adc_jsqr"
ttc_manage.pl replace "register_stm32f1xx_adc_ltr_t" "t_register_stm32f1xx_adc_ltr"
ttc_manage.pl replace "register_stm32f1xx_adc_smpr1_t" "t_register_stm32f1xx_adc_smpr1"
ttc_manage.pl replace "register_stm32f1xx_adc_smpr2_t" "t_register_stm32f1xx_adc_smpr2"
ttc_manage.pl replace "register_stm32f1xx_adc_sqr1_t" "t_register_stm32f1xx_adc_sqr1"
ttc_manage.pl replace "register_stm32f1xx_adc_sqr2_t" "t_register_stm32f1xx_adc_sqr2"
ttc_manage.pl replace "register_stm32f1xx_adc_sqr3_t" "t_register_stm32f1xx_adc_sqr3"
ttc_manage.pl replace "register_stm32f1xx_adc_sr_t" "t_register_stm32f1xx_adc_sr"
ttc_manage.pl replace "register_stm32f1xx_adc_t" "t_register_stm32f1xx_adc"
ttc_manage.pl replace "register_stm32f1xx_afio_t" "t_register_stm32f1xx_afio"
ttc_manage.pl replace "register_stm32f1xx_can_btr_t" "t_register_stm32f1xx_can_btr"
ttc_manage.pl replace "register_stm32f1xx_can_esr_t" "t_register_stm32f1xx_can_esr"
ttc_manage.pl replace "register_stm32f1xx_can_fifo_mailbox_t" "t_register_stm32f1xx_can_fifo_mailbox"
ttc_manage.pl replace "register_stm32f1xx_can_filter_t" "t_register_stm32f1xx_can_filter"
ttc_manage.pl replace "register_stm32f1xx_can_ier_t" "t_register_stm32f1xx_can_ier"
ttc_manage.pl replace "register_stm32f1xx_can_mcr_t" "t_register_stm32f1xx_can_mcr"
ttc_manage.pl replace "register_stm32f1xx_can_msr_t" "t_register_stm32f1xx_can_msr"
ttc_manage.pl replace "register_stm32f1xx_can_rdtxr_t" "t_register_stm32f1xx_can_rdtxr"
ttc_manage.pl replace "register_stm32f1xx_can_rf0r_t" "t_register_stm32f1xx_can_rf0r"
ttc_manage.pl replace "register_stm32f1xx_can_rf1r_t" "t_register_stm32f1xx_can_rf1r"
ttc_manage.pl replace "register_stm32f1xx_can_rixr_t" "t_register_stm32f1xx_can_rixr"
ttc_manage.pl replace "register_stm32f1xx_can_tdtxr_t" "t_register_stm32f1xx_can_tdtxr"
ttc_manage.pl replace "register_stm32f1xx_can_tixr_t" "t_register_stm32f1xx_can_tixr"
ttc_manage.pl replace "register_stm32f1xx_can_tsr_t" "t_register_stm32f1xx_can_tsr"
ttc_manage.pl replace "register_stm32f1xx_can_t" "t_register_stm32f1xx_can"
ttc_manage.pl replace "register_stm32f1xx_exti_emr_t" "t_register_stm32f1xx_exti_emr"
ttc_manage.pl replace "register_stm32f1xx_exti_ftsr_t" "t_register_stm32f1xx_exti_ftsr"
ttc_manage.pl replace "register_stm32f1xx_exti_imr_t" "t_register_stm32f1xx_exti_imr"
ttc_manage.pl replace "register_stm32f1xx_exti_pr_t" "t_register_stm32f1xx_exti_pr"
ttc_manage.pl replace "register_stm32f1xx_exti_rtsr_t" "t_register_stm32f1xx_exti_rtsr"
ttc_manage.pl replace "register_stm32f1xx_exti_swier_t" "t_register_stm32f1xx_exti_swier"
ttc_manage.pl replace "register_stm32f1xx_exti_t" "t_register_stm32f1xx_exti"
ttc_manage.pl replace "register_stm32f1xx_gpio_t" "t_register_stm32f1xx_gpio"
ttc_manage.pl replace "register_stm32f1xx_i2c_ccr_t" "t_register_stm32f1xx_i2c_ccr"
ttc_manage.pl replace "register_stm32f1xx_i2c_cr1_t" "t_register_stm32f1xx_i2c_cr1"
ttc_manage.pl replace "register_stm32f1xx_i2c_cr2_t" "t_register_stm32f1xx_i2c_cr2"
ttc_manage.pl replace "register_stm32f1xx_i2c_dr_t" "t_register_stm32f1xx_i2c_dr"
ttc_manage.pl replace "register_stm32f1xx_i2c_oar1_t" "t_register_stm32f1xx_i2c_oar1"
ttc_manage.pl replace "register_stm32f1xx_i2c_oar2_t" "t_register_stm32f1xx_i2c_oar2"
ttc_manage.pl replace "register_stm32f1xx_i2c_sr1_t" "t_register_stm32f1xx_i2c_sr1"
ttc_manage.pl replace "register_stm32f1xx_i2c_sr2_t" "t_register_stm32f1xx_i2c_sr2"
ttc_manage.pl replace "register_stm32f1xx_i2c_trise_t" "t_register_stm32f1xx_i2c_trise"
ttc_manage.pl replace "register_stm32f1xx_i2c_t" "t_register_stm32f1xx_i2c"
ttc_manage.pl replace "register_stm32f1xx_rcc_ahbenr_t" "t_register_stm32f1xx_rcc_ahbenr"
ttc_manage.pl replace "register_stm32f1xx_rcc_ahbrstr_t" "t_register_stm32f1xx_rcc_ahbrstr"
ttc_manage.pl replace "register_stm32f1xx_rcc_apb1_enr_t" "t_register_stm32f1xx_rcc_apb1_enr"
ttc_manage.pl replace "register_stm32f1xx_rcc_apb1rstr_t" "t_register_stm32f1xx_rcc_apb1rstr"
ttc_manage.pl replace "register_stm32f1xx_rcc_apb2_enr_t" "t_register_stm32f1xx_rcc_apb2_enr"
ttc_manage.pl replace "register_stm32f1xx_rcc_apb2rstr_t" "t_register_stm32f1xx_rcc_apb2rstr"
ttc_manage.pl replace "register_stm32f1xx_rcc_bdcr_t" "t_register_stm32f1xx_rcc_bdcr"
ttc_manage.pl replace "register_stm32f1xx_rcc_cfgr_t" "t_register_stm32f1xx_rcc_cfgr"
ttc_manage.pl replace "register_stm32f1xx_rcc_cir_t" "t_register_stm32f1xx_rcc_cir"
ttc_manage.pl replace "register_stm32f1xx_rcc_cr_t" "t_register_stm32f1xx_rcc_cr"
ttc_manage.pl replace "register_stm32f1xx_rcc_csr_t" "t_register_stm32f1xx_rcc_csr"
ttc_manage.pl replace "register_stm32f1xx_rcc_t" "t_register_stm32f1xx_rcc"
ttc_manage.pl replace "register_stm32f1xx_spi_cr1_t" "t_register_stm32f1xx_spi_cr1"
ttc_manage.pl replace "register_stm32f1xx_spi_cr2_t" "t_register_stm32f1xx_spi_cr2"
ttc_manage.pl replace "register_stm32f1xx_spi_crc_t" "t_register_stm32f1xx_spi_crc"
ttc_manage.pl replace "register_stm32f1xx_spi_dr_t" "t_register_stm32f1xx_spi_dr"
ttc_manage.pl replace "register_stm32f1xx_spi_i2scfgr_t" "t_register_stm32f1xx_spi_i2scfgr"
ttc_manage.pl replace "register_stm32f1xx_spi_i2spr_t" "t_register_stm32f1xx_spi_i2spr"
ttc_manage.pl replace "register_stm32f1xx_spi_rx_crc_t" "t_register_stm32f1xx_spi_rx_crc"
ttc_manage.pl replace "register_stm32f1xx_spi_sr_t" "t_register_stm32f1xx_spi_sr"
ttc_manage.pl replace "register_stm32f1xx_spi_t" "t_register_stm32f1xx_spi"
ttc_manage.pl replace "register_stm32f1xx_timer_t" "t_register_stm32f1xx_timer"
ttc_manage.pl replace "register_stm32f1xx_usart_brr_t" "t_register_stm32f1xx_usart_brr"
ttc_manage.pl replace "register_stm32f1xx_usart_cr1_t" "t_register_stm32f1xx_usart_cr1"
ttc_manage.pl replace "register_stm32f1xx_usart_cr2_t" "t_register_stm32f1xx_usart_cr2"
ttc_manage.pl replace "register_stm32f1xx_usart_cr3_t" "t_register_stm32f1xx_usart_cr3"
ttc_manage.pl replace "register_stm32f1xx_usart_dr_t" "t_register_stm32f1xx_usart_dr"
ttc_manage.pl replace "register_stm32f1xx_usart_sr_t" "t_register_stm32f1xx_usart_sr"
ttc_manage.pl replace "register_stm32f1xx_usart_t" "t_register_stm32f1xx_usart"
ttc_manage.pl replace "register_stm32f1xx_usb_cntr_t" "t_register_stm32f1xx_usb_cntr"
ttc_manage.pl replace "register_stm32f1xx_usb_fnr_t" "t_register_stm32f1xx_usb_fnr"
ttc_manage.pl replace "register_stm32f1xx_usb_istr_t" "t_register_stm32f1xx_usb_istr"
ttc_manage.pl replace "register_stm32f1xx_usb_t" "t_register_stm32f1xx_usb"
ttc_manage.pl replace "register_stm32l0xx_gpio_t" "t_register_stm32l0xx_gpio"
ttc_manage.pl replace "register_stm32l0xx_spi_cr1_t" "t_register_stm32l0xx_spi_cr1"
ttc_manage.pl replace "register_stm32l0xx_spi_cr2_t" "t_register_stm32l0xx_spi_cr2"
ttc_manage.pl replace "register_stm32l0xx_spi_crc_t" "t_register_stm32l0xx_spi_crc"
ttc_manage.pl replace "register_stm32l0xx_spi_dr_t" "t_register_stm32l0xx_spi_dr"
ttc_manage.pl replace "register_stm32l0xx_spi_i2scfgr_t" "t_register_stm32l0xx_spi_i2scfgr"
ttc_manage.pl replace "register_stm32l0xx_spi_i2spr_t" "t_register_stm32l0xx_spi_i2spr"
ttc_manage.pl replace "register_stm32l0xx_spi_rx_crc_t" "t_register_stm32l0xx_spi_rx_crc"
ttc_manage.pl replace "register_stm32l0xx_spi_sr_t" "t_register_stm32l0xx_spi_sr"
ttc_manage.pl replace "register_stm32l0xx_spi_t" "t_register_stm32l0xx_spi"
ttc_manage.pl replace "register_stm32l0xx_usart_t" "t_register_stm32l0xx_usart"
ttc_manage.pl replace "register_stm32l1xx_adc_cr1_t" "t_register_stm32l1xx_adc_cr1"
ttc_manage.pl replace "register_stm32l1xx_adc_cr2_t" "t_register_stm32l1xx_adc_cr2"
ttc_manage.pl replace "register_stm32l1xx_adc_dr_t" "t_register_stm32l1xx_adc_dr"
ttc_manage.pl replace "register_stm32l1xx_adc_htr_t" "t_register_stm32l1xx_adc_htr"
ttc_manage.pl replace "register_stm32l1xx_adc_jdr1_t" "t_register_stm32l1xx_adc_jdr1"
ttc_manage.pl replace "register_stm32l1xx_adc_jdr2_t" "t_register_stm32l1xx_adc_jdr2"
ttc_manage.pl replace "register_stm32l1xx_adc_jdr3_t" "t_register_stm32l1xx_adc_jdr3"
ttc_manage.pl replace "register_stm32l1xx_adc_jdr4_t" "t_register_stm32l1xx_adc_jdr4"
ttc_manage.pl replace "register_stm32l1xx_adc_jofr1_t" "t_register_stm32l1xx_adc_jofr1"
ttc_manage.pl replace "register_stm32l1xx_adc_jofr2_t" "t_register_stm32l1xx_adc_jofr2"
ttc_manage.pl replace "register_stm32l1xx_adc_jofr3_t" "t_register_stm32l1xx_adc_jofr3"
ttc_manage.pl replace "register_stm32l1xx_adc_jofr4_t" "t_register_stm32l1xx_adc_jofr4"
ttc_manage.pl replace "register_stm32l1xx_adc_jsqr_t" "t_register_stm32l1xx_adc_jsqr"
ttc_manage.pl replace "register_stm32l1xx_adc_ltr_t" "t_register_stm32l1xx_adc_ltr"
ttc_manage.pl replace "register_stm32l1xx_adc_smpr0_t" "t_register_stm32l1xx_adc_smpr0"
ttc_manage.pl replace "register_stm32l1xx_adc_smpr1_t" "t_register_stm32l1xx_adc_smpr1"
ttc_manage.pl replace "register_stm32l1xx_adc_smpr2_t" "t_register_stm32l1xx_adc_smpr2"
ttc_manage.pl replace "register_stm32l1xx_adc_smpr3_t" "t_register_stm32l1xx_adc_smpr3"
ttc_manage.pl replace "register_stm32l1xx_adc_sqr1_t" "t_register_stm32l1xx_adc_sqr1"
ttc_manage.pl replace "register_stm32l1xx_adc_sqr2_t" "t_register_stm32l1xx_adc_sqr2"
ttc_manage.pl replace "register_stm32l1xx_adc_sqr3_t" "t_register_stm32l1xx_adc_sqr3"
ttc_manage.pl replace "register_stm32l1xx_adc_sqr4_t" "t_register_stm32l1xx_adc_sqr4"
ttc_manage.pl replace "register_stm32l1xx_adc_sqr5_t" "t_register_stm32l1xx_adc_sqr5"
ttc_manage.pl replace "register_stm32l1xx_adc_sr_t" "t_register_stm32l1xx_adc_sr"
ttc_manage.pl replace "register_stm32l1xx_adc_t" "t_register_stm32l1xx_adc"
ttc_manage.pl replace "register_stm32l1xx_dac_cr_t" "t_register_stm32l1xx_dac_cr"
ttc_manage.pl replace "register_stm32l1xx_dac_dhr12l1_t" "t_register_stm32l1xx_dac_dhr12l1"
ttc_manage.pl replace "register_stm32l1xx_dac_dhr12l2_t" "t_register_stm32l1xx_dac_dhr12l2"
ttc_manage.pl replace "register_stm32l1xx_dac_dhr12ld_t" "t_register_stm32l1xx_dac_dhr12ld"
ttc_manage.pl replace "register_stm32l1xx_dac_dhr12r1_t" "t_register_stm32l1xx_dac_dhr12r1"
ttc_manage.pl replace "register_stm32l1xx_dac_dhr12r2_t" "t_register_stm32l1xx_dac_dhr12r2"
ttc_manage.pl replace "register_stm32l1xx_dac_dhr12rd_t" "t_register_stm32l1xx_dac_dhr12rd"
ttc_manage.pl replace "register_stm32l1xx_dac_dhr8r1_t" "t_register_stm32l1xx_dac_dhr8r1"
ttc_manage.pl replace "register_stm32l1xx_dac_dhr8r2_t" "t_register_stm32l1xx_dac_dhr8r2"
ttc_manage.pl replace "register_stm32l1xx_dac_dhr8rd_t" "t_register_stm32l1xx_dac_dhr8rd"
ttc_manage.pl replace "register_stm32l1xx_dac_dor1_t" "t_register_stm32l1xx_dac_dor1"
ttc_manage.pl replace "register_stm32l1xx_dac_dor2_t" "t_register_stm32l1xx_dac_dor2"
ttc_manage.pl replace "register_stm32l1xx_dac_sr_t" "t_register_stm32l1xx_dac_sr"
ttc_manage.pl replace "register_stm32l1xx_dac_swtrigr_t" "t_register_stm32l1xx_dac_swtrigr"
ttc_manage.pl replace "register_stm32l1xx_dac_t" "t_register_stm32l1xx_dac"
ttc_manage.pl replace "register_stm32l1xx_dma_ccr1_t" "t_register_stm32l1xx_dma_ccr1"
ttc_manage.pl replace "register_stm32l1xx_dma_channel_t" "t_register_stm32l1xx_dma_channel"
ttc_manage.pl replace "register_stm32l1xx_dma_cmar1_t" "t_register_stm32l1xx_dma_cmar1"
ttc_manage.pl replace "register_stm32l1xx_dma_cndtr1_t" "t_register_stm32l1xx_dma_cndtr1"
ttc_manage.pl replace "register_stm32l1xx_dma_cpar1_t" "t_register_stm32l1xx_dma_cpar1"
ttc_manage.pl replace "register_stm32l1xx_dma_ifcr_t" "t_register_stm32l1xx_dma_ifcr"
ttc_manage.pl replace "register_stm32l1xx_dma_isr_t" "t_register_stm32l1xx_dma_isr"
ttc_manage.pl replace "register_stm32l1xx_dma_t" "t_register_stm32l1xx_dma"
ttc_manage.pl replace "register_stm32l1xx_exti_emr_t" "t_register_stm32l1xx_exti_emr"
ttc_manage.pl replace "register_stm32l1xx_exti_ftsr_t" "t_register_stm32l1xx_exti_ftsr"
ttc_manage.pl replace "register_stm32l1xx_exti_imr_t" "t_register_stm32l1xx_exti_imr"
ttc_manage.pl replace "register_stm32l1xx_exti_pr_t" "t_register_stm32l1xx_exti_pr"
ttc_manage.pl replace "register_stm32l1xx_exti_rtsr_t" "t_register_stm32l1xx_exti_rtsr"
ttc_manage.pl replace "register_stm32l1xx_exti_swier_t" "t_register_stm32l1xx_exti_swier"
ttc_manage.pl replace "register_stm32l1xx_exti_t" "t_register_stm32l1xx_exti"
ttc_manage.pl replace "register_stm32l1xx_gpio_t" "t_register_stm32l1xx_gpio"
ttc_manage.pl replace "register_stm32l1xx_gpiox_afrh_t" "t_register_stm32l1xx_gpiox_afrh"
ttc_manage.pl replace "register_stm32l1xx_gpiox_afrl_t" "t_register_stm32l1xx_gpiox_afrl"
ttc_manage.pl replace "register_stm32l1xx_gpiox_bsrr_t" "t_register_stm32l1xx_gpiox_bsrr"
ttc_manage.pl replace "register_stm32l1xx_gpiox_idr_t" "t_register_stm32l1xx_gpiox_idr"
ttc_manage.pl replace "register_stm32l1xx_gpiox_lckr_t" "t_register_stm32l1xx_gpiox_lckr"
ttc_manage.pl replace "register_stm32l1xx_gpiox_moder_t" "t_register_stm32l1xx_gpiox_moder"
ttc_manage.pl replace "register_stm32l1xx_gpiox_odr_t" "t_register_stm32l1xx_gpiox_odr"
ttc_manage.pl replace "register_stm32l1xx_gpiox_ospeedr_t" "t_register_stm32l1xx_gpiox_ospeedr"
ttc_manage.pl replace "register_stm32l1xx_gpiox_otyper_t" "t_register_stm32l1xx_gpiox_otyper"
ttc_manage.pl replace "register_stm32l1xx_gpiox_pupdr_t" "t_register_stm32l1xx_gpiox_pupdr"
ttc_manage.pl replace "register_stm32l1xx_i2c_ccr_t" "t_register_stm32l1xx_i2c_ccr"
ttc_manage.pl replace "register_stm32l1xx_i2c_cr1_t" "t_register_stm32l1xx_i2c_cr1"
ttc_manage.pl replace "register_stm32l1xx_i2c_cr2_t" "t_register_stm32l1xx_i2c_cr2"
ttc_manage.pl replace "register_stm32l1xx_i2c_dr_t" "t_register_stm32l1xx_i2c_dr"
ttc_manage.pl replace "register_stm32l1xx_i2c_oar1_t" "t_register_stm32l1xx_i2c_oar1"
ttc_manage.pl replace "register_stm32l1xx_i2c_oar2_t" "t_register_stm32l1xx_i2c_oar2"
ttc_manage.pl replace "register_stm32l1xx_i2c_sr1_t" "t_register_stm32l1xx_i2c_sr1"
ttc_manage.pl replace "register_stm32l1xx_i2c_sr2_t" "t_register_stm32l1xx_i2c_sr2"
ttc_manage.pl replace "register_stm32l1xx_i2c_trise_t" "t_register_stm32l1xx_i2c_trise"
ttc_manage.pl replace "register_stm32l1xx_i2c_t" "t_register_stm32l1xx_i2c"
ttc_manage.pl replace "register_stm32l1xx_pwr_cr_t" "t_register_stm32l1xx_pwr_cr"
ttc_manage.pl replace "register_stm32l1xx_pwr_csr_t" "t_register_stm32l1xx_pwr_csr"
ttc_manage.pl replace "register_stm32l1xx_pwr_t" "t_register_stm32l1xx_pwr"
ttc_manage.pl replace "register_stm32l1xx_rcc_ahbenr_t" "t_register_stm32l1xx_rcc_ahbenr"
ttc_manage.pl replace "register_stm32l1xx_rcc_ahblpenr_t" "t_register_stm32l1xx_rcc_ahblpenr"
ttc_manage.pl replace "register_stm32l1xx_rcc_ahbrstr_t" "t_register_stm32l1xx_rcc_ahbrstr"
ttc_manage.pl replace "register_stm32l1xx_rcc_apb1enr_t" "t_register_stm32l1xx_rcc_apb1enr"
ttc_manage.pl replace "register_stm32l1xx_rcc_apb1lpenr_t" "t_register_stm32l1xx_rcc_apb1lpenr"
ttc_manage.pl replace "register_stm32l1xx_rcc_apb1rstr_t" "t_register_stm32l1xx_rcc_apb1rstr"
ttc_manage.pl replace "register_stm32l1xx_rcc_apb2enr_t" "t_register_stm32l1xx_rcc_apb2enr"
ttc_manage.pl replace "register_stm32l1xx_rcc_apb2lpenr_t" "t_register_stm32l1xx_rcc_apb2lpenr"
ttc_manage.pl replace "register_stm32l1xx_rcc_apb2rstr_t" "t_register_stm32l1xx_rcc_apb2rstr"
ttc_manage.pl replace "register_stm32l1xx_rcc_cfgr_t" "t_register_stm32l1xx_rcc_cfgr"
ttc_manage.pl replace "register_stm32l1xx_rcc_cir_t" "t_register_stm32l1xx_rcc_cir"
ttc_manage.pl replace "register_stm32l1xx_rcc_cr_t" "t_register_stm32l1xx_rcc_cr"
ttc_manage.pl replace "register_stm32l1xx_rcc_csr_t" "t_register_stm32l1xx_rcc_csr"
ttc_manage.pl replace "register_stm32l1xx_rcc_icscr_t" "t_register_stm32l1xx_rcc_icscr"
ttc_manage.pl replace "register_stm32l1xx_rcc_t" "t_register_stm32l1xx_rcc"
ttc_manage.pl replace "register_stm32l1xx_ri_ascr1_t" "t_register_stm32l1xx_ri_ascr1"
ttc_manage.pl replace "register_stm32l1xx_ri_ascr2_t" "t_register_stm32l1xx_ri_ascr2"
ttc_manage.pl replace "register_stm32l1xx_ri_asmr1_t" "t_register_stm32l1xx_ri_asmr1"
ttc_manage.pl replace "register_stm32l1xx_ri_asmr2_t" "t_register_stm32l1xx_ri_asmr2"
ttc_manage.pl replace "register_stm32l1xx_ri_asmr3_t" "t_register_stm32l1xx_ri_asmr3"
ttc_manage.pl replace "register_stm32l1xx_ri_asmr4_t" "t_register_stm32l1xx_ri_asmr4"
ttc_manage.pl replace "register_stm32l1xx_ri_asmr5_t" "t_register_stm32l1xx_ri_asmr5"
ttc_manage.pl replace "register_stm32l1xx_ri_cicr1_t" "t_register_stm32l1xx_ri_cicr1"
ttc_manage.pl replace "register_stm32l1xx_ri_cicr2_t" "t_register_stm32l1xx_ri_cicr2"
ttc_manage.pl replace "register_stm32l1xx_ri_cicr3_t" "t_register_stm32l1xx_ri_cicr3"
ttc_manage.pl replace "register_stm32l1xx_ri_cicr4_t" "t_register_stm32l1xx_ri_cicr4"
ttc_manage.pl replace "register_stm32l1xx_ri_cicr5_t" "t_register_stm32l1xx_ri_cicr5"
ttc_manage.pl replace "register_stm32l1xx_ri_cmr1_t" "t_register_stm32l1xx_ri_cmr1"
ttc_manage.pl replace "register_stm32l1xx_ri_cmr2_t" "t_register_stm32l1xx_ri_cmr2"
ttc_manage.pl replace "register_stm32l1xx_ri_cmr3_t" "t_register_stm32l1xx_ri_cmr3"
ttc_manage.pl replace "register_stm32l1xx_ri_cmr4_t" "t_register_stm32l1xx_ri_cmr4"
ttc_manage.pl replace "register_stm32l1xx_ri_cmr5_t" "t_register_stm32l1xx_ri_cmr5"
ttc_manage.pl replace "register_stm32l1xx_ri_hyscr1_t" "t_register_stm32l1xx_ri_hyscr1"
ttc_manage.pl replace "register_stm32l1xx_ri_hyscr2_t" "t_register_stm32l1xx_ri_hyscr2"
ttc_manage.pl replace "register_stm32l1xx_ri_hyscr3_t" "t_register_stm32l1xx_ri_hyscr3"
ttc_manage.pl replace "register_stm32l1xx_ri_hyscr4_t" "t_register_stm32l1xx_ri_hyscr4"
ttc_manage.pl replace "register_stm32l1xx_rtc_alrmar_t" "t_register_stm32l1xx_rtc_alrmar"
ttc_manage.pl replace "register_stm32l1xx_rtc_alrmassr_t" "t_register_stm32l1xx_rtc_alrmassr"
ttc_manage.pl replace "register_stm32l1xx_rtc_alrmbr_t" "t_register_stm32l1xx_rtc_alrmbr"
ttc_manage.pl replace "register_stm32l1xx_rtc_alrmbssr_t" "t_register_stm32l1xx_rtc_alrmbssr"
ttc_manage.pl replace "register_stm32l1xx_rtc_bkpor_t" "t_register_stm32l1xx_rtc_bkpor"
ttc_manage.pl replace "register_stm32l1xx_rtc_calibr_t" "t_register_stm32l1xx_rtc_calibr"
ttc_manage.pl replace "register_stm32l1xx_rtc_calr_t" "t_register_stm32l1xx_rtc_calr"
ttc_manage.pl replace "register_stm32l1xx_rtc_cr_t" "t_register_stm32l1xx_rtc_cr"
ttc_manage.pl replace "register_stm32l1xx_rtc_dr_t" "t_register_stm32l1xx_rtc_dr"
ttc_manage.pl replace "register_stm32l1xx_rtc_isr_t" "t_register_stm32l1xx_rtc_isr"
ttc_manage.pl replace "register_stm32l1xx_rtc_prer_t" "t_register_stm32l1xx_rtc_prer"
ttc_manage.pl replace "register_stm32l1xx_rtc_shiftr_t" "t_register_stm32l1xx_rtc_shiftr"
ttc_manage.pl replace "register_stm32l1xx_rtc_ssr_t" "t_register_stm32l1xx_rtc_ssr"
ttc_manage.pl replace "register_stm32l1xx_rtc_tafcr_t" "t_register_stm32l1xx_rtc_tafcr"
ttc_manage.pl replace "register_stm32l1xx_rtc_tr_t" "t_register_stm32l1xx_rtc_tr"
ttc_manage.pl replace "register_stm32l1xx_rtc_tsdr_t" "t_register_stm32l1xx_rtc_tsdr"
ttc_manage.pl replace "register_stm32l1xx_rtc_tsssr_t" "t_register_stm32l1xx_rtc_tsssr"
ttc_manage.pl replace "register_stm32l1xx_rtc_tstr_t" "t_register_stm32l1xx_rtc_tstr"
ttc_manage.pl replace "register_stm32l1xx_rtc_t" "t_register_stm32l1xx_rtc"
ttc_manage.pl replace "register_stm32l1xx_rtc_wpr_t" "t_register_stm32l1xx_rtc_wpr"
ttc_manage.pl replace "register_stm32l1xx_rtc_wutr_t" "t_register_stm32l1xx_rtc_wutr"
ttc_manage.pl replace "register_stm32l1xx_spi_cr1_t" "t_register_stm32l1xx_spi_cr1"
ttc_manage.pl replace "register_stm32l1xx_spi_cr2_t" "t_register_stm32l1xx_spi_cr2"
ttc_manage.pl replace "register_stm32l1xx_spi_crc_t" "t_register_stm32l1xx_spi_crc"
ttc_manage.pl replace "register_stm32l1xx_spi_dr_t" "t_register_stm32l1xx_spi_dr"
ttc_manage.pl replace "register_stm32l1xx_spi_i2scfgr_t" "t_register_stm32l1xx_spi_i2scfgr"
ttc_manage.pl replace "register_stm32l1xx_spi_i2spr_t" "t_register_stm32l1xx_spi_i2spr"
ttc_manage.pl replace "register_stm32l1xx_spi_rx_crc_t" "t_register_stm32l1xx_spi_rx_crc"
ttc_manage.pl replace "register_stm32l1xx_spi_sr_t" "t_register_stm32l1xx_spi_sr"
ttc_manage.pl replace "register_stm32l1xx_spi_t" "t_register_stm32l1xx_spi"
ttc_manage.pl replace "register_stm32l1xx_tim10_to_tim11_arr_t" "t_register_stm32l1xx_tim10_to_tim11_arr"
ttc_manage.pl replace "register_stm32l1xx_tim10_to_tim11_ccer_t" "t_register_stm32l1xx_tim10_to_tim11_ccer"
ttc_manage.pl replace "register_stm32l1xx_tim10_to_tim11_ccmr1_input_capture_mode_t" "t_register_stm32l1xx_tim10_to_tim11_ccmr1_input_capture_mode"
ttc_manage.pl replace "register_stm32l1xx_tim10_to_tim11_ccr1_t" "t_register_stm32l1xx_tim10_to_tim11_ccr1"
ttc_manage.pl replace "register_stm32l1xx_tim10_to_tim11_cnt_t" "t_register_stm32l1xx_tim10_to_tim11_cnt"
ttc_manage.pl replace "register_stm32l1xx_tim10_to_tim11_cr1_t" "t_register_stm32l1xx_tim10_to_tim11_cr1"
ttc_manage.pl replace "register_stm32l1xx_tim10_to_tim11_dier_t" "t_register_stm32l1xx_tim10_to_tim11_dier"
ttc_manage.pl replace "register_stm32l1xx_tim10_to_tim11_egr_t" "t_register_stm32l1xx_tim10_to_tim11_egr"
ttc_manage.pl replace "register_stm32l1xx_tim10_to_tim11_input_capture_mode_t" "t_register_stm32l1xx_tim10_to_tim11_input_capture_mode"
ttc_manage.pl replace "register_stm32l1xx_tim10_to_tim11_or_t" "t_register_stm32l1xx_tim10_to_tim11_or"
ttc_manage.pl replace "register_stm32l1xx_tim10_to_tim11_output_compare_mode_t" "t_register_stm32l1xx_tim10_to_tim11_output_compare_mode"
ttc_manage.pl replace "register_stm32l1xx_tim10_to_tim11_psc_t" "t_register_stm32l1xx_tim10_to_tim11_psc"
ttc_manage.pl replace "register_stm32l1xx_tim10_to_tim11_smcr_t" "t_register_stm32l1xx_tim10_to_tim11_smcr"
ttc_manage.pl replace "register_stm32l1xx_tim10_to_tim11_sr_t" "t_register_stm32l1xx_tim10_to_tim11_sr"
ttc_manage.pl replace "register_stm32l1xx_tim2_to_tim4_input_capture_mode_t" "t_register_stm32l1xx_tim2_to_tim4_input_capture_mode"
ttc_manage.pl replace "register_stm32l1xx_tim2_to_tim4_output_compare_mode_t" "t_register_stm32l1xx_tim2_to_tim4_output_compare_mode"
ttc_manage.pl replace "register_stm32l1xx_tim6_to_tim7_t" "t_register_stm32l1xx_tim6_to_tim7"
ttc_manage.pl replace "register_stm32l1xx_tim9_input_capture_t" "t_register_stm32l1xx_tim9_input_capture"
ttc_manage.pl replace "register_stm32l1xx_tim9_output_compare_t" "t_register_stm32l1xx_tim9_output_compare"
ttc_manage.pl replace "register_stm32l1xx_timer_t" "t_register_stm32l1xx_timer"
ttc_manage.pl replace "register_stm32l1xx_timx_arr_t" "t_register_stm32l1xx_timx_arr"
ttc_manage.pl replace "register_stm32l1xx_timx_ccer_t" "t_register_stm32l1xx_timx_ccer"
ttc_manage.pl replace "register_stm32l1xx_timx_ccmr1_compare_mode_t" "t_register_stm32l1xx_timx_ccmr1_compare_mode"
ttc_manage.pl replace "register_stm32l1xx_timx_ccmr2_compare_mode_t" "t_register_stm32l1xx_timx_ccmr2_compare_mode"
ttc_manage.pl replace "register_stm32l1xx_timx_ccr1_t" "t_register_stm32l1xx_timx_ccr1"
ttc_manage.pl replace "register_stm32l1xx_timx_ccr2_t" "t_register_stm32l1xx_timx_ccr2"
ttc_manage.pl replace "register_stm32l1xx_timx_ccr3_t" "t_register_stm32l1xx_timx_ccr3"
ttc_manage.pl replace "register_stm32l1xx_timx_ccr4_t" "t_register_stm32l1xx_timx_ccr4"
ttc_manage.pl replace "register_stm32l1xx_timx_cnt_t" "t_register_stm32l1xx_timx_cnt"
ttc_manage.pl replace "register_stm32l1xx_timx_cr1_t" "t_register_stm32l1xx_timx_cr1"
ttc_manage.pl replace "register_stm32l1xx_timx_cr2_t" "t_register_stm32l1xx_timx_cr2"
ttc_manage.pl replace "register_stm32l1xx_timx_dcr_t" "t_register_stm32l1xx_timx_dcr"
ttc_manage.pl replace "register_stm32l1xx_timx_dier_t" "t_register_stm32l1xx_timx_dier"
ttc_manage.pl replace "register_stm32l1xx_timx_dmar_t" "t_register_stm32l1xx_timx_dmar"
ttc_manage.pl replace "register_stm32l1xx_timx_egr_t" "t_register_stm32l1xx_timx_egr"
ttc_manage.pl replace "register_stm32l1xx_timx_psc_t" "t_register_stm32l1xx_timx_psc"
ttc_manage.pl replace "register_stm32l1xx_timx_smcr_t" "t_register_stm32l1xx_timx_smcr"
ttc_manage.pl replace "register_stm32l1xx_timx_sr_t" "t_register_stm32l1xx_timx_sr"
ttc_manage.pl replace "register_stm32l1xx_usart_brr_t" "t_register_stm32l1xx_usart_brr"
ttc_manage.pl replace "register_stm32l1xx_usart_cr1_t" "t_register_stm32l1xx_usart_cr1"
ttc_manage.pl replace "register_stm32l1xx_usart_cr2_t" "t_register_stm32l1xx_usart_cr2"
ttc_manage.pl replace "register_stm32l1xx_usart_cr3_t" "t_register_stm32l1xx_usart_cr3"
ttc_manage.pl replace "register_stm32l1xx_usart_dr_t" "t_register_stm32l1xx_usart_dr"
ttc_manage.pl replace "register_stm32l1xx_usart_gtpr_t" "t_register_stm32l1xx_usart_gtpr"
ttc_manage.pl replace "register_stm32l1xx_usart_sr_t" "t_register_stm32l1xx_usart_sr"
ttc_manage.pl replace "register_stm32l1xx_usart_t" "t_register_stm32l1xx_usart"
ttc_manage.pl replace "register_stm32w1xx_all_t" "t_register_stm32w1xx_all"
ttc_manage.pl replace "register_stm32w1xx_GPIO_DBGCFG_t" "t_register_stm32w1xx_gpio_dbgcfg"
ttc_manage.pl replace "register_stm32w1xx_GPIO_DBGSTAT_t" "t_register_stm32w1xx_gpio_dbgstat"
ttc_manage.pl replace "register_stm32w1xx_GPIO_debug_wake_irq_t" "t_register_stm32w1xx_gpio_debug_wake_irq"
ttc_manage.pl replace "register_stm32w1xx_GPIO_INTCFGx_t" "t_register_stm32w1xx_gpio_intcfgx"
ttc_manage.pl replace "register_stm32w1xx_GPIO_interruptCFG_t" "t_register_stm32w1xx_gpio_interruptcfg"
ttc_manage.pl replace "register_stm32w1xx_GPIO_interruptFLAG_t" "t_register_stm32w1xx_gpio_interruptflag"
ttc_manage.pl replace "register_stm32w1xx_GPIO_IRQCSEL_t" "t_register_stm32w1xx_gpio_irqcsel"
ttc_manage.pl replace "register_stm32w1xx_GPIO_IRQDSEL_t" "t_register_stm32w1xx_gpio_irqdsel"
ttc_manage.pl replace "register_stm32w1xx_gpio_IRQx_mode_e" "e_register_stm32w1xx_gpio_irqx_mode"
ttc_manage.pl replace "register_stm32w1xx_gpio_port_ioMode_e" "e_register_stm32w1xx_gpio_port_iomode"
ttc_manage.pl replace "register_stm32w1xx_GPIO_PxCFGH_t" "t_register_stm32w1xx_gpio_pxcfgh"
ttc_manage.pl replace "register_stm32w1xx_GPIO_PxCFGL_t" "t_register_stm32w1xx_gpio_pxcfgl"
ttc_manage.pl replace "register_stm32w1xx_GPIO_PxCLR_t" "t_register_stm32w1xx_gpio_pxclr"
ttc_manage.pl replace "register_stm32w1xx_GPIO_PxIN_t" "t_register_stm32w1xx_gpio_pxin"
ttc_manage.pl replace "register_stm32w1xx_GPIO_PxOUT_t" "t_register_stm32w1xx_gpio_pxout"
ttc_manage.pl replace "register_stm32w1xx_GPIO_PxSET_t" "t_register_stm32w1xx_gpio_pxset"
ttc_manage.pl replace "register_stm32w1xx_GPIO_PxWAKE_t" "t_register_stm32w1xx_gpio_pxwake"
ttc_manage.pl replace "register_stm32w1xx_GPIO_WAKEFILT_t" "t_register_stm32w1xx_gpio_wakefilt"
ttc_manage.pl replace "register_stm32w1xx_GPIOx_t" "t_register_stm32w1xx_gpiox"
ttc_manage.pl replace "register_stm32w1xx_INT_ACTIVE_t" "t_register_stm32w1xx_int_active"
ttc_manage.pl replace "register_stm32w1xx_INT_CFGCLR_t" "t_register_stm32w1xx_int_cfgclr"
ttc_manage.pl replace "register_stm32w1xx_INT_CFGSET_t" "t_register_stm32w1xx_int_cfgset"
ttc_manage.pl replace "register_stm32w1xx_INT_MISS_t" "t_register_stm32w1xx_int_miss"
ttc_manage.pl replace "register_stm32w1xx_INT_PENDCLR_t" "t_register_stm32w1xx_int_pendclr"
ttc_manage.pl replace "register_stm32w1xx_INT_PENDSET_t" "t_register_stm32w1xx_int_pendset"
ttc_manage.pl replace "register_stm32w1xx_INT_SCxCFG_t" "t_register_stm32w1xx_int_scxcfg"
ttc_manage.pl replace "register_stm32w1xx_INT_SCxFLAG_t" "t_register_stm32w1xx_int_scxflag"
ttc_manage.pl replace "register_stm32w1xx_NVIC_interrupt_registers_t" "t_register_stm32w1xx_nvic_interrupt_registers"
ttc_manage.pl replace "register_stm32w1xx_OSC24M_CTRL_t" "t_register_stm32w1xx_osc24m_ctrl"
ttc_manage.pl replace "register_stm32w1xx_peripherals_t" "t_register_stm32w1xx_peripherals"
ttc_manage.pl replace "register_stm32w1xx_private_peripherals_t" "t_register_stm32w1xx_private_peripherals"
ttc_manage.pl replace "register_stm32w1xx_SC1_UARTCFG_t" "t_register_stm32w1xx_sc1_uartcfg"
ttc_manage.pl replace "register_stm32w1xx_SC1_UARTFRAC_t" "t_register_stm32w1xx_sc1_uartfrac"
ttc_manage.pl replace "register_stm32w1xx_SC1_UARTPER_t" "t_register_stm32w1xx_sc1_uartper"
ttc_manage.pl replace "register_stm32w1xx_SC1_UARTSTAT_t" "t_register_stm32w1xx_sc1_uartstat"
ttc_manage.pl replace "register_stm32w1xx_sc_mode_e" "e_register_stm32w1xx_sc_mode"
ttc_manage.pl replace "register_stm32w1xx_SCS_AFSR_t" "t_register_stm32w1xx_scs_afsr"
ttc_manage.pl replace "register_stm32w1xx_SCx_DATA_t" "t_register_stm32w1xx_scx_data"
ttc_manage.pl replace "register_stm32w1xx_SCx_DMACTRL_t" "t_register_stm32w1xx_scx_dmactrl"
ttc_manage.pl replace "register_stm32w1xx_SCx_DMASTAT_t" "t_register_stm32w1xx_scx_dmastat"
ttc_manage.pl replace "register_stm32w1xx_SCx_INTMODE_t" "t_register_stm32w1xx_scx_intmode"
ttc_manage.pl replace "register_stm32w1xx_SCx_MODE_t" "t_register_stm32w1xx_scx_mode"
ttc_manage.pl replace "register_stm32w1xx_SCx_RATEEXP_t" "t_register_stm32w1xx_scx_rateexp"
ttc_manage.pl replace "register_stm32w1xx_SCx_RATELIN_t" "t_register_stm32w1xx_scx_ratelin"
ttc_manage.pl replace "register_stm32w1xx_SCx_RXBEGA_t" "t_register_stm32w1xx_scx_rxbega"
ttc_manage.pl replace "register_stm32w1xx_SCx_RXBEGB_t" "t_register_stm32w1xx_scx_rxbegb"
ttc_manage.pl replace "register_stm32w1xx_SCx_RXCNTA_t" "t_register_stm32w1xx_scx_rxcnta"
ttc_manage.pl replace "register_stm32w1xx_SCx_RXCNTB_t" "t_register_stm32w1xx_scx_rxcntb"
ttc_manage.pl replace "register_stm32w1xx_SCx_RXCNTSAVED_t" "t_register_stm32w1xx_scx_rxcntsaved"
ttc_manage.pl replace "register_stm32w1xx_SCx_RXENDA_t" "t_register_stm32w1xx_scx_rxenda"
ttc_manage.pl replace "register_stm32w1xx_SCx_RXENDB_t" "t_register_stm32w1xx_scx_rxendb"
ttc_manage.pl replace "register_stm32w1xx_SCx_RXERRA_t" "t_register_stm32w1xx_scx_rxerra"
ttc_manage.pl replace "register_stm32w1xx_SCx_RXERRB_t" "t_register_stm32w1xx_scx_rxerrb"
ttc_manage.pl replace "register_stm32w1xx_SCx_SPICFG_t" "t_register_stm32w1xx_scx_spicfg"
ttc_manage.pl replace "register_stm32w1xx_SCx_SPISTAT_t" "t_register_stm32w1xx_scx_spistat"
ttc_manage.pl replace "register_stm32w1xx_SCx_t" "t_register_stm32w1xx_scx"
ttc_manage.pl replace "register_stm32w1xx_SCx_TWICTRL1_t" "t_register_stm32w1xx_scx_twictrl1"
ttc_manage.pl replace "register_stm32w1xx_SCx_TWICTRL2_t" "t_register_stm32w1xx_scx_twictrl2"
ttc_manage.pl replace "register_stm32w1xx_SCx_TWISTAT_t" "t_register_stm32w1xx_scx_twistat"
ttc_manage.pl replace "register_stm32w1xx_SCx_TXBEGA_t" "t_register_stm32w1xx_scx_txbega"
ttc_manage.pl replace "register_stm32w1xx_SCx_TXBEGB_t" "t_register_stm32w1xx_scx_txbegb"
ttc_manage.pl replace "register_stm32w1xx_SCx_TXCNT_t" "t_register_stm32w1xx_scx_txcnt"
ttc_manage.pl replace "register_stm32w1xx_SCx_TXENDA_t" "t_register_stm32w1xx_scx_txenda"
ttc_manage.pl replace "register_stm32w1xx_SCx_TXENDB_t" "t_register_stm32w1xx_scx_txendb"
ttc_manage.pl replace "register_stm32w1xx_usart_t" "t_register_stm32w1xx_usart"
ttc_manage.pl replace "register_t" "t_register"
ttc_manage.pl replace "reserved_reg_t" "t_reserved_reg"
ttc_manage.pl replace "rimeaddr_t" "t_rimeaddr"
ttc_manage.pl replace "RTC_Register_t" "t_rtc_register"
ttc_manage.pl replace "rtls_common_data_report_distances_t" "t_rtls_common_data_report_distances"
ttc_manage.pl replace "rtls_common_data_report_locations_t" "t_rtls_common_data_report_locations"
ttc_manage.pl replace "rtls_common_distance_t" "t_rtls_common_distance"
ttc_manage.pl replace "rtls_common_location_t" "t_rtls_common_location"
ttc_manage.pl replace "rtls_common_packet_distances_report_t" "t_rtls_common_packet_distances_report"
ttc_manage.pl replace "rtls_common_packet_locations_report_t" "t_rtls_common_packet_locations_report"
ttc_manage.pl replace "rtls_common_packet_t" "t_rtls_common_packet"
ttc_manage.pl replace "rtls_crtof_simple_2d_packet_report_distance_to_northpole_t" "t_rtls_crtof_simple_2d_packet_report_distance_to_northpole"
ttc_manage.pl replace "rtls_crtof_simple_2d_packet_request_distance_to_northpole_t" "t_rtls_crtof_simple_2d_packet_request_distance_to_northpole"
ttc_manage.pl replace "rtls_crtof_simple_2d_packet_t" "t_rtls_crtof_simple_2d_packet"
ttc_manage.pl replace "s16_t" "t_s16"
ttc_manage.pl replace "s32_t" "t_s32"
ttc_manage.pl replace "s8_t" "t_s8"
ttc_manage.pl replace "sc2d_node_distance_t" "t_sc2d_node_distance"
ttc_manage.pl replace "scs2_node_distances_t" "t_scs2_node_distances"
ttc_manage.pl replace "SDCARD_Register_t" "t_sdcard_register"
ttc_manage.pl replace "ServoCfg_t" "t_servocfg"
ttc_manage.pl replace "SFD_t" "t_sfd"
ttc_manage.pl replace "SHR_t" "t_shr"
ttc_manage.pl replace "slam_simple_2d_node_index_e" "e_slam_simple_2d_node_index"
ttc_manage.pl replace "slam_simple_2d_node_t" "t_slam_simple_2d_node"
ttc_manage.pl replace "SPI_Register_t" "t_spi_register"
ttc_manage.pl replace "statedata_s2d_build_coordinate_system_t" "t_statedata_s2d_build_coordinate_system"
ttc_manage.pl replace "statedata_s2d_measure_all_ranges_t" "t_statedata_s2d_measure_all_ranges"
ttc_manage.pl replace "statedata_s2d_measure_range_to_northpole_t" "t_statedata_s2d_measure_range_to_northpole"
ttc_manage.pl replace "statedata_s2d_measure_single_range_t" "t_statedata_s2d_measure_single_range"
ttc_manage.pl replace "statedata_s2d_request_all_ranges_to_northpole_t" "t_statedata_s2d_request_all_ranges_to_northpole"
ttc_manage.pl replace "statedata_s2d_waiting_t" "t_statedata_s2d_waiting"
ttc_manage.pl replace "stm32_clock_source_e" "e_stm32_clock_source"
ttc_manage.pl replace "stm32l0_gpio_mode_e" "e_stm32l0_gpio_mode"
ttc_manage.pl replace "stm32l0_gpio_otype_e" "e_stm32l0_gpio_otype"
ttc_manage.pl replace "stm32l0_gpio_pupd_e" "e_stm32l0_gpio_pupd"
ttc_manage.pl replace "stm32l0_gpio_speed_e" "e_stm32l0_gpio_speed"
ttc_manage.pl replace "stm32l0_GPIOx_AFRH_t" "t_stm32l0_gpiox_afrh"
ttc_manage.pl replace "stm32l0_GPIOx_AFRL_t" "t_stm32l0_gpiox_afrl"
ttc_manage.pl replace "stm32l0_GPIOx_MODER_t" "t_stm32l0_gpiox_moder"
ttc_manage.pl replace "stm32l0_GPIOx_OSPEEDR_t" "t_stm32l0_gpiox_ospeedr"
ttc_manage.pl replace "stm32l0_GPIOx_OTYPER_t" "t_stm32l0_gpiox_otyper"
ttc_manage.pl replace "stm32l0_GPIOx_PUPDR_t" "t_stm32l0_gpiox_pupdr"
ttc_manage.pl replace "stm32l0xx_USART_BRR_t" "t_stm32l0xx_usart_brr"
ttc_manage.pl replace "stm32l0xx_USART_CR1_t" "t_stm32l0xx_usart_cr1"
ttc_manage.pl replace "stm32l0xx_USART_CR2_t" "t_stm32l0xx_usart_cr2"
ttc_manage.pl replace "stm32l0xx_USART_CR3_t" "t_stm32l0xx_usart_cr3"
ttc_manage.pl replace "stm32l0xx_USART_GTPR_t" "t_stm32l0xx_usart_gtpr"
ttc_manage.pl replace "stm32l0xx_USART_ICR_t" "t_stm32l0xx_usart_icr"
ttc_manage.pl replace "stm32l0xx_USART_ISR_t" "t_stm32l0xx_usart_isr"
ttc_manage.pl replace "stm32l0xx_USART_RDR_t" "t_stm32l0xx_usart_rdr"
ttc_manage.pl replace "stm32l0xx_USART_RQR_t" "t_stm32l0xx_usart_rqr"
ttc_manage.pl replace "stm32l0xx_USART_RTOR_t" "t_stm32l0xx_usart_rtor"
ttc_manage.pl replace "stm32l0xx_USART_TDR_t" "t_stm32l0xx_usart_tdr"
ttc_manage.pl replace "stm32l1_gpio_AF_e" "e_stm32l1_gpio_af"
ttc_manage.pl replace "stm32l1_gpio_mode_e" "e_stm32l1_gpio_mode"
ttc_manage.pl replace "stm32l1_gpio_otype_e" "e_stm32l1_gpio_otype"
ttc_manage.pl replace "stm32l1_gpio_pupd_e" "e_stm32l1_gpio_pupd"
ttc_manage.pl replace "stm32l1_gpio_speed_e" "e_stm32l1_gpio_speed"
ttc_manage.pl replace "stm32l1_register_DAC_t" "t_stm32l1_register_dac"
ttc_manage.pl replace "stm32l1_register_exti_t" "t_stm32l1_register_exti"
ttc_manage.pl replace "stm32l1_register_i2c_t" "t_stm32l1_register_i2c"
ttc_manage.pl replace "stm32l1_register_usart_t" "t_stm32l1_register_usart"
ttc_manage.pl replace "stm32l1_TIM2_OR_t" "t_stm32l1_tim2_or"
ttc_manage.pl replace "stm32l1_TIM3_OR_t" "t_stm32l1_tim3_or"
ttc_manage.pl replace "stm32l1_TIMx_CCMR1_input_capture_mode_t" "t_stm32l1_timx_ccmr1_input_capture_mode"
ttc_manage.pl replace "stm32l1_TIMx_CCMR2_input_capture_mode_t" "t_stm32l1_timx_ccmr2_input_capture_mode"
ttc_manage.pl replace "stm32l1__t" "t_stm32l1_unknown"
ttc_manage.pl replace "stm32l1_USART_BRR_t" "t_stm32l1_usart_brr"
ttc_manage.pl replace "stm32l1_USART_CR1_t" "t_stm32l1_usart_cr1"
ttc_manage.pl replace "stm32l1_USART_CR2_t" "t_stm32l1_usart_cr2"
ttc_manage.pl replace "stm32l1_USART_CR3_t" "t_stm32l1_usart_cr3"
ttc_manage.pl replace "stm32l1_USART_DR_t" "t_stm32l1_usart_dr"
ttc_manage.pl replace "stm32l1_USART_GTPR_t" "t_stm32l1_usart_gtpr"
ttc_manage.pl replace "stm32l1_USART_SR_t" "t_stm32l1_usart_sr"
ttc_manage.pl replace "stm32l1xx_interrupt_usart_errors_t" "t_stm32l1xx_interrupt_usart_errors"
ttc_manage.pl replace "stm32_spi_architecture_t" "t_stm32_spi_architecture"
ttc_manage.pl replace "stm32w_Port_t" "t_stm32w_port"
ttc_manage.pl replace "stm32w_usart_architecture_t" "t_stm32w_usart_architecture"
ttc_manage.pl replace "STRING_Register_t" "t_string_register"
ttc_manage.pl replace "SYSCLOCK_Register_t" "t_sysclock_register"
ttc_manage.pl replace "sysclock_stm32f1xx_SourcePLL_e" "e_sysclock_stm32f1xx_sourcepll"
ttc_manage.pl replace "sysclock_stm32l1xx_mco_source_e" "e_sysclock_stm32l1xx_mco_source"
ttc_manage.pl replace "sysclock_stm32l1xx_sysclock_source_e" "e_sysclock_stm32l1xx_sysclock_source"
ttc_manage.pl replace "sysclock_update_item_t" "t_sysclock_update_item"
ttc_manage.pl replace "SYSTICK_Register_t" "t_systick_register"
ttc_manage.pl replace "TCPIP_Register_t" "t_tcpip_register"
ttc_manage.pl replace "tgp_e" "e_tgp"
ttc_manage.pl replace "TIM10_to_TIM11_CCMR1_output_compare_mode_t" "t_tim10_to_tim11_ccmr1_output_compare_mode"
ttc_manage.pl replace "TIM2_OR_t" "t_tim2_or"
ttc_manage.pl replace "TIM3_OR_t" "t_tim3_or"
ttc_manage.pl replace "TIMER_Register_t" "t_timer_register"
ttc_manage.pl replace "timer_stm32l1xx_clock_source_e" "e_timer_stm32l1xx_clock_source"
ttc_manage.pl replace "TIMx_BDTR_t" "t_timx_bdtr"
ttc_manage.pl replace "TIMx_CCMR1_input_capture_mode_t" "t_timx_ccmr1_input_capture_mode"
ttc_manage.pl replace "TIMx_CCMR1_t" "t_timx_ccmr1"
ttc_manage.pl replace "TIMx_CCMR2_input_capture_mode_t" "t_timx_ccmr2_input_capture_mode"
ttc_manage.pl replace "TIMx_CCMR2_t" "t_timx_ccmr2"
ttc_manage.pl replace "TIMx_OR_t" "t_timx_or"
ttc_manage.pl replace "tit_InputAreaShape_e" "e_tit_inputareashape"
ttc_manage.pl replace "tit_InputArea_t" "t_tit_inputarea"
ttc_manage.pl replace "tit_MouseEvent_e" "e_tit_mouseevent"
ttc_manage.pl replace "tit_ScrollData_t" "t_tit_scrolldata"
ttc_manage.pl replace "tnt_macstack_e" "e_tnt_macstack"
ttc_manage.pl replace "tnt_protocol_e" "e_tnt_protocol"
ttc_manage.pl replace "tnt_stack_e" "e_tnt_stack"
ttc_manage.pl replace "touchpad_analog4_pins_t" "t_touchpad_analog4_pins"
ttc_manage.pl replace "tss_flags_t" "t_tss_flags"
ttc_manage.pl replace "ttc_accelerometer_architecture_e" "e_ttc_accelerometer_architecture"
ttc_manage.pl replace "ttc_accelerometer_errorcode_e" "e_ttc_accelerometer_errorcode"
ttc_manage.pl replace "ttc_accelerometer_measures_t" "t_ttc_accelerometer_measures"
ttc_manage.pl replace "ttc_accelerometer_physical_index_e" "e_ttc_accelerometer_physical_index"
ttc_manage.pl replace "ttc_adc_architecture_e" "e_ttc_adc_architecture"
ttc_manage.pl replace "ttc_adc_config_bits_t" "t_ttc_adc_config_bits"
ttc_manage.pl replace "ttc_adc_errorcode_e" "e_ttc_adc_errorcode"
ttc_manage.pl replace "ttc_assert_origin_e" "e_ttc_assert_origin"
ttc_manage.pl replace "ttc_basic_architecture_e" "e_ttc_basic_architecture"
ttc_manage.pl replace "ttc_basic_errorcode_e" "e_ttc_basic_errorcode"
ttc_manage.pl replace "ttc_board_architecture_e" "e_ttc_board_architecture"
ttc_manage.pl replace "ttc_board_errorcode_e" "e_ttc_board_errorcode"
ttc_manage.pl replace "ttc_board_features_t" "t_ttc_board_features"
ttc_manage.pl replace "ttc_can_architecture_e" "e_ttc_can_architecture"
ttc_manage.pl replace "ttc_can_arch_t" "t_ttc_can_arch"
ttc_manage.pl replace "ttc_can_bit_segment1_e" "e_ttc_can_bit_segment1"
ttc_manage.pl replace "ttc_can_bit_segment2_e" "e_ttc_can_bit_segment2"
ttc_manage.pl replace "ttc_can_errorcode_e" "e_ttc_can_errorcode"
ttc_manage.pl replace "ttc_can_filter_t" "t_ttc_can_filter"
ttc_manage.pl replace "ttc_can_message_t" "t_ttc_can_message"
ttc_manage.pl replace "ttc_can_physical_index_e" "e_ttc_can_physical_index"
ttc_manage.pl replace "ttc_can_tx_status_e" "e_ttc_can_tx_status"
ttc_manage.pl replace "ttc_channel_errorcode_e" "e_ttc_channel_errorcode"
ttc_manage.pl replace "ttc_channel_node_application_t" "t_ttc_channel_node_application"
ttc_manage.pl replace "ttc_channel_node_generic_t" "t_ttc_channel_node_generic"
ttc_manage.pl replace "ttc_channel_node_t" "t_ttc_channel_node"
ttc_manage.pl replace "ttc_channel_t" "t_ttc_channel"
ttc_manage.pl replace "ttc_cpu_architecture_e" "e_ttc_cpu_architecture"
ttc_manage.pl replace "ttc_cpu_errorcode_e" "e_ttc_cpu_errorcode"
ttc_manage.pl replace "ttc_cpu_info_t" "t_ttc_cpu_info"
ttc_manage.pl replace "ttc_cpu_variant_e" "e_ttc_cpu_variant"
ttc_manage.pl replace "ttc_dac_architecture_e" "e_ttc_dac_architecture"
ttc_manage.pl replace "ttc_DAC_arch_t" "t_ttc_dac_arch"
ttc_manage.pl replace "ttc_dac_errorcode_e" "e_ttc_dac_errorcode"
ttc_manage.pl replace "ttc_dac_physical_index_e" "e_ttc_dac_physical_index"
ttc_manage.pl replace "ttc_dma_architecture_e" "e_ttc_dma_architecture"
ttc_manage.pl replace "ttc_dma_errorcode_e" "e_ttc_dma_errorcode"
ttc_manage.pl replace "ttc_dma_physical_index_e" "e_ttc_dma_physical_index"
ttc_manage.pl replace "ttc_ethernet_architecture_e" "e_ttc_ethernet_architecture"
ttc_manage.pl replace "ttc_ethernet_errorcode_e" "e_ttc_ethernet_errorcode"
ttc_manage.pl replace "ttc_ethernet_interface_e" "e_ttc_ethernet_interface"
ttc_manage.pl replace "ttc_ethernet_physical_e" "e_ttc_ethernet_physical"
ttc_manage.pl replace "ttc_ethernet_physical_index_e" "e_ttc_ethernet_physical_index"
ttc_manage.pl replace "ttc_font_data_t" "t_ttc_font_data"
ttc_manage.pl replace "ttc_font_generic_t" "t_ttc_font_generic"
ttc_manage.pl replace "ttc_gfx_architecture_e" "e_ttc_gfx_architecture"
ttc_manage.pl replace "ttc_gfx_driver_e" "e_ttc_gfx_driver"
ttc_manage.pl replace "ttc_gfx_errorcode_e" "e_ttc_gfx_errorcode"
ttc_manage.pl replace "ttc_gfx_generic_t" "t_ttc_gfx_generic"
ttc_manage.pl replace "ttc_gfx_mt_char_t" "t_ttc_gfx_mt_char"
ttc_manage.pl replace "ttc_gfx_mt_circle_t" "t_ttc_gfx_mt_circle"
ttc_manage.pl replace "ttc_gfx_mt_clear_t" "t_ttc_gfx_mt_clear"
ttc_manage.pl replace "ttc_gfx_mt_color_t" "t_ttc_gfx_mt_color"
ttc_manage.pl replace "ttc_gfx_mt_line_t" "t_ttc_gfx_mt_line"
ttc_manage.pl replace "ttc_gfx_mt_position_t" "t_ttc_gfx_mt_position"
ttc_manage.pl replace "ttc_gfx_mt_rect_t" "t_ttc_gfx_mt_rect"
ttc_manage.pl replace "ttc_gfx_mt_string_t" "t_ttc_gfx_mt_string"
ttc_manage.pl replace "ttc_gfx_mt_union_t" "t_ttc_gfx_mt_union"
ttc_manage.pl replace "ttc_gfx_physical_index_e" "e_ttc_gfx_physical_index"
ttc_manage.pl replace "ttc_gpio_architecture_e" "e_ttc_gpio_architecture"
ttc_manage.pl replace "ttc_gpio_errorcode_e" "e_ttc_gpio_errorcode"
ttc_manage.pl replace "ttc_gpio_mode_e" "e_ttc_gpio_mode"
ttc_manage.pl replace "ttc_gpio_speed_e" "e_ttc_gpio_speed"
ttc_manage.pl replace "ttc_gyroscope_architecture_e" "e_ttc_gyroscope_architecture"
ttc_manage.pl replace "ttc_gyroscope_errorcode_e" "e_ttc_gyroscope_errorcode"
ttc_manage.pl replace "ttc_gyroscope_measures_t" "t_ttc_gyroscope_measures"
ttc_manage.pl replace "ttc_gyroscope_physical_index_e" "e_ttc_gyroscope_physical_index"
ttc_manage.pl replace "ttc_heap_architecture_e" "e_ttc_heap_architecture"
ttc_manage.pl replace "ttc_heap_block_from_pool_t" "t_ttc_heap_block_from_pool"
ttc_manage.pl replace "ttc_heap_block_t" "t_ttc_heap_block"
ttc_manage.pl replace "ttc_heap_errorcode_e" "e_ttc_heap_errorcode"
ttc_manage.pl replace "ttc_heap_physical_index_e" "e_ttc_heap_physical_index"
ttc_manage.pl replace "ttc_heap_pool_block_debug_t" "t_ttc_heap_pool_block_debug"
ttc_manage.pl replace "ttc_heap_pool_debug_t" "t_ttc_heap_pool_debug"
ttc_manage.pl replace "ttc_heap_pool_statistics_t" "t_ttc_heap_pool_statistics"
ttc_manage.pl replace "ttc_heap_pool_t" "t_ttc_heap_pool"
ttc_manage.pl replace "ttc_heap_record_t" "t_ttc_heap_record"
ttc_manage.pl replace "ttc_i2c_address_type_e" "e_ttc_i2c_address_type"
ttc_manage.pl replace "ttc_i2c_architecture_e" "e_ttc_i2c_architecture"
ttc_manage.pl replace "ttc_i2c_architecture_t" "t_ttc_i2c_architecture"
ttc_manage.pl replace "ttc_i2c_errorcode_e" "e_ttc_i2c_errorcode"
ttc_manage.pl replace "ttc_i2c_error_t" "t_ttc_i2c_error"
ttc_manage.pl replace "ttc_i2c_event_code_e" "e_ttc_i2c_event_code"
ttc_manage.pl replace "ttc_i2c_event_t" "t_ttc_i2c_event"
ttc_manage.pl replace "ttc_i2c_flag_code_e" "e_ttc_i2c_flag_code"
ttc_manage.pl replace "ttc_input_architecture_e" "e_ttc_input_architecture"
ttc_manage.pl replace "ttc_input_area_t" "t_ttc_input_area"
ttc_manage.pl replace "ttc_input_driver_e" "e_ttc_input_driver"
ttc_manage.pl replace "ttc_input_errorcode_e" "e_ttc_input_errorcode"
ttc_manage.pl replace "ttc_input_event_e" "e_ttc_input_event"
ttc_manage.pl replace "ttc_interface_architecture_e" "e_ttc_interface_architecture"
ttc_manage.pl replace "ttc_interface_errorcode_e" "e_ttc_interface_errorcode"
ttc_manage.pl replace "ttc_interface_physical_index_e" "e_ttc_interface_physical_index"
ttc_manage.pl replace "ttc_interrupt_architecture_e" "e_ttc_interrupt_architecture"
ttc_manage.pl replace "ttc_interrupt_config_can_t" "t_ttc_interrupt_config_can"
ttc_manage.pl replace "ttc_interrupt_config_gpio_t" "t_ttc_interrupt_config_gpio"
ttc_manage.pl replace "ttc_interrupt_config_i2c_t" "t_ttc_interrupt_config_i2c"
ttc_manage.pl replace "ttc_interrupt_config_rtc_t" "t_ttc_interrupt_config_rtc"
ttc_manage.pl replace "ttc_interrupt_config_spi_t" "t_ttc_interrupt_config_spi"
ttc_manage.pl replace "ttc_interrupt_config_usart_t" "t_ttc_interrupt_config_usart"
ttc_manage.pl replace "ttc_interrupt_errorcode_e" "e_ttc_interrupt_errorcode"
ttc_manage.pl replace "ttc_interrupt_gpio_index_t" "t_ttc_interrupt_gpio_index"
ttc_manage.pl replace "ttc_interrupt_handle_t" "t_ttc_interrupt_handle"
ttc_manage.pl replace "ttc_interrupt_source_usart_t" "t_ttc_interrupt_source_usart"
ttc_manage.pl replace "ttc_interrupt_type_e" "e_ttc_interrupt_type"
ttc_manage.pl replace "ttc_interrupt_usart_errors_t" "t_ttc_interrupt_usart_errors"
ttc_manage.pl replace "ttc_layer_phy_architecture_e" "e_ttc_layer_phy_architecture"
ttc_manage.pl replace "ttc_layer_phy_errorcode_e" "e_ttc_layer_phy_errorcode"
ttc_manage.pl replace "ttc_layer_phy_physical_index_e" "e_ttc_layer_phy_physical_index"
ttc_manage.pl replace "ttc_list_error_e" "e_ttc_list_error"
ttc_manage.pl replace "ttc_list_item_t" "t_ttc_list_item"
ttc_manage.pl replace "ttc_list_operation_e" "e_ttc_list_operation"
ttc_manage.pl replace "ttc_ListSize_t" "t_ttc_listsize"
ttc_manage.pl replace "ttc_list_statistics_t" "t_ttc_list_statistics"
ttc_manage.pl replace "ttc_list_t" "t_ttc_list"
ttc_manage.pl replace "ttc_math_architecture_e" "e_ttc_math_architecture"
ttc_manage.pl replace "ttc_math_errorcode_e" "e_ttc_math_errorcode"
ttc_manage.pl replace "ttc_math_int_vector2d_rz_t" "t_ttc_math_int_vector2d_rz"
ttc_manage.pl replace "ttc_math_int_vector2d_xy_t" "t_ttc_math_int_vector2d_xy"
ttc_manage.pl replace "ttc_math_int_vector3d_ryz_t" "t_ttc_math_int_vector3d_ryz"
ttc_manage.pl replace "ttc_math_int_vector3d_xyz_t" "t_ttc_math_int_vector3d_xyz"
ttc_manage.pl replace "ttc_math_lateration_3d_t" "t_ttc_math_lateration_3d"
ttc_manage.pl replace "ttc_math_precision_e" "e_ttc_math_precision"
ttc_manage.pl replace "ttc_math_vector2d_rz_t" "t_ttc_math_vector2d_rz"
ttc_manage.pl replace "ttc_math_vector2d_xy_t" "t_ttc_math_vector2d_xy"
ttc_manage.pl replace "ttc_math_vector3d_ryz_t" "t_ttc_math_vector3d_ryz"
ttc_manage.pl replace "ttc_math_vector3d_xyz_t" "t_ttc_math_vector3d_xyz"
ttc_manage.pl replace "ttc_mutex_error_e" "e_ttc_mutex_error"
ttc_manage.pl replace "ttc_mutex_smart_t" "t_ttc_mutex_smart"
ttc_manage.pl replace "ttc_mutex_t" "t_ttc_mutex"
ttc_manage.pl replace "ttc_network_architecture_e" "e_ttc_network_architecture"
ttc_manage.pl replace "ttc_network_arch_t" "t_ttc_network_arch"
ttc_manage.pl replace "ttc_network_errorcode_e" "e_ttc_network_errorcode"
ttc_manage.pl replace "ttc_network_layer_architecture_e" "e_ttc_network_layer_architecture"
ttc_manage.pl replace "ttc_network_layer_errorcode_e" "e_ttc_network_layer_errorcode"
ttc_manage.pl replace "ttc_network_layer_physical_index_e" "e_ttc_network_layer_physical_index"
ttc_manage.pl replace "ttc_network_node_t" "t_ttc_network_node"
ttc_manage.pl replace "ttc_packet_address_format_e" "e_ttc_packet_address_format"
ttc_manage.pl replace "ttc_packet_address_t" "t_ttc_packet_address"
ttc_manage.pl replace "ttc_packet_category_e" "e_ttc_packet_category"
ttc_manage.pl replace "ttc_packet_debug_t" "t_ttc_packet_debug"
ttc_manage.pl replace "ttc_packet_errorcode_e" "e_ttc_packet_errorcode"
ttc_manage.pl replace "ttc_packet_meta_debug_t" "t_ttc_packet_meta_debug"
ttc_manage.pl replace "ttc_packet_meta_small_t" "t_ttc_packet_meta_small"
ttc_manage.pl replace "ttc_packet_pattern_e" "e_ttc_packet_pattern"
ttc_manage.pl replace "ttc_packet_payload_t" "t_ttc_packet_payload"
ttc_manage.pl replace "ttc_packet_status_tx_e" "e_ttc_packet_status_tx"
ttc_manage.pl replace "ttc_packet_t" "t_ttc_packet"
ttc_manage.pl replace "ttc_physical_index_e" "e_ttc_physical_index"
ttc_manage.pl replace "ttc_pwm_architecture_e" "e_ttc_pwm_architecture"
ttc_manage.pl replace "ttc_pwm_errorcode_e" "e_ttc_pwm_errorcode"
ttc_manage.pl replace "ttc_pwm_features_t" "t_ttc_pwm_features"
ttc_manage.pl replace "ttc_pwr_architecture_e" "e_ttc_pwr_architecture"
ttc_manage.pl replace "ttc_pwr_errorcode_e" "e_ttc_pwr_errorcode"
ttc_manage.pl replace "ttc_pwr_physical_index_e" "e_ttc_pwr_physical_index"
ttc_manage.pl replace "ttc_queue_bytes_t" "t_ttc_queue_bytes"
ttc_manage.pl replace "ttc_queue_error_e" "e_ttc_queue_error"
ttc_manage.pl replace "ttc_queue_generic_t" "t_ttc_queue_generic"
ttc_manage.pl replace "ttc_queue_pointers_t" "t_ttc_queue_pointers"
ttc_manage.pl replace "ttc_queue_waiting_task_t" "t_ttc_queue_waiting_task"
ttc_manage.pl replace "ttc_radio_architecture_e" "e_ttc_radio_architecture"
ttc_manage.pl replace "ttc_radio_configure_frame_filter_e" "e_ttc_radio_configure_frame_filter"
ttc_manage.pl replace "ttc_radio_distance_t" "t_ttc_radio_distance"
ttc_manage.pl replace "ttc_radio_driver_e" "e_ttc_radio_driver"
ttc_manage.pl replace "ttc_radio_errorcode_e" "e_ttc_radio_errorcode"
ttc_manage.pl replace "ttc_radio_features_t" "t_ttc_radio_features"
ttc_manage.pl replace "ttc_radio_job_protocol_t" "t_ttc_radio_job_protocol"
ttc_manage.pl replace "ttc_radio_packet_ranging_t" "t_ttc_radio_packet_ranging"
ttc_manage.pl replace "ttc_radio_packet_reply_localization_sstofcr_t" "t_ttc_radio_packet_reply_localization_sstofcr"
ttc_manage.pl replace "ttc_radio_packet_reply_ranging_sstof_t" "t_ttc_radio_packet_reply_ranging_sstof"
ttc_manage.pl replace "ttc_radio_packet_reply_ranging_t" "t_ttc_radio_packet_reply_ranging"
ttc_manage.pl replace "ttc_radio_packet_report_localization_sstofcr_t" "t_ttc_radio_packet_report_localization_sstofcr"
ttc_manage.pl replace "ttc_radio_packet_report_ranging_sstof_t" "t_ttc_radio_packet_report_ranging_sstof"
ttc_manage.pl replace "ttc_radio_packet_request_localization_sstofcr_t" "t_ttc_radio_packet_request_localization_sstofcr"
ttc_manage.pl replace "ttc_radio_packet_request_ranging_sstofcr_t" "t_ttc_radio_packet_request_ranging_sstofcr"
ttc_manage.pl replace "ttc_radio_packet_request_ranging_sstof_t" "t_ttc_radio_packet_request_ranging_sstof"
ttc_manage.pl replace "ttc_radio_packet_type_e" "e_ttc_radio_packet_type"
ttc_manage.pl replace "ttc_radio_payload_handshake_t" "t_ttc_radio_payload_handshake"
ttc_manage.pl replace "ttc_radio_physical_index_e" "e_ttc_radio_physical_index"
ttc_manage.pl replace "ttc_real_time_clock_architecture_e" "e_ttc_real_time_clock_architecture"
ttc_manage.pl replace "ttc_real_time_clock_arch_t" "t_ttc_real_time_clock_arch"
ttc_manage.pl replace "ttc_real_time_clock_errorcode_e" "e_ttc_real_time_clock_errorcode"
ttc_manage.pl replace "ttc_register_architecture_e" "e_ttc_register_architecture"
ttc_manage.pl replace "ttc_register_errorcode_e" "e_ttc_register_errorcode"
ttc_manage.pl replace "ttc_register_physical_index_e" "e_ttc_register_physical_index"
ttc_manage.pl replace "ttc_rtc_arch_t" "t_ttc_rtc_arch"
ttc_manage.pl replace "ttc_rtc_errorcode_e" "e_ttc_rtc_errorcode"
ttc_manage.pl replace "ttc_rtc_time_t" "t_ttc_rtc_time"
ttc_manage.pl replace "ttc_rtls_architecture_e" "e_ttc_rtls_architecture"
ttc_manage.pl replace "ttc_rtls_config_anchor_t" "t_ttc_rtls_config_anchor"
ttc_manage.pl replace "ttc_rtls_config_mobile_t" "t_ttc_rtls_config_mobile"
ttc_manage.pl replace "ttc_rtls_errorcode_e" "e_ttc_rtls_errorcode"
ttc_manage.pl replace "ttc_rtls_features_t" "t_ttc_rtls_features"
ttc_manage.pl replace "ttc_rtls_localization_t" "t_ttc_rtls_localization"
ttc_manage.pl replace "ttc_rtls_packet_e" "e_ttc_rtls_packet"
ttc_manage.pl replace "ttc_rtls_packet_t" "t_ttc_rtls_packet"
ttc_manage.pl replace "ttc_rtls_payload_header_t" "t_ttc_rtls_payload_header"
ttc_manage.pl replace "ttc_rtls_state_e" "e_ttc_rtls_state"
ttc_manage.pl replace "ttc_rtls_statistics_t" "t_ttc_rtls_statistics"
ttc_manage.pl replace "ttc_sdcard_architecture_e" "e_ttc_sdcard_architecture"
ttc_manage.pl replace "ttc_sdcard_errorcode_e" "e_ttc_sdcard_errorcode"
ttc_manage.pl replace "ttc_semaphore_error_e" "e_ttc_semaphore_error"
ttc_manage.pl replace "ttc_semaphore_smart_t" "t_ttc_semaphore_smart"
ttc_manage.pl replace "ttc_semaphore_t" "t_ttc_semaphore"
ttc_manage.pl replace "ttc_slam_architecture_e" "e_ttc_slam_architecture"
ttc_manage.pl replace "ttc_slam_box_t" "t_ttc_slam_box"
ttc_manage.pl replace "ttc_slam_distance_t" "t_ttc_slam_distance"
ttc_manage.pl replace "ttc_slam_errorcode_e" "e_ttc_slam_errorcode"
ttc_manage.pl replace "ttc_slam_features_t" "t_ttc_slam_features"
ttc_manage.pl replace "ttc_slam_node_t" "t_ttc_slam_node"
ttc_manage.pl replace "ttc_spi_architecture_e" "e_ttc_spi_architecture"
ttc_manage.pl replace "ttc_spi_architecture_t" "t_ttc_spi_architecture"
ttc_manage.pl replace "ttc_spi_errorcode_e" "e_ttc_spi_errorcode"
ttc_manage.pl replace "ttc_spi_generic_t" "t_ttc_spi_generic"
ttc_manage.pl replace "ttc_spi_physical_index_e" "e_ttc_spi_physical_index"
ttc_manage.pl replace "ttc_states_call_t" "t_ttc_states_call"
ttc_manage.pl replace "ttc_states_errorcode_e" "e_ttc_states_errorcode"
ttc_manage.pl replace "ttc_states_state_t" "t_ttc_states_state"
ttc_manage.pl replace "ttc_states_transition_e" "e_ttc_states_transition"
ttc_manage.pl replace "ttc_string_architecture_e" "e_ttc_string_architecture"
ttc_manage.pl replace "ttc_string_errorcode_e" "e_ttc_string_errorcode"
ttc_manage.pl replace "ttc_switch_architecture_e" "e_ttc_switch_architecture"
ttc_manage.pl replace "ttc_sysclock_architecture_e" "e_ttc_sysclock_architecture"
ttc_manage.pl replace "ttc_sysclock_errorcode_e" "e_ttc_sysclock_errorcode"
ttc_manage.pl replace "ttc_sysclock_oscillator_e" "e_ttc_sysclock_oscillator"
ttc_manage.pl replace "ttc_sysclock_profile_e" "e_ttc_sysclock_profile"
ttc_manage.pl replace "ttc_systick_architecture_e" "e_ttc_systick_architecture"
ttc_manage.pl replace "ttc_systick_delay_t" "t_ttc_systick_delay"
ttc_manage.pl replace "ttc_systick_errorcode_e" "e_ttc_systick_errorcode"
ttc_manage.pl replace "ttc_systick_features_t" "t_ttc_systick_features"
ttc_manage.pl replace "ttc_systick_profile_e" "e_ttc_systick_profile"
ttc_manage.pl replace "ttc_task_all_t" "t_ttc_task_all"
ttc_manage.pl replace "ttc_task_info_t" "t_ttc_task_info"
ttc_manage.pl replace "ttc_task_waiting_list_t" "t_ttc_task_waiting_list"
ttc_manage.pl replace "ttc_task_waiting_task_t" "t_ttc_task_waiting_task"
ttc_manage.pl replace "ttc_tcpip_architecture_e" "e_ttc_tcpip_architecture"
ttc_manage.pl replace "ttc_tcpip_errorcode_e" "e_ttc_tcpip_errorcode"
ttc_manage.pl replace "ttc_tcpip_physical_index_e" "e_ttc_tcpip_physical_index"
ttc_manage.pl replace "ttc_time_event_t" "t_ttc_time_event"
ttc_manage.pl replace "ttc_timer_architecture_e" "e_ttc_timer_architecture"
ttc_manage.pl replace "ttc_timer_arch_t" "t_ttc_timer_arch"
ttc_manage.pl replace "ttc_timer_errorcode_e" "e_ttc_timer_errorcode"
ttc_manage.pl replace "ttc_timer_physical_index_e" "e_ttc_timer_physical_index"
ttc_manage.pl replace "ttc_timer_statuscode_e" "e_ttc_timer_statuscode"
ttc_manage.pl replace "ttc_touchpad_architecture_e" "e_ttc_touchpad_architecture"
ttc_manage.pl replace "ttc_touchpad_errorcode_e" "e_ttc_touchpad_errorcode"
ttc_manage.pl replace "ttc_touchpad_update_e" "e_ttc_touchpad_update"
ttc_manage.pl replace "ttc_usart_architecture_e" "e_ttc_usart_architecture"
ttc_manage.pl replace "ttc_usart_architecture_t" "t_ttc_usart_architecture"
ttc_manage.pl replace "ttc_usart_errorcode_e" "e_ttc_usart_errorcode"
ttc_manage.pl replace "ttc_usart_physical_index_e" "e_ttc_usart_physical_index"
ttc_manage.pl replace "ttc_usb_errorcode_e" "e_ttc_usb_errorcode"
ttc_manage.pl replace "ttc_usb_generic_t" "t_ttc_usb_generic"
ttc_manage.pl replace "tut_httpd_state_t" "t_tut_httpd_state"
ttc_manage.pl replace "uip_stats_t" "t_uip_stats"
ttc_manage.pl replace "uip_tcp_appstate_t" "t_uip_tcp_appstate"
ttc_manage.pl replace "USART_BRR_t" "t_usart_brr"
ttc_manage.pl replace "USART_CR1_t" "t_usart_cr1"
ttc_manage.pl replace "USART_CR2_t" "t_usart_cr2"
ttc_manage.pl replace "USART_CR3_t" "t_usart_cr3"
ttc_manage.pl replace "USART_DR_t" "t_usart_dr"
ttc_manage.pl replace "USART_GPTR_t" "t_usart_gptr"
ttc_manage.pl replace "USART_Register_t" "t_usart_register"
ttc_manage.pl replace "USART_SR_t" "t_usart_sr"
ttc_manage.pl replace "ValueItem_t" "t_valueitem"
ttc_manage.pl replace "\.\./t_" "../"
ttc_manage.pl replace "ttc_mutexypes" "ttc_mutex_types"
ttc_manage.pl replace ""t_ttc_" ""ttc_"
ttc_manage.pl replace "ttc_t_" "t_ttc_"
ttc_manage.pl replace "t_ttc_registerypes" "ttc_register_types"
ttc_manage.pl replace "t_ttc_semaphoreypes" "ttc_semaphore_types"
ttc_manage.pl replace "t_ttc_packetypes" "ttc_packet_types"
ttc_manage.pl replace "ttc_semaphoreypes" "ttc_semaphore_types"
ttc_manage.pl replace "ttc_listypes" "ttc_list_types"
ttc_manage.pl replace "ttc_packetypes" "ttc_packet_types"
ttc_manage.pl replace "u32_t" "t_u32"
ttc_manage.pl replace "u16_t" "t_u16"
ttc_manage.pl replace "u8_t" "t_u8"
ttc_manage.pl replace "Base_signed_t" "t_base_signed"
ttc_manage.pl replace "ut_int8" "t_u8"
ttc_manage.pl replace "ut_int32" "t_u32"
ttc_manage.pl replace "ttc_usart_t_config" "t_ttc_usart_config"
ttc_manage.pl replace "rtls_simple4.c" "rtls_square4.c"
ttc_manage.pl replace "rtls_simple4.o" "rtls_square4.o"
ttc_manage.pl replace "rtls_simple4.h" "rtls_square4.h"
ttc_manage.pl replace "rtls_simple4_types.h" "rtls_square4_types.h"
ttc_manage.pl replace "simple4" "square4"
ttc_manage.pl replace "ttc_tcpip_t_config" "t_ttc_tcpip_config"
ttc_manage.pl replace "sysclock_stm32l1xx_t_config" "t_sysclock_stm32l1xx_config"
ttc_manage.pl replace "sysclock_stm32f1xx_t_config" "t_sysclock_stm32f1xx_config"
ttc_manage.pl replace "sysclock_stm32l0xx_t_config" "t_sysclock_stm32l0xx_config"
ttc_manage.pl replace "sysclock_stm32w1xx_t_config" "t_sysclock_stm32w1xx_config"
ttc_manage.pl replace "timer_stm32f1xx_t_config" "t_timer_stm32f1xx_config"
ttc_manage.pl replace "timer_stm32f0xx_t_config" "t_timer_stm32f0xx_config"
ttc_manage.pl replace "timer_stm32l1xx_t_config" "t_timer_stm32l1xx_config"
ttc_manage.pl replace "timer_stm32w1xx_t_config" "t_timer_stm32w1xx_config"
ttc_manage.pl replace "pwm_stm32l1xx_t_config" "t_pwm_stm32l1xx_config"
ttc_manage.pl replace "network_layer_usart_t_config" "t_network_layer_usart_config"
ttc_manage.pl replace "board_stm32l053_discovery_t_config" "t_board_stm32l053_discovery_config"
ttc_manage.pl replace "ttc_heap_t_config" "t_ttc_heap_config"
ttc_manage.pl replace "interrupt_stm32l1xx_t_config" "t_interrupt_stm32l1xx_config"
ttc_manage.pl replace "interrupt_stm32w1xx_t_config" "t_interrupt_stm32w1xx_config"
ttc_manage.pl replace "interrupt_stm32f1xx_t_config" "t_interrupt_stm32f1xx_config"
ttc_manage.pl replace "ttc_adc_t_config" "t_ttc_adc_config"
ttc_manage.pl replace "ttc_gfx_t_config" "t_ttc_gfx_config"
ttc_manage.pl replace "ttc_real_time_clock_t_config" "t_ttc_real_time_clock_config"
ttc_manage.pl replace "stm32f1_can_t_config" "t_stm32f1_can_config"
ttc_manage.pl replace "ttc_dac_t_config" "t_ttc_dac_config"
ttc_manage.pl replace "ttc_string_t_config" "t_ttc_string_config"
ttc_manage.pl replace "radio_dw1000_transmission_t_config" "t_radio_dw1000_transmission_config"
ttc_manage.pl replace "radio_dw1000_t_config" "t_radio_dw1000_config"
ttc_manage.pl replace "radio_stm32w1xx_t_config" "t_radio_stm32w1xx_config"
ttc_manage.pl replace "ttc_i2c_t_config" "t_ttc_i2c_config"
ttc_manage.pl replace "gyroscope_mpu6050_t_config" "t_gyroscope_mpu6050_config"
ttc_manage.pl replace "layer_phy_spi_t_config" "t_layer_phy_spi_config"
ttc_manage.pl replace "string_ascii_t_config" "t_string_ascii_config"
ttc_manage.pl replace "ttc_rtc_t_config" "t_ttc_rtc_config"
ttc_manage.pl replace "gpio_stm32l0xx_t_config" "t_gpio_stm32l0xx_config"
ttc_manage.pl replace "pwr_stm32l1xx_t_config" "t_pwr_stm32l1xx_config"
ttc_manage.pl replace "ttc_network_t_config" "t_ttc_network_config"
ttc_manage.pl replace "memory_stm32l0xx_t_config" "t_memory_stm32l0xx_config"
ttc_manage.pl replace "memory_stm32f1xx_t_config" "t_memory_stm32f1xx_config"
ttc_manage.pl replace "memory_stm32l1xx_t_config" "t_memory_stm32l1xx_config"
ttc_manage.pl replace "ttc_can_t_config" "t_ttc_can_config"
ttc_manage.pl replace "dma_stm32l1xx_t_config" "t_dma_stm32l1xx_config"
ttc_manage.pl replace "real_time_clock_stm32l1_t_config" "t_real_time_clock_stm32l1_config"
ttc_manage.pl replace "sdcard_spi_t_config" "t_sdcard_spi_config"
ttc_manage.pl replace "ttc_board_t_config" "t_ttc_board_config"
ttc_manage.pl replace "ttc_gyroscope_t_config" "t_ttc_gyroscope_config"
ttc_manage.pl replace "interface_ste101p_t_config" "t_interface_ste101p_config"
ttc_manage.pl replace "ttc_interrupt_t_config" "t_ttc_interrupt_config"
ttc_manage.pl replace "ttc_network_layer_t_config" "t_ttc_network_layer_config"
ttc_manage.pl replace "ttc_layer_phy_t_config" "t_ttc_layer_phy_config"
ttc_manage.pl replace "ttc_slam_t_config" "t_ttc_slam_config"
ttc_manage.pl replace "ttc_pwm_t_config" "t_ttc_pwm_config"
ttc_manage.pl replace "slam_simple_2d_t_config" "t_slam_simple_2d_config"
ttc_manage.pl replace "ttc_input_t_config" "t_ttc_input_config"
ttc_manage.pl replace "ttc_spi_t_config" "t_ttc_spi_config"
ttc_manage.pl replace "ttc_ethernet_t_config" "t_ttc_ethernet_config"
ttc_manage.pl replace "ttc_states_t_config" "t_ttc_states_config"
ttc_manage.pl replace "heap_freertos_t_config" "t_heap_freertos_config"
ttc_manage.pl replace "heap_zdefault_t_config" "t_heap_zdefault_config"
ttc_manage.pl replace "i2c_stm32f1xx_t_config" "t_i2c_stm32f1xx_config"
ttc_manage.pl replace "i2c_stm32l1xx_t_config" "t_i2c_stm32l1xx_config"
ttc_manage.pl replace "usart_stm32f1xx_t_config" "t_usart_stm32f1xx_config"
ttc_manage.pl replace "usart_stm32l1xx_t_config" "t_usart_stm32l1xx_config"
ttc_manage.pl replace "usart_stm32w1xx_t_config" "t_usart_stm32w1xx_config"
ttc_manage.pl replace "ttc_timer_t_config" "t_ttc_timer_config"
ttc_manage.pl replace "ttc_dma_t_config" "t_ttc_dma_config"
ttc_manage.pl replace "ttc_accelerometer_t_config" "t_ttc_accelerometer_config"
ttc_manage.pl replace "DAC_stm32l1_t_config" "t_DAC_stm32l1_config"
ttc_manage.pl replace "network_mac_t_config" "t_network_mac_config"
ttc_manage.pl replace "network_6lowpan_t_config" "t_network_6lowpan_config"
ttc_manage.pl replace "spi_stm32l0xx_t_config" "t_spi_stm32l0xx_config"
ttc_manage.pl replace "spi_stm32w1xx_t_config" "t_spi_stm32w1xx_config"
ttc_manage.pl replace "spi_stm32l1xx_t_config" "t_spi_stm32l1xx_config"
ttc_manage.pl replace "spi_stm32f1xx_t_config" "t_spi_stm32f1xx_config"
ttc_manage.pl replace "input_touchpad_t_config" "t_input_touchpad_config"
ttc_manage.pl replace "ttc_touchpad_t_config" "t_ttc_touchpad_config"
ttc_manage.pl replace "ttc_sdcard_t_config" "t_ttc_sdcard_config"
ttc_manage.pl replace "touchpad_analog4_t_config" "t_touchpad_analog4_config"
ttc_manage.pl replace "scs2_anchor_t_config" "t_scs2_anchor_config"
ttc_manage.pl replace "scs2_mobile_t_config" "t_scs2_mobile_config"
ttc_manage.pl replace "rtls_crtof_simple_2d_t_config" "t_rtls_crtof_simple_2d_config"
ttc_manage.pl replace "rtls_square4_t_config" "t_rtls_square4_config"
ttc_manage.pl replace "ttc_systick_t_config" "t_ttc_systick_config"
ttc_manage.pl replace "systick_freertos_t_config" "t_systick_freertos_config"
ttc_manage.pl replace "systick_cortexm3_t_config" "t_systick_cortexm3_config"
ttc_manage.pl replace "dac_stm32l1xx_t_config" "t_dac_stm32l1xx_config"
ttc_manage.pl replace "ttc_gpio_t_config" "t_ttc_gpio_config"
ttc_manage.pl replace "ttc_rtls_t_config" "t_ttc_rtls_config"
ttc_manage.pl replace "ethernet_stm32f107_t_config" "t_ethernet_stm32f107_config"
ttc_manage.pl replace "ttc_cpu_t_config" "t_ttc_cpu_config"
ttc_manage.pl replace "register_stm32l0xx_t_config" "t_register_stm32l0xx_config"
ttc_manage.pl replace "ttc_sysclock_t_config" "t_ttc_sysclock_config"
ttc_manage.pl replace "tcpip_uip_t_config" "t_tcpip_uip_config"
ttc_manage.pl replace "gfx_ili9320_t_config" "t_gfx_ili9320_config"
ttc_manage.pl replace "lcd_ili9320_t_config" "t_lcd_ili9320_config"
ttc_manage.pl replace "cpu_cortexm0_t_config" "t_cpu_cortexm0_config"
ttc_manage.pl replace "cpu_stm32w1xx_t_config" "t_cpu_stm32w1xx_config"
ttc_manage.pl replace "cpu_stm32l0xx_t_config" "t_cpu_stm32l0xx_config"
ttc_manage.pl replace "cpu_stm32f2xx_t_config" "t_cpu_stm32f2xx_config"
ttc_manage.pl replace "cpu_cortexm4_t_config" "t_cpu_cortexm4_config"
ttc_manage.pl replace "cpu_stm32f4xx_t_config" "t_cpu_stm32f4xx_config"
ttc_manage.pl replace "cpu_stm32l1xx_t_config" "t_cpu_stm32l1xx_config"
ttc_manage.pl replace "cpu_stm32f0xx_t_config" "t_cpu_stm32f0xx_config"
ttc_manage.pl replace "cpu_stm32f1xx_t_config" "t_cpu_stm32f1xx_config"
ttc_manage.pl replace "cpu_stm32f3xx_t_config" "t_cpu_stm32f3xx_config"
ttc_manage.pl replace "ttc_interface_t_config" "t_ttc_interface_config"
ttc_manage.pl replace "rtc_stm32f1xx_t_config" "t_rtc_stm32f1xx_config"
ttc_manage.pl replace "rtc_stm32l1_t_config" "t_rtc_stm32l1_config"
ttc_manage.pl replace "rtc_stm32l1xx_t_config" "t_rtc_stm32l1xx_config"
ttc_manage.pl replace "ttc_radio_t_config" "t_ttc_radio_config"
ttc_manage.pl replace "ttc_pwr_t_config" "t_ttc_pwr_config"
ttc_manage.pl replace "Example_Ttc_Packe" "t_Example_T_Packe"
ttc_manage.pl replace "_t_config" "t__config"
ttc_manage.pl replace "t_Example_T_Packe" "Example_ttc_Packet"
ttc_manage.pl replace "ttc_basict__config" "t_ttc_basic_config"
ttc_manage.pl replace "ttc_matht__config" "t_ttc_math_config"
ttc_manage.pl replace "ttc_usbt__config" "t_ttc_usb_config"
ttc_manage.pl replace "ttc_DACt__config" "t_ttc_dac_config"
ttc_manage.pl replace "interrupt_drivert__configimer_t" "t_interrupt_driver_config_timer"
ttc_manage.pl replace "ttc_memoryt__config" "t_ttc_memory_config"
ttc_manage.pl replace "ttc_assertt__config" "t_ttc_assert_config"
ttc_manage.pl replace "touchpadt__config" "t_touchpad_config"
ttc_manage.pl replace "ttc_cm0t__config" "t_ttc_cm0_config"
ttc_manage.pl replace "board_stm32l152_discoveryt__config" "t_board_stm32l152_discovery_config"
ttc_manage.pl replace "board_stm32l100c_discoveryt__config" "t_board_stm32l100c_discovery_config"
ttc_manage.pl replace "basic_stm32l1xxt__config" "t_basic_stm32l1xx_config"
ttc_manage.pl replace "ttc_ADCt__config" "t_ttc_adc__config"
ttc_manage.pl replace "stm32w_usartt__config" "t_stm32w_usart_config"
ttc_manage.pl replace "packet_802154t__config" "t_packet_802154_config"
ttc_manage.pl replace "dwtt__config" "t_dwt_config"
ttc_manage.pl replace "ttc_packet_architecture_e" "e_ttc_packet_architecture"
ttc_manage.pl replace "ttc_GYROSCOPE_architecture_e" "e_ttc_gyroscope_architecture"
ttc_manage.pl replace "ttc_sboard_architecture_e" "e_ttc_board_architecture"
ttc_manage.pl replace "ttc_spwm_architecture_e" "e_ttc_pwm_architecture"
ttc_manage.pl replace "ttc_ADC_architecture_e" "e_ttc_adc_architecture"
ttc_manage.pl replace "ttc_srtls_architecture_e" "e_ttc_rtls_architecture"
ttc_manage.pl replace "ttc_ssystick_architecture_e" "e_ttc_systick_architecture"
ttc_manage.pl replace "example_benchmarks.o" "DEPRECATED_example_benchmarks.o"
ttc_manage.pl replace "ttc_gpio_t_register" "t_ttc_gpio_register"
ttc_manage.pl replace "ttc_gpio_bank_t" "t_ttc_gpio_bank"
ttc_manage.pl replace "etp_nodet__config" "t_etp_node_config"
ttc_manage.pl replace "ttc_gpio_pin_e" "e_ttc_gpio_pin"
ttc_manage.pl replace "t_ttc_packetype_e" "e_ttc_packet_type"
ttc_manage.pl replace "t_ttc_packetype_" "ttc_packet_type_"
ttc_manage.pl replace "ta_packet_Unknown" "ttc_packet_type_Unknown"
ttc_manage.pl replace " ttc_packet_category_" " E_ttc_packet_category_"
ttc_manage.pl replace " ttc_packet_address_" " E_ttc_packet_address_"
ttc_manage.pl replace " ttc_packet_type_" " E_ttc_packet_type_"
ttc_manage.pl replace " ttc_packet_pattern_" " E_ttc_packet_pattern_"
ttc_manage.pl replace "t_ttc_semaphoreake_isr" "ttc_semaphore_take_isr"
ttc_manage.pl replace "t_ttc_semaphoreake_try" "ttc_semaphore_take_try"
ttc_manage.pl replace "t_ttc_semaphoreake" "ttc_semaphore_take"
ttc_manage.pl replace "E_ttc_packet_address_reply" "ttc_packet_address_reply"
ttc_manage.pl replace "E_ttc_packet_pattern_matches" "ttc_packet_pattern_matches"
ttc_manage.pl replace "t_ttc_heap_poolo_list_item" "ttc_heap_pool_to_list_item"
ttc_manage.pl replace "TTC_HEAP_SAFE_ARRAYS" "ENABLE_TTC_BASIC_SAFE_ARRAYS"
ttc_manage.pl replace "ttc_packet_mac_t" "t_ttc_packet_mac"
ttc_manage.pl replace "t_ttc_packetimestamp_40_u" "u_ttc_packetimestamp_40"
ttc_manage.pl replace "ttc_packet_meta_t" "t_ttc_packet_meta"
ttc_manage.pl replace "e_radio_dw1000_registerc_ctrl_u" "u_radio_dw1000_register_ec_ctrl"
ttc_manage.pl replace "packet_802154_fcf_u" "u_packet_802154_fcf"
ttc_manage.pl replace "radio_dw1000_load_from_otp_u" "u_radio_dw1000_load_from_otp"
ttc_manage.pl replace "radio_dw1000_register_agc_ctrl1_u" "u_radio_dw1000_register_agc_ctrl1"
ttc_manage.pl replace "radio_dw1000_register_agc_stat1_u" "u_radio_dw1000_register_agc_stat1"
ttc_manage.pl replace "radio_dw1000_register_aon_cfg0_u" "u_radio_dw1000_register_aon_cfg0"
ttc_manage.pl replace "radio_dw1000_register_aon_cfg1_u" "u_radio_dw1000_register_aon_cfg1"
ttc_manage.pl replace "radio_dw1000_register_aon_ctrl_u" "u_radio_dw1000_register_aon_ctrl"
ttc_manage.pl replace "radio_dw1000_register_aon_wcfg_u" "u_radio_dw1000_register_aon_wcfg"
ttc_manage.pl replace "radio_dw1000_register_chan_ctrl_u" "u_radio_dw1000_register_chan_ctrl"
ttc_manage.pl replace "radio_dw1000_register_first_path_u" "u_radio_dw1000_register_first_path"
ttc_manage.pl replace "radio_dw1000_register_fs_xtalt_u" "u_radio_dw1000_register_fs_xtalt"
ttc_manage.pl replace "radio_dw1000_register_gpio_dir_u" "u_radio_dw1000_register_gpio_dir"
ttc_manage.pl replace "radio_dw1000_register_gpio_dout_u" "u_radio_dw1000_register_gpio_dout"
ttc_manage.pl replace "radio_dw1000_register_gpio_ibes_u" "u_radio_dw1000_register_gpio_ibes"
ttc_manage.pl replace "radio_dw1000_register_gpio_iclr_u" "u_radio_dw1000_register_gpio_iclr"
ttc_manage.pl replace "radio_dw1000_register_gpio_idbe_u" "u_radio_dw1000_register_gpio_idbe"
ttc_manage.pl replace "radio_dw1000_register_gpio_imode_u" "u_radio_dw1000_register_gpio_imode"
ttc_manage.pl replace "radio_dw1000_register_gpio_irqe_u" "u_radio_dw1000_register_gpio_irqe"
ttc_manage.pl replace "radio_dw1000_register_gpio_isen_u" "u_radio_dw1000_register_gpio_isen"
ttc_manage.pl replace "radio_dw1000_register_gpio_mode_u" "u_radio_dw1000_register_gpio_mode"
ttc_manage.pl replace "radio_dw1000_register_gpio_raw_u" "u_radio_dw1000_register_gpio_raw"
ttc_manage.pl replace "radio_dw1000_register_lde_cfg1_u" "u_radio_dw1000_register_lde_cfg1"
ttc_manage.pl replace "radio_dw1000_register_otp_ctrl_u" "u_radio_dw1000_register_otp_ctrl"
ttc_manage.pl replace "radio_dw1000_register_otp_sf_u" "u_radio_dw1000_register_otp_sf"
ttc_manage.pl replace "radio_dw1000_register_otp_stat_u" "u_radio_dw1000_register_otp_stat"
ttc_manage.pl replace "radio_dw1000_register_pmsc_ctrl0_u" "u_radio_dw1000_register_pmsc_ctrl0"
ttc_manage.pl replace "radio_dw1000_register_pmsc_ctrl1_u" "u_radio_dw1000_register_pmsc_ctrl1"
ttc_manage.pl replace "radio_dw1000_register_pmsc_ledc_u" "u_radio_dw1000_register_pmsc_ledc"
ttc_manage.pl replace "radio_dw1000_register_rf_conf_u" "u_radio_dw1000_register_rf_conf"
ttc_manage.pl replace "radio_dw1000_register_rf_status_u" "u_radio_dw1000_register_rf_status"
ttc_manage.pl replace "radio_dw1000_register_rx_finfo_u" "u_radio_dw1000_register_rx_finfo"
ttc_manage.pl replace "radio_dw1000_register_rx_fqual_u" "u_radio_dw1000_register_rx_fqual"
ttc_manage.pl replace "radio_dw1000_register_rx_sniff_u" "u_radio_dw1000_register_rx_sniff"
ttc_manage.pl replace "radio_dw1000_register_rx_ttcko_u" "u_radio_dw1000_register_rx_ttcko"
ttc_manage.pl replace "radio_dw1000_register_sys_cfg_u" "u_radio_dw1000_register_sys_cfg"
ttc_manage.pl replace "radio_dw1000_register_sys_ctrl_u" "u_radio_dw1000_register_sys_ctrl"
ttc_manage.pl replace "radio_dw1000_register_sys_mask_u" "u_radio_dw1000_register_sys_mask"
ttc_manage.pl replace "radio_dw1000_register_sys_state_u" "u_radio_dw1000_register_sys_state"
ttc_manage.pl replace "radio_dw1000_register_sys_status_u" "u_radio_dw1000_register_sys_status"
ttc_manage.pl replace "radio_dw1000_t_registerx_fctrl_u" "u_radio_dw1000_t_registerx_fctrl"
ttc_manage.pl replace "register_stm32f1xx_timx_btdr_u" "u_register_stm32f1xx_timx_btdr"
ttc_manage.pl replace "register_stm32f1xx_timx_ccer_u" "u_register_stm32f1xx_timx_ccer"
ttc_manage.pl replace "register_stm32f1xx_timx_ccmr1_u" "u_register_stm32f1xx_timx_ccmr1"
ttc_manage.pl replace "register_stm32f1xx_timx_ccmr2_u" "u_register_stm32f1xx_timx_ccmr2"
ttc_manage.pl replace "register_stm32f1xx_timx_cr1_u" "u_register_stm32f1xx_timx_cr1"
ttc_manage.pl replace "register_stm32f1xx_timx_cr2_u" "u_register_stm32f1xx_timx_cr2"
ttc_manage.pl replace "register_stm32f1xx_timx_dcr_u" "u_register_stm32f1xx_timx_dcr"
ttc_manage.pl replace "register_stm32f1xx_timx_dier_u" "u_register_stm32f1xx_timx_dier"
ttc_manage.pl replace "register_stm32f1xx_timx_egr_u" "u_register_stm32f1xx_timx_egr"
ttc_manage.pl replace "register_stm32f1xx_timx_smcr_u" "u_register_stm32f1xx_timx_smcr"
ttc_manage.pl replace "register_stm32f1xx_timx_sr_u" "u_register_stm32f1xx_timx_sr"
ttc_manage.pl replace "TIMx_CR1_u" "u_TIMx_CR1"
ttc_manage.pl replace "TIMx_DIER_u" "u_TIMx_DIER"
ttc_manage.pl replace "TIMx_SR_u" "u_TIMx_SR"
ttc_manage.pl replace "ttc_board_architecture_u" "u_ttc_board_architecture"
ttc_manage.pl replace "ttc_channel_device_u" "u_ttc_channel_device"
ttc_manage.pl replace "ttc_gfx_architecture_u" "u_ttc_gfx_architecture"
ttc_manage.pl replace "ttc_i2c_Address_7Bit_u" "u_ttc_i2c_Address_7Bit"
ttc_manage.pl replace "ttc_i2c_architecture_u" "u_ttc_i2c_architecture"
ttc_manage.pl replace "ttc_packet_architecture_u" "u_ttc_packet_architecture"
ttc_manage.pl replace "ttc_packet_timestamp_40_u" "u_ttc_packet_timestamp_40"
ttc_manage.pl replace "ttc_pwm_architecture_u" "u_ttc_pwm_architecture"
ttc_manage.pl replace "ttc_radio_frame_filter_u" "u_ttc_radio_frame_filter"
ttc_manage.pl replace "ttc_radio_ranging_message_u" "u_ttc_radio_ranging_message"
ttc_manage.pl replace "ttc_rtls_architecture_u" "u_ttc_rtls_architecture"
ttc_manage.pl replace "ttc_sdcard_architecture_u" "u_ttc_sdcard_architecture"
ttc_manage.pl replace "ttc_slam_architecture_u" "u_ttc_slam_architecture"
ttc_manage.pl replace "ttc_slam_node_driver_u" "u_ttc_slam_node_driver"
ttc_manage.pl replace "ttc_slam_nodes_u" "u_ttc_slam_nodes"
ttc_manage.pl replace "ttc_states_architecture_u" "u_ttc_states_architecture"
ttc_manage.pl replace "ttc_string_architecture_u" "u_ttc_string_architecture"
ttc_manage.pl replace "ttc_systick_architecture_u" "u_ttc_systick_architecture"
ttc_manage.pl replace "ttc_tcpip_address_IP4_u" "u_ttc_tcpip_address_IP4"
ttc_manage.pl replace "ttc_touchpad_architecture_u" "u_ttc_touchpad_architecture"
ttc_manage.pl replace "USART_CR1_u" "u_USART_CR1"
ttc_manage.pl replace "USART_CR2_u" "u_USART_CR2"
ttc_manage.pl replace "USART_CR3_u" "u_USART_CR3"
ttc_manage.pl replace "register_stm32l1xx_all_t" "t_register_stm32l1xx_all"
ttc_manage.pl replace "ttc_register_architecture_t" "t_ttc_register_architecture"
ttc_manage.pl replace "ttc_accelerometer_architecture_t" "t_ttc_accelerometer_architecture"
ttc_manage.pl replace "ttc_adc_architecture_t" "t_ttc_adc_architecture"
ttc_manage.pl replace "ttc_array_define" "t_ttc_array_defi"
ttc_manage.pl replace "t_ttc_array_defi_extern" "t_t_ttc_array_defi_exte"
ttc_manage.pl replace "ttc_array_dynamic" "t_ttc_array_dynam"
ttc_manage.pl replace "t_ttc_array_dynam_extern" "t_t_ttc_array_dynam_exte"
ttc_manage.pl replace "ttc_basic_architecture_t" "t_ttc_basic_architecture"
ttc_manage.pl replace "ttc_board_architecture_t" "t_ttc_board_architecture"
ttc_manage.pl replace "ttc_can_architecture_t" "t_ttc_can_architecture"
ttc_manage.pl replace "ttc_cpu_architecture_t" "t_ttc_cpu_architecture"
ttc_manage.pl replace "ttc_dac_architecture_t" "t_ttc_dac_architecture"
ttc_manage.pl replace "ttc_dma_architecture_t" "t_ttc_dma_architecture"
ttc_manage.pl replace "ttc_ethernet_architecture_t" "t_ttc_ethernet_architecture"
ttc_manage.pl replace "ttc_gfx_architecture_t" "t_ttc_gfx_architecture"
ttc_manage.pl replace "ttc_gpio_t" "t_ttc_gpio"
ttc_manage.pl replace "ttc_gpio_values_t" "t_ttc_gpio_values"
ttc_manage.pl replace "ttc_gyroscope_architecture_t" "t_ttc_gyroscope_architecture"
ttc_manage.pl replace "ttc_heap_architecture_t" "t_ttc_heap_architecture"
ttc_manage.pl replace "ttc_i2c_base_register_t" "t_ttc_i2c_base_register"
ttc_manage.pl replace "ttc_input_architecture_t" "t_ttc_input_architecture"
ttc_manage.pl replace "ttc_interface_architecture_t" "t_ttc_interface_architecture"
ttc_manage.pl replace "ttc_interrupt_architecture_t" "t_ttc_interrupt_architecture"
ttc_manage.pl replace "ttc_layer_phy_architecture_t" "t_ttc_layer_phy_architecture"
ttc_manage.pl replace "ttc_memory_architecture_t" "t_ttc_memory_architecture"
ttc_manage.pl replace "ttc_network_layer_architecture_t" "t_ttc_network_layer_architecture"
ttc_manage.pl replace "ttc_packet_meta_lowlevel_t" "t_ttc_packet_meta_lowlevel"
ttc_manage.pl replace "ttc_Port_t" "t_ttc_Port"
ttc_manage.pl replace "ttc_pwm_architecture_t" "t_ttc_pwm_architecture"
ttc_manage.pl replace "ttc_pwr_architecture_t" "t_ttc_pwr_architecture"
ttc_manage.pl replace "ttc_radio_architecture_t" "t_ttc_radio_architecture"
ttc_manage.pl replace "ttc_rtc_architecture_t" "t_ttc_rtc_architecture"
ttc_manage.pl replace "ttc_rtls_architecture_t" "t_ttc_rtls_architecture"
ttc_manage.pl replace "ttc_sdcard_architecture_t" "t_ttc_sdcard_architecture"
ttc_manage.pl replace "ttc_string_architecture_t" "t_ttc_string_architecture"
ttc_manage.pl replace "ttc_sysclock_architecture_t" "t_ttc_sysclock_architecture"
ttc_manage.pl replace "ttc_systick_architecture_t" "t_ttc_systick_architecture"
ttc_manage.pl replace "ttc_tcpip_architecture_t" "t_ttc_tcpip_architecture"
ttc_manage.pl replace "ttc_timer_architecture_t" "t_ttc_timer_architecture"
ttc_manage.pl replace "ttc_touchpad_architecture_t" "t_ttc_touchpad_architecture"
ttc_manage.pl replace "ttc_usart_register_rx_t" "t_ttc_usart_register_rx"
ttc_manage.pl replace "ttc_usart_t_registerx_t" "t_ttc_usart_t_registerx"
ttc_manage.pl replace "t_ttc_gpioypes.h" "ttc_gpio_types.h"
ttc_manage.pl replace "_e_gpio_stm32l1xx_banknable" "_gpio_stm32l1xx_bank_enable"
ttc_manage.pl replace "ta_board_stm32l100c_discovery" "E_ttc_board_architecture_stm32l100c_discovery"
ttc_manage.pl replace "ta_board_stm32l152_discovery" "E_ttc_board_architecture_stm32l152_discovery"
ttc_manage.pl replace "ta_board_stm32l053_discovery" "E_ttc_board_architecture_stm32l053_discovery"
ttc_manage.pl replace "ta_board_None" "E_ttc_board_architecture_none"
ttc_manage.pl replace "ta_board_Unknown" "E_ttc_board_architecture_unknown"
ttc_manage.pl replace "sensor_dwm_" "sensor_dwm1000_"
ttc_manage.pl replace "EXTENSION_board_sensor_dwm" "EXTENSION_board_sensor_dwm1000"
ttc_manage.pl replace "sensor_dwm" "sensor_dwm1000"
ttc_manage.pl replace "sensor_dwm10001000" "sensor_dwm1000"
ttc_manage.pl replace "ec_board_" "E_ttc_board_"
ttc_manage.pl replace "tgp_" "E_ttc_gpio_pin_"
ttc_manage.pl replace "e_tgp" "E_ttc_gpio_pin_e"
ttc_manage.pl replace "PIN_P" "TTC_GPIO_"
ttc_manage.pl replace "#include "ttc_basic.h"" "#include "ttc_basic.h"  // Include First! (basic datatypes and definitions)"
ttc_manage.pl replace "physical_index_t" "t_physical_index"
ttc_manage.pl replace "RCC_APB1_ENR" "APB1ENR"
ttc_manage.pl replace "RCC_APB2_ENR" "APB2ENR"
ttc_manage.pl replace "RCC_BDCR" "BDCR"
ttc_manage.pl replace "ttc_usart_t_register" "t_ttc_usart_register"
ttc_manage.pl replace "t_t_ttc_usart_registerx" "t_ttc_usart_register_tx"
ttc_manage.pl replace "t_ttc_packet_addressarget_set" "ttc_packet_address_target_set"
ttc_manage.pl replace "TTC_RADIO1_SPI" "TTC_RADIO1_INDEX_SPI"
ttc_manage.pl replace "TTC_RADIO2_SPI" "TTC_RADIO2_INDEX_SPI"
ttc_manage.pl replace "TTC_RADIO3_SPI" "TTC_RADIO3_INDEX_SPI"
ttc_manage.pl replace "TTC_RADIO4_SPI" "TTC_RADIO4_INDEX_SPI"
ttc_manage.pl replace "TTC_RADIO5_SPI" "TTC_RADIO5_INDEX_SPI"
ttc_manage.pl replace "TTC_RADIO6_SPI" "TTC_RADIO6_INDEX_SPI"
ttc_manage.pl replace "TTC_RADIO7_SPI" "TTC_RADIO7_INDEX_SPI"
ttc_manage.pl replace "TTC_RADIO8_SPI" "TTC_RADIO8_INDEX_SPI"
ttc_manage.pl replace "TTC_RADIO9_SPI" "TTC_RADIO9_INDEX_SPI"
ttc_manage.pl replace "TTC_RADIO10_SPI" "TTC_RADIO10_INDEX_SPI"
ttc_manage.pl replace "ProtocolType" "SocketID"
ttc_manage.pl replace "TTC_PACKET_MULTILAYER_PAYLOAD" "TTC_PACKET_SOCKET_BYTE"
ttc_manage.pl replace "protocol_new" "socket_new"
ttc_manage.pl replace "ProtocolJob" "SocketJob"
ttc_manage.pl replace "job_protocol" "job_socket"
ttc_manage.pl replace "Init.Protocol" "Init.SocketID"
ttc_manage.pl replace "E_ttc_packet_pattern_protocol_" "E_ttc_packet_pattern_socket_"
ttc_manage.pl replace "protocol_get" "socket_get"
ttc_manage.pl replace "ttc_packet_protocol" "ttc_packet_socket"
ttc_manage.pl replace "Init.SocketID" "Init.Pattern"
ttc_manage.pl replace "pattern_matches_protocol" "pattern_matches_socket"
ttc_manage.pl replace "protocol_iterator" "socket_iterator"
ttc_manage.pl replace "ta_interrupt_stm32l1xx" "E_ttc_interrupt_architecture_stm32l1xx"
ttc_manage.pl replace "ta_interrupt_" "E_ttc_interrupt_architecture_"
ttc_manage.pl replace "E_ttc_interrupt_architecture_None" "E_ttc_interrupt_architecture_none"
ttc_manage.pl replace "adc_stm32f1xx_device_s" "s_adc_stm32f1xx_device"
ttc_manage.pl replace "example_ttc_radio_ranging_anchor_list_s" "s_example_ttc_radio_ranging_anchor_list"
ttc_manage.pl replace "example_ttc_radio_ranging_common_list_s" "s_example_ttc_radio_ranging_common_list"
ttc_manage.pl replace "example_ttc_radio_ranging_mobile_list_s" "s_example_ttc_radio_ranging_mobile_list"
ttc_manage.pl replace "example_ttc_radio_ranging_observer_list_s" "s_example_ttc_radio_ranging_observer_list"
ttc_manage.pl replace "example_ttc_rtls_crtof_simple_2d_anchor_list_s" "s_example_ttc_rtls_crtof_simple_2d_anchor_list"
ttc_manage.pl replace "example_ttc_rtls_crtof_simple_2d_mobile_list_s" "s_example_ttc_rtls_crtof_simple_2d_mobile_list"
ttc_manage.pl replace "gni_NumberArea_s" "s_ttc_gui_number_area"
ttc_manage.pl replace "t_gni_numberarea" "t_ttc_gui_number_area"
ttc_manage.pl replace "heap_sdma_free_block_s" "s_heap_sdma_free_block"
ttc_manage.pl replace "heap_sdma_used_block_s" "s_heap_sdma_used_block"
ttc_manage.pl replace "input_helper_list_s" "s_input_helper_list"
ttc_manage.pl replace "packet_802154_ack_000000_s" "s_packet_802154_ack_000000"
ttc_manage.pl replace "packet_802154_auxiliary_security_s00_s" "s_packet_802154_auxiliary_security_s00"
ttc_manage.pl replace "packet_802154_auxiliary_security_s01_s" "s_packet_802154_auxiliary_security_s01"
ttc_manage.pl replace "packet_802154_auxiliary_security_s10_s" "s_packet_802154_auxiliary_security_s10"
ttc_manage.pl replace "packet_802154_auxiliary_security_s11_s" "s_packet_802154_auxiliary_security_s11"
ttc_manage.pl replace "packet_802154_beacon_000010_s" "s_packet_802154_beacon_000010"
ttc_manage.pl replace "packet_802154_beacon_000011_s" "s_packet_802154_beacon_000011"
ttc_manage.pl replace "packet_802154_command_000010_s" "s_packet_802154_command_000010"
ttc_manage.pl replace "packet_802154_command_000011_s" "s_packet_802154_command_000011"
ttc_manage.pl replace "packet_802154_command_001000_s" "s_packet_802154_command_001000"
ttc_manage.pl replace "packet_802154_command_001010_s" "s_packet_802154_command_001010"
ttc_manage.pl replace "packet_802154_command_001100_s" "s_packet_802154_command_001100"
ttc_manage.pl replace "packet_802154_command_001110_s" "s_packet_802154_command_001110"
ttc_manage.pl replace "packet_802154_command_001111_s" "s_packet_802154_command_001111"
ttc_manage.pl replace "packet_802154_command_011000_s" "s_packet_802154_command_011000"
ttc_manage.pl replace "packet_802154_command_011010_s" "s_packet_802154_command_011010"
ttc_manage.pl replace "packet_802154_command_011100_s" "s_packet_802154_command_011100"
ttc_manage.pl replace "packet_802154_command_011110_s" "s_packet_802154_command_011110"
ttc_manage.pl replace "packet_802154_command_011111_s" "s_packet_802154_command_011111"
ttc_manage.pl replace "packet_802154_data_000010_s" "s_packet_802154_data_000010"
ttc_manage.pl replace "packet_802154_data_000011_s" "s_packet_802154_data_000011"
ttc_manage.pl replace "packet_802154_data_001000_s" "s_packet_802154_data_001000"
ttc_manage.pl replace "packet_802154_data_001010_s" "s_packet_802154_data_001010"
ttc_manage.pl replace "packet_802154_data_001100_s" "s_packet_802154_data_001100"
ttc_manage.pl replace "packet_802154_data_001110_s" "s_packet_802154_data_001110"
ttc_manage.pl replace "packet_802154_data_001111_s" "s_packet_802154_data_001111"
ttc_manage.pl replace "packet_802154_data_011000_s" "s_packet_802154_data_011000"
ttc_manage.pl replace "packet_802154_data_011010_s" "s_packet_802154_data_011010"
ttc_manage.pl replace "packet_802154_data_011100_s" "s_packet_802154_data_011100"
ttc_manage.pl replace "packet_802154_data_011110_s" "s_packet_802154_data_011110"
ttc_manage.pl replace "packet_802154_data_011111_s" "s_packet_802154_data_011111"
ttc_manage.pl replace "packet_802154_generic_s" "s_packet_802154_generic"
ttc_manage.pl replace "packet_802154_mhr_000010_s" "s_packet_802154_mhr_000010"
ttc_manage.pl replace "packet_802154_mhr_000011_s" "s_packet_802154_mhr_000011"
ttc_manage.pl replace "packet_802154_mhr_001000_s" "s_packet_802154_mhr_001000"
ttc_manage.pl replace "packet_802154_mhr_001010_s" "s_packet_802154_mhr_001010"
ttc_manage.pl replace "packet_802154_mhr_001100_s" "s_packet_802154_mhr_001100"
ttc_manage.pl replace "packet_802154_mhr_001110_s" "s_packet_802154_mhr_001110"
ttc_manage.pl replace "packet_802154_mhr_001111_s" "s_packet_802154_mhr_001111"
ttc_manage.pl replace "packet_802154_mhr_010010_s" "s_packet_802154_mhr_010010"
ttc_manage.pl replace "packet_802154_mhr_010011_s" "s_packet_802154_mhr_010011"
ttc_manage.pl replace "packet_802154_mhr_011000_s" "s_packet_802154_mhr_011000"
ttc_manage.pl replace "packet_802154_mhr_011010_s" "s_packet_802154_mhr_011010"
ttc_manage.pl replace "packet_802154_mhr_011110_s" "s_packet_802154_mhr_011110"
ttc_manage.pl replace "packet_802154_mhr_011111_s" "s_packet_802154_mhr_011111"
ttc_manage.pl replace "packet_common_types_list_s" "s_packet_common_types_list"
ttc_manage.pl replace "radio_dw1000_config_s" "s_radio_dw1000_config"
ttc_manage.pl replace "radio_dw1000_registers_list_s" "s_radio_dw1000_registers_list"
ttc_manage.pl replace "radio_serial_generic_s" "s_radio_serial_generic"
ttc_manage.pl replace "register_stm32f1xx_adc_s" "s_register_stm32f1xx_adc"
ttc_manage.pl replace "rtls_common_data_report_distances_s" "s_rtls_common_data_report_distances"
ttc_manage.pl replace "rtls_common_data_report_locations_s" "s_rtls_common_data_report_locations"
ttc_manage.pl replace "ScrollData_s" "s_ttc_gui_scroll_data"
ttc_manage.pl replace "tit_InputArea_s" "s_ttc_gui_input_area"
ttc_manage.pl replace "ttc_accelerometer_config_s" "s_ttc_accelerometer_config"
ttc_manage.pl replace "ttc_accelerometer_measures_s" "s_ttc_accelerometer_measures"
ttc_manage.pl replace "ttc_adc_config_s" "s_ttc_adc_config"
ttc_manage.pl replace "ttc_board_config_s" "s_ttc_board_config"
ttc_manage.pl replace "ttc_board_features_s" "s_ttc_board_features"
ttc_manage.pl replace "ttc_can_config_s" "s_ttc_can_config"
ttc_manage.pl replace "ttc_can_filter_s" "s_ttc_can_filter"
ttc_manage.pl replace "ttc_can_message_s" "s_ttc_can_message"
ttc_manage.pl replace "ttc_channel_device_interface_s" "s_ttc_channel_device_interface"
ttc_manage.pl replace "ttc_channel_node_s" "s_ttc_channel_node"
ttc_manage.pl replace "ttc_channel_s" "s_ttc_channel"
ttc_manage.pl replace "ttc_cpu_config_s" "s_ttc_cpu_config"
ttc_manage.pl replace "ttc_cpu_info_s" "s_ttc_cpu_info"
ttc_manage.pl replace "ttc_dac_config_s" "s_ttc_dac_config"
ttc_manage.pl replace "ttc_dma_config_s" "s_ttc_dma_config"
ttc_manage.pl replace "ttc_ethernet_config_s" "s_ttc_ethernet_config"
ttc_manage.pl replace "ttc_font_data_s" "s_ttc_font_data"
ttc_manage.pl replace "ttc_font_generic_s" "s_ttc_font_generic"
ttc_manage.pl replace "ttc_gfx_config_s" "s_ttc_gfx_config"
ttc_manage.pl replace "ttc_gfx_generic_s" "s_ttc_gfx_generic"
ttc_manage.pl replace "ttc_gfx_mt_char_s" "s_ttc_gfx_mt_char"
ttc_manage.pl replace "ttc_gfx_mt_circle_s" "s_ttc_gfx_mt_circle"
ttc_manage.pl replace "ttc_gfx_mt_clear_s" "s_ttc_gfx_mt_clear"
ttc_manage.pl replace "ttc_gfx_mt_color_s" "s_ttc_gfx_mt_color"
ttc_manage.pl replace "ttc_gfx_mt_line_s" "s_ttc_gfx_mt_line"
ttc_manage.pl replace "ttc_gfx_mt_position_s" "s_ttc_gfx_mt_position"
ttc_manage.pl replace "ttc_gfx_mt_rect_s" "s_ttc_gfx_mt_rect"
ttc_manage.pl replace "ttc_gfx_mt_string_s" "s_ttc_gfx_mt_string"
ttc_manage.pl replace "ttc_gpio_config_s" "s_ttc_gpio_config"
ttc_manage.pl replace "ttc_gyroscope_config_s" "s_ttc_gyroscope_config"
ttc_manage.pl replace "ttc_gyroscope_measures_s" "s_ttc_gyroscope_measures"
ttc_manage.pl replace "ttc_heap_block_from_pool_s" "s_ttc_heap_block_from_pool"
ttc_manage.pl replace "ttc_heap_block_s" "s_ttc_heap_block"
ttc_manage.pl replace "ttc_heap_config_s" "s_ttc_heap_config"
ttc_manage.pl replace "ttc_heap_pool_debug_s" "s_ttc_heap_pool_debug"
ttc_manage.pl replace "ttc_heap_pool_s" "s_ttc_heap_pool"
ttc_manage.pl replace "s_ttc_heap_pooltatistics_s" "s_s_ttc_heap_pooltatistics"
ttc_manage.pl replace "ttc_i2c_config_s" "s_ttc_i2c_config"
ttc_manage.pl replace "ttc_input_area_s" "s_ttc_input_area"
ttc_manage.pl replace "ttc_input_config_s" "s_ttc_input_config"
ttc_manage.pl replace "ttc_input_generic_s" "s_ttc_input_generic"
ttc_manage.pl replace "ttc_interface_config_s" "s_ttc_interface_config"
ttc_manage.pl replace "ttc_interrupt_source_usart_s" "s_ttc_interrupt_source_usart"
ttc_manage.pl replace "ttc_layer_phy_config_s" "s_ttc_layer_phy_config"
ttc_manage.pl replace "ttc_list_item_s" "s_ttc_list_item"
ttc_manage.pl replace "ttc_list_s" "s_ttc_list"
ttc_manage.pl replace "s_ttc_listtatistics_s" "s_s_ttc_listtatistics"
ttc_manage.pl replace "ttc_math_int_vector2d_rz_s" "s_ttc_math_int_vector2d_rz"
ttc_manage.pl replace "ttc_math_int_vector2d_xy_s" "s_ttc_math_int_vector2d_xy"
ttc_manage.pl replace "ttc_math_int_vector3d_ryz_s" "s_ttc_math_int_vector3d_ryz"
ttc_manage.pl replace "ttc_math_int_vector3d_xyz_s" "s_ttc_math_int_vector3d_xyz"
ttc_manage.pl replace "ttc_math_vector2d_rz_s" "s_ttc_math_vector2d_rz"
ttc_manage.pl replace "ttc_math_vector2d_xy_s" "s_ttc_math_vector2d_xy"
ttc_manage.pl replace "ttc_math_vector3d_ryz_s" "s_ttc_math_vector3d_ryz"
ttc_manage.pl replace "ttc_math_vector3d_xyz_s" "s_ttc_math_vector3d_xyz"
ttc_manage.pl replace "ttc_memory_block_s" "s_ttc_memory_block"
ttc_manage.pl replace "ttc_memory_from_pool_s" "s_ttc_memory_from_pool"
ttc_manage.pl replace "ttc_memory_pool_s" "s_ttc_memory_pool"
ttc_manage.pl replace "s_ttc_memory_pooltatistics_s" "s_s_ttc_memory_pooltatistics"
ttc_manage.pl replace "ttc_mutex_smart_s" "s_ttc_mutex_smart"
ttc_manage.pl replace "ttc_network_config_s" "s_ttc_network_config"
ttc_manage.pl replace "ttc_network_layer_config_s" "s_ttc_network_layer_config"
ttc_manage.pl replace "ttc_network_node_s" "s_ttc_network_node"
ttc_manage.pl replace "ttc_packet_config_s" "s_ttc_packet_config"
ttc_manage.pl replace "ttc_packet_meta_debug_s" "s_ttc_packet_meta_debug"
ttc_manage.pl replace "ttc_packet_meta_small_s" "s_ttc_packet_meta_small"
ttc_manage.pl replace "ttc_packet_payload_s" "s_ttc_packet_payload"
ttc_manage.pl replace "ttc_packet_s" "s_ttc_packet"
ttc_manage.pl replace "ttc_pwm_config_s" "s_ttc_pwm_config"
ttc_manage.pl replace "ttc_pwm_features_s" "s_ttc_pwm_features"
ttc_manage.pl replace "ttc_pwr_config_s" "s_ttc_pwr_config"
ttc_manage.pl replace "ttc_queue_waiting_task_s" "s_ttc_queue_waiting_task"
ttc_manage.pl replace "ttc_radio_address_s" "s_ttc_radio_address"
ttc_manage.pl replace "ttc_radio_config_s" "s_ttc_radio_config"
ttc_manage.pl replace "ttc_radio_distance_s" "s_ttc_radio_distance"
ttc_manage.pl replace "ttc_radio_features_s" "s_ttc_radio_features"
ttc_manage.pl replace "ttc_radio_generic_s" "s_ttc_radio_generic"
ttc_manage.pl replace "ttc_real_time_clock_config_s" "s_ttc_real_time_clock_config"
ttc_manage.pl replace "ttc_real_time_clock_time_s" "s_ttc_real_time_clock_time"
ttc_manage.pl replace "ttc_rtc_config_s" "s_ttc_rtc_config"
ttc_manage.pl replace "ttc_rtc_time_s" "s_ttc_rtc_time"
ttc_manage.pl replace "ttc_sdcard_config_s" "s_ttc_sdcard_config"
ttc_manage.pl replace "ttc_semaphore_smart_s" "s_ttc_semaphore_smart"
ttc_manage.pl replace "ttc_slam_box_s" "s_ttc_slam_box"
ttc_manage.pl replace "ttc_slam_config_s" "s_ttc_slam_config"
ttc_manage.pl replace "ttc_slam_distance_s" "s_ttc_slam_distance"
ttc_manage.pl replace "ttc_slam_features_s" "s_ttc_slam_features"
ttc_manage.pl replace "ttc_slam_node_s" "s_ttc_slam_node"
ttc_manage.pl replace "ttc_spi_config_s" "s_ttc_spi_config"
ttc_manage.pl replace "ttc_states_call_s" "s_ttc_states_call"
ttc_manage.pl replace "ttc_states_config_s" "s_ttc_states_config"
ttc_manage.pl replace "ttc_states_state_s" "s_ttc_states_state"
ttc_manage.pl replace "ttc_string_config_s" "s_ttc_string_config"
ttc_manage.pl replace "ttc_sysclock_config_s" "s_ttc_sysclock_config"
ttc_manage.pl replace "ttc_systick_config_s" "s_ttc_systick_config"
ttc_manage.pl replace "ttc_systick_features_s" "s_ttc_systick_features"
ttc_manage.pl replace "ttc_task_update_info_s" "s_ttc_task_update_info"
ttc_manage.pl replace "ttc_task_waitinglist_list_s" "s_ttc_task_waitinglist_list"
ttc_manage.pl replace "ttc_task_waiting_task_s" "s_ttc_task_waiting_task"
ttc_manage.pl replace "ttc_tcpip_config_s" "s_ttc_tcpip_config"
ttc_manage.pl replace "ttc_timer_config_s" "s_ttc_timer_config"
ttc_manage.pl replace "ttc_touchpad_config_s" "s_ttc_touchpad_config"
ttc_manage.pl replace "ttc_usart_config_s" "s_ttc_usart_config"
ttc_manage.pl replace "ttc_usart_generic_s" "s_ttc_usart_generic"
ttc_manage.pl replace "ttc_usb_generic_s" "s_ttc_usb_generic"
ttc_manage.pl replace "tut_httpd_state_s" "s_ttc_tcpip_uip_httpd_state"
ttc_manage.pl replace "_ili9320_repeat_last_data" "_gfx_ili9320_repeat_last_data"
ttc_manage.pl replace "EXTENSION_510_ttc_font" "EXTENSION_ttc_font"
ttc_manage.pl replace "CurrentConfig" "ttc_gfx_Display.Config"
ttc_manage.pl replace "CurrentFont" "ttc_gfx_Display.Font"
ttc_manage.pl replace "EXTENSION_100_board_olimex_lcd" "EXTENSION_board_olimex_lcd"
ttc_manage.pl replace "TTC_STM32_FSMC" "TTC_GFX_STM32_FSMC"
ttc_manage.pl replace "170_chip_ili9320" "450_gfx_ili9320"
ttc_manage.pl replace "_gfx_ili9320_write_" "gfx_ili9320_board_write_"
ttc_manage.pl replace "_ILI9320_PIN_WRITEMODE" "_ILI9320_PIN_WRITE_STROBE"
ttc_manage.pl replace "_ILI9320_PIN_READMODE" "_ILI9320_PIN_READ_STROBE"
ttc_manage.pl replace "_clr_pixel" "_pixel_clr"
ttc_manage.pl replace "_set_pixel" "_pixel_set"
ttc_manage.pl replace "_put_char_" "_char_"
ttc_manage.pl replace "_put_char" "_char"
ttc_manage.pl replace "_set_backlight" "_backlight"
ttc_manage.pl replace "_set_color_" "_color_"
ttc_manage.pl replace "_set_palette" "_palette_set"
ttc_manage.pl replace "_set_cursor" "_cursor_set"
ttc_manage.pl replace "gfx_ili9320_repeat_datas" "_gfx_ili9320_data_fill"
ttc_manage.pl replace "_enterSleep" "_sleep_enter"
ttc_manage.pl replace "_exitSleep" "_sleep_exit"
ttc_manage.pl replace "_setWindow" "_window_set"
ttc_manage.pl replace "DriverCodeRead" "E_gfx_ili9320_register_DriverCodeRead"
ttc_manage.pl replace "DriverOutputControl" "E_gfx_ili9320_register_DriverOutputControl"
ttc_manage.pl replace "LCDDrivingWaveControl" "E_gfx_ili9320_register_LCDDrivingWaveControl"
ttc_manage.pl replace "EntryMode" "E_gfx_ili9320_register_EntryMode"
ttc_manage.pl replace "ResizingControlRegister" "E_gfx_ili9320_register_ResizingControlRegister"
ttc_manage.pl replace "DisplayControl1" "E_gfx_ili9320_register_DisplayControl1"
ttc_manage.pl replace "DisplayControl2" "E_gfx_ili9320_register_DisplayControl2"
ttc_manage.pl replace "DisplayControl3" "E_gfx_ili9320_register_DisplayControl3"
ttc_manage.pl replace "DisplayControl4" "E_gfx_ili9320_register_DisplayControl4"
ttc_manage.pl replace "RGBDisplayInterfaceControl1" "E_gfx_ili9320_register_RGBDisplayInterfaceControl1"
ttc_manage.pl replace "FrameMarkerPosition" "E_gfx_ili9320_register_FrameMarkerPosition"
ttc_manage.pl replace "RGBDisplayInterfaceControl2" "E_gfx_ili9320_register_RGBDisplayInterfaceControl2"
ttc_manage.pl replace "PowerControl1" "E_gfx_ili9320_register_PowerControl1"
ttc_manage.pl replace "PowerControl2" "E_gfx_ili9320_register_PowerControl2"
ttc_manage.pl replace "PowerControl3" "E_gfx_ili9320_register_PowerControl3"
ttc_manage.pl replace "PowerControl4" "E_gfx_ili9320_register_PowerControl4"
ttc_manage.pl replace "GRAMHorizontalAddressSet" "E_gfx_ili9320_register_GRAMHorizontalAddressSet"
ttc_manage.pl replace "GRAMVerticalAddressSet" "E_gfx_ili9320_register_GRAMVerticalAddressSet"
ttc_manage.pl replace "WriteDatatoGRAM" "E_gfx_ili9320_register_WriteDatatoGRAM"
ttc_manage.pl replace "ReadDatatoGRAM" "E_gfx_ili9320_register_ReadDatatoGRAM"
ttc_manage.pl replace "PowerControl7" "E_gfx_ili9320_register_PowerControl7"
ttc_manage.pl replace "FrameRateandColorControl" "E_gfx_ili9320_register_FrameRateandColorControl"
ttc_manage.pl replace "GammaControl1" "E_gfx_ili9320_register_GammaControl1"
ttc_manage.pl replace "GammaControl2" "E_gfx_ili9320_register_GammaControl2"
ttc_manage.pl replace "GammaControl3" "E_gfx_ili9320_register_GammaControl3"
ttc_manage.pl replace "GammaControl4" "E_gfx_ili9320_register_GammaControl4"
ttc_manage.pl replace "GammaControl5" "E_gfx_ili9320_register_GammaControl5"
ttc_manage.pl replace "GammaControl6" "E_gfx_ili9320_register_GammaControl6"
ttc_manage.pl replace "GammaControl7" "E_gfx_ili9320_register_GammaControl7"
ttc_manage.pl replace "GammaControl8" "E_gfx_ili9320_register_GammaControl8"
ttc_manage.pl replace "GammaControl9" "E_gfx_ili9320_register_GammaControl9"
ttc_manage.pl replace "GammaControl10" "E_gfx_ili9320_register_GammaControl10"
ttc_manage.pl replace "HorizontalRAMStartAddressPosition" "E_gfx_ili9320_register_HorizontalRAMStartAddressPosition"
ttc_manage.pl replace "HorizontalRAMEndAddressPosition" "E_gfx_ili9320_register_HorizontalRAMEndAddressPosition"
ttc_manage.pl replace "VerticalRAMStartAddressPosition" "E_gfx_ili9320_register_VerticalRAMStartAddressPosition"
ttc_manage.pl replace "VerticalRAMEndAddressPosition" "E_gfx_ili9320_register_VerticalRAMEndAddressPosition"
ttc_manage.pl replace "DriverOutputControl2" "E_gfx_ili9320_register_DriverOutputControl2"
ttc_manage.pl replace "BaseImageDisplayControl" "E_gfx_ili9320_register_BaseImageDisplayControl"
ttc_manage.pl replace "VerticalScrollControl" "E_gfx_ili9320_register_VerticalScrollControl"
ttc_manage.pl replace "PartialImage1DisplayPosition" "E_gfx_ili9320_register_PartialImage1DisplayPosition"
ttc_manage.pl replace "PartialImage1RAMStartAddress" "E_gfx_ili9320_register_PartialImage1RAMStartAddress"
ttc_manage.pl replace "PartialImage1RAMEndAddress" "E_gfx_ili9320_register_PartialImage1RAMEndAddress"
ttc_manage.pl replace "PartialImage2DisplayPosition" "E_gfx_ili9320_register_PartialImage2DisplayPosition"
ttc_manage.pl replace "PartialImage2RAMStartAddress" "E_gfx_ili9320_register_PartialImage2RAMStartAddress"
ttc_manage.pl replace "PartialImage2RAMEndAddress" "E_gfx_ili9320_register_PartialImage2RAMEndAddress"
ttc_manage.pl replace "PanelInterfaceControl1" "E_gfx_ili9320_register_PanelInterfaceControl1"
ttc_manage.pl replace "PanelInterfaceControl2" "E_gfx_ili9320_register_PanelInterfaceControl2"
ttc_manage.pl replace "PanelInterfaceControl3" "E_gfx_ili9320_register_PanelInterfaceControl3"
ttc_manage.pl replace "PanelInterfaceControl4" "E_gfx_ili9320_register_PanelInterfaceControl4"
ttc_manage.pl replace "PanelInterfaceControl5" "E_gfx_ili9320_register_PanelInterfaceControl5"
ttc_manage.pl replace "PanelInterfaceControl6" "E_gfx_ili9320_register_PanelInterfaceControl6"
ttc_manage.pl replace "OTPVCMProgrammingControl" "E_gfx_ili9320_register_OTPVCMProgrammingControl"
ttc_manage.pl replace "OTPVCMStatusandEnable" "E_gfx_ili9320_register_OTPVCMStatusandEnable"
ttc_manage.pl replace "OTPProgrammingIDKey" "E_gfx_ili9320_register_OTPProgrammingIDKey"
ttc_manage.pl replace "EXTENSION_060" "EXTENSION"
ttc_manage.pl replace "banknable" "bank_enable"
ttc_manage.pl replace "_e_gpio_stm32f1xx_bank_enable" "_gpio_stm32f1xx_bank_enable"
ttc_manage.pl replace "tgaf_" "E_ttc_gpio_alternate_function_"
ttc_manage.pl replace "tgs_None" "E_ttc_gpio_speed_none"
ttc_manage.pl replace "tgs_Min" "E_ttc_gpio_speed_min"
ttc_manage.pl replace "tgs_400KHz" "E_ttc_gpio_speed_400khz"
ttc_manage.pl replace "tgs_2MHz" "E_ttc_gpio_speed_2mhz"
ttc_manage.pl replace "tgs_10MHz" "E_ttc_gpio_speed_10mhz"
ttc_manage.pl replace "tgs_40MHz" "E_ttc_gpio_speed_40mhz"
ttc_manage.pl replace "tgs_50MHz" "E_ttc_gpio_speed_50mhz"
ttc_manage.pl replace "tgs_Max" "E_ttc_gpio_speed_max"
ttc_manage.pl replace "tgs_Unknown" "E_ttc_gpio_speed_unknown"
ttc_manage.pl replace "ttc_manage.pl" "replace"
ttc_manage.pl replace "ec_gpio_" "E_ttc_gpio_errorcode_"
ttc_manage.pl replace "tgm_None" "E_ttc_gpio_mode_none"
ttc_manage.pl replace "tgm_analog_in" "E_ttc_gpio_mode_analog_in"
ttc_manage.pl replace "tgm_input_floating" "E_ttc_gpio_mode_input_floating"
ttc_manage.pl replace "tgm_input_pull_down" "E_ttc_gpio_mode_input_pull_down"
ttc_manage.pl replace "tgm_input_pull_up" "E_ttc_gpio_mode_input_pull_up"
ttc_manage.pl replace "tgm_output_open_drain" "E_ttc_gpio_mode_output_open_drain"
ttc_manage.pl replace "tgm_output_push_pull" "E_ttc_gpio_mode_output_push_pull"
ttc_manage.pl replace "tgm_alternate_function_push_pull" "E_ttc_gpio_mode_alternate_function_push_pull"
ttc_manage.pl replace "tgm_alternate_function_open_drain" "E_ttc_gpio_mode_alternate_function_open_drain"
ttc_manage.pl replace "tgm_alternate_function_SPECIAL_SCLK" "E_ttc_gpio_mode_alternate_function_special_sclk"
ttc_manage.pl replace "tgm_Unknown" "E_ttc_gpio_mode_unknown"
ttc_manage.pl replace "ta_gpio_None" "E_ttc_gpio_architecture_none"
ttc_manage.pl replace "ta_gpio_stm32w1xx" "E_ttc_gpio_architecture_stm32w1xx"
ttc_manage.pl replace "ta_gpio_stm32f1xx" "E_ttc_gpio_architecture_stm32f1xx"
ttc_manage.pl replace "ta_gpio_stm32l1xx" "E_ttc_gpio_architecture_stm32l1xx"
ttc_manage.pl replace "ta_gpio_stm32f30x" "E_ttc_gpio_architecture_stm32f30x"
ttc_manage.pl replace "ta_gpio_stm32l0xx" "E_ttc_gpio_architecture_stm32l0xx"
ttc_manage.pl replace "ta_gpio_ERROR" "E_ttc_gpio_architecture_error"
ttc_manage.pl replace "ttc_gpio_errorcode" "ttc_gpio_error"
ttc_manage.pl replace "E_ttc_gpio_error_OK" "E_ttc_gpio_error_ok"
ttc_manage.pl replace "E_ttc_gpio_error_ERROR" "E_ttc_gpio_error_error"
ttc_manage.pl replace "E_ttc_gpio_error_DeviceNotFound" "E_ttc_gpio_error_devicenotfound"
ttc_manage.pl replace "E_ttc_gpio_error_InvalidImplementation" "E_ttc_gpio_error_invalidimplementation"
ttc_manage.pl replace "E_ttc_gpio_error_NotImplemented" "E_ttc_gpio_error_notimplemented"
ttc_manage.pl replace "E_ttc_gpio_error_error" "E_ttc_gpio_error_unknown"
ttc_manage.pl replace "stm32_gpio_None" "E_ttc_gpio_bank_none"
ttc_manage.pl replace "tgb_bank_a" "E_ttc_gpio_bank_a"
ttc_manage.pl replace "tgb_bank_b" "E_ttc_gpio_bank_b"
ttc_manage.pl replace "tgb_bank_c" "E_ttc_gpio_bank_c"
ttc_manage.pl replace "tgb_bank_d" "E_ttc_gpio_bank_d"
ttc_manage.pl replace "tgb_bank_e" "E_ttc_gpio_bank_e"
ttc_manage.pl replace "tgb_bank_f" "E_ttc_gpio_bank_f"
ttc_manage.pl replace "tgb_bank_g" "E_ttc_gpio_bank_g"
ttc_manage.pl replace "stm32_gpio_NotImplemented" "E_ttc_gpio_bank_unknown"
ttc_manage.pl replace "gsm_input_analog" "E_ttc_gpio_mode_input_analog"
ttc_manage.pl replace "gsm_input_floating" "E_ttc_gpio_mode_input_floating"
ttc_manage.pl replace "gsm_input_pull_updown" "E_ttc_gpio_mode_input_pull_updown"
ttc_manage.pl replace "gsm_input_reserved" "E_ttc_gpio_mode_input_reserved"
ttc_manage.pl replace "gsm_output_push_pull" "E_ttc_gpio_mode_output_push_pull"
ttc_manage.pl replace "gsm_output_open_drain" "E_ttc_gpio_mode_output_open_drain"
ttc_manage.pl replace "gsm_output_alternate_push_pull" "E_ttc_gpio_mode_output_alternate_push_pull"
ttc_manage.pl replace "gsm_output_alternate_open_drain" "E_ttc_gpio_mode_output_alternate_open_drain"
ttc_manage.pl replace "gsm_unknown" "E_ttc_gpio_mode_unknown"
ttc_manage.pl replace "gfx_ili9320_board_write_data" "gfx_ili9320_board_write_data16"
ttc_manage.pl replace "gfx_ili9320_board_write_register" "gfx_ili9320_board_write_register16"
ttc_manage.pl replace "gfx_ili9320_board_read_register" "gfx_ili9320_board_read_register16"
ttc_manage.pl replace "_init_u8" "_parallel08_init"
ttc_manage.pl replace "_init_u16" "_parallel16_init"
ttc_manage.pl replace "gpio_put_u8_" "gpio_parallel08_put_"
ttc_manage.pl replace "gpio_get_u8_" "gpio_parallel08_get_"
ttc_manage.pl replace "gpio_get_u16" "gpio_parallel16_get"
ttc_manage.pl replace "gpio_put_u16" "gpio_parallel16_put"
ttc_manage.pl replace "TTC_PARALLEL" "TTC_GPIO_PARALLEL"
ttc_manage.pl replace "ec_math_" "E_ttc_math_error_"
ttc_manage.pl replace "_init_shift" "_init"
ttc_manage.pl replace "e_gpio_stm32l1xx_bank" "E_gpio_stm32l1xx_bank"
ttc_manage.pl replace "e_gpio_stm32l1xx_pull" "E_gpio_stm32l1xx_pull"
ttc_manage.pl replace "E_gpio_stm32l1xx_pull" "e_gpio_stm32l1xx_pull"
ttc_manage.pl replace "E_gpio_stm32l1xx_bank" "e_gpio_stm32l1xx_bank"
ttc_manage.pl replace "installs_low_level" "low_level"
ttc_manage.pl replace "2017" "2018"
ttc_manage.pl replace "ethernet_stm32f107.o" "DEPRECATED_ethernet_stm32f107.o"
ttc_manage.pl replace " il9320" " ili9320"
ttc_manage.pl replace "9320" "93xx"
ttc_manage.pl replace "_PIN_REGISTER" "_PIN_NOT_REGISTER_SELECT"
ttc_manage.pl replace "_ILI93xx_PIN_CHIPSELECT" "_ILI93xx_PIN_NOT_CHIPSELECT"
ttc_manage.pl replace "PIN_WRITE_STROBE" "PIN_NOT_WRITE_STROBE"
ttc_manage.pl replace "PIN_READ_STROBE" "PIN_NOT_READ_STROBE"
ttc_manage.pl replace "ILI93xx_PIN_RESET" "ILI93xx_PIN_NOT_RESET"
ttc_manage.pl replace "ttc_radiot__config" "t_ttc_radio_config"
ttc_manage.pl replace "ttc_gfxt__config" "t_ttc_gfx_config"
ttc_manage.pl replace "ttc_drivert__config" "t_ttc_driver_config"
ttc_manage.pl replace "ttc_i2c_base_t_register" "t_ttc_i2c_base_register"
ttc_manage.pl replace "tiat_" "E_ttc_i2c_address_type_"
ttc_manage.pl replace "tifc_" "E_ttc_i2c_flag_code_"
ttc_manage.pl replace "tiec_" "E_ttc_i2c_event_code_"
ttc_manage.pl replace "ec_i2c_" "E_ttc_i2c_errorcode_"
ttc_manage.pl replace "tiras_" "E_ttc_i2c_address_type_"
ttc_manage.pl replace "ILI93xx_PIN" "ILI93XX_PIN"
ttc_manage.pl replace "ec_sysclock_" "E_ttc_sysclock_errorcode_"
ttc_manage.pl replace "ta_sysclock_" "E_ttc_sysclock_architecture"
ttc_manage.pl replace "tsp_" "E_ttc_sysclock_profile"
ttc_manage.pl replace "tso_" "E_ttc_sysclock_oscillator_"
ttc_manage.pl replace "E_ttc_sysclock_profile" "E_ttc_sysclock_profile_"
ttc_manage.pl replace "E_ttc_sysclock_architecture" "E_ttc_sysclock_architecture_"
ttc_manage.pl replace "tsa_sysclock_Unknown" "E_ttc_sysclock_architecture_unknown"
ttc_manage.pl replace "_Unknown" "_unknown"
ttc_manage.pl replace "_read_16_" "_16_read_"
ttc_manage.pl replace "_write_16_" "_16_write_"
ttc_manage.pl replace "_read_32_" "_32_read_"
ttc_manage.pl replace "_write_32_" "_32_write_"
ttc_manage.pl replace "_atomic_add_16" "_16_atomic_add_"
ttc_manage.pl replace "_atomic_add_8" "_08_atomic_add_"
ttc_manage.pl replace "_atomic_add_32" "_32_atomic_add_"
ttc_manage.pl replace "ttc_32_" "ttc_basic_32_"
ttc_manage.pl replace "ttc_16_" "ttc_basic_16_"
ttc_manage.pl replace "ttc_08_" "ttc_basic_08_"
ttc_manage.pl replace "_atomic_read_write_32" "_32_atomic_read_write"
ttc_manage.pl replace "_atomic_read_write_16" "_16_atomic_read_write"
ttc_manage.pl replace "_atomic_read_write_8" "_08_atomic_read_write"
ttc_manage.pl replace "ttc_atomic_add" "ttc_basic_atomic_add"
ttc_manage.pl replace "atomic_add_" "atomic_add"
ttc_manage.pl replace "ttc_gpio_alternate_function_e" "e_ttc_gpio_alternate_function"
ttc_manage.pl replace "TTC_GFX1_ILI93XX_PIN_NOT_REGISTER_SELECT" "TTC_GFX1_ILI93XX_PIN_REGISTER_SELECT"
ttc_manage.pl replace "_ILI93XX_PIN_D" "_ILI93XX_PIN_D0"
ttc_manage.pl replace "GFX_ILI932X_PIN_" "TTC_GFX1_ILI93XX_PIN_"
ttc_manage.pl replace "TIM3EN" "TIM3_EN"
ttc_manage.pl replace "AWDEN" "AWD_EN"
ttc_manage.pl replace "BITNUMBER_ADC_CR1_DISCEN" "BITNUMBER_ADC_CR1_DISC_EN"
ttc_manage.pl replace "BITNUMBER_ADC_CR1_JDISCEN" "BITNUMBER_ADC_CR1_JDISC_EN"
ttc_manage.pl replace "BKPEN" "BKP_EN"
ttc_manage.pl replace "CAN1EN" "CAN1_EN"
ttc_manage.pl replace "CAN2EN" "CAN2_EN"
ttc_manage.pl replace "CANEN" "CAN_EN"
ttc_manage.pl replace "CEN" "C_EN"
ttc_manage.pl replace "CHLEN" "CHL_EN"
ttc_manage.pl replace "DATLEN" "DATL_EN"
ttc_manage.pl replace "DMA1EN" "DMA1_EN"
ttc_manage.pl replace "DMA2EN" "DMA2_EN"
ttc_manage.pl replace "DMAEN" "DMA_EN"
ttc_manage.pl replace "ETHMACRXEN" "ETHMACRX_EN"
ttc_manage.pl replace "ETHMACTXEN" "ETHMACTX_EN"
ttc_manage.pl replace "FLITFEN" "FLITF_EN"
ttc_manage.pl replace "I2C1EN" "I2C1_EN"
ttc_manage.pl replace "I2C2EN" "I2C2_EN"
ttc_manage.pl replace "ITBUFEN" "ITBUF_EN"
ttc_manage.pl replace "ITERREN" "ITERR_EN"
ttc_manage.pl replace "ITEVTEN" "ITEVT_EN"
ttc_manage.pl replace "OTGFSEN" "OTGFS_EN"
ttc_manage.pl replace "PWREN" "PWR_EN"
ttc_manage.pl replace "SPI2EN" "SPI2_EN"
ttc_manage.pl replace "SPI3EN" "SPI3_EN"
ttc_manage.pl replace "SRAMEN" "SRAM_EN"
ttc_manage.pl replace "TIM12EN" "TIM12_EN"
ttc_manage.pl replace "TIM13EN" "TIM13_EN"
ttc_manage.pl replace "TIM14EN" "TIM14_EN"
ttc_manage.pl replace "TIM2EN" "TIM2_EN"
ttc_manage.pl replace "TIM4EN" "TIM4_EN"
ttc_manage.pl replace "TIM5EN" "TIM5_EN"
ttc_manage.pl replace "TIM6EN" "TIM6_EN"
ttc_manage.pl replace "TIM7EN" "TIM7_EN"
ttc_manage.pl replace "UART4EN" "UART4_EN"
ttc_manage.pl replace "UART5EN" "UART5_EN"
ttc_manage.pl replace "USART2EN" "USART2_EN"
ttc_manage.pl replace "USART3EN" "USART3_EN"
ttc_manage.pl replace "USBEN" "USB_EN"
ttc_manage.pl replace "WWDGEN" "WWDG_EN"
ttc_manage.pl replace "GPIOAEN" "GPIOA_EN"
ttc_manage.pl replace "GPIOBEN" "GPIOB_EN"
ttc_manage.pl replace "GPIODEN" "GPIOD_EN"
ttc_manage.pl replace "GPIOEEN" "GPIOE_EN"
ttc_manage.pl replace "GPIOFEN" "GPIOF_EN"
ttc_manage.pl replace "GPIOGEN" "GPIOG_EN"
ttc_manage.pl replace "GPIOHEN" "GPIOH_EN"
ttc_manage.pl replace "write_block" "block_write"
ttc_manage.pl replace "_mount" "_medium_mount"
ttc_manage.pl replace "_unmount" "_medium_unmount"
ttc_manage.pl replace "_spi_detect" "_spi_medium_detect"
ttc_manage.pl replace "_sdcard_detect" "_sdcard_medium_detect"
ttc_manage.pl replace "stm32w_block_write" "stm32w_write_block"
ttc_manage.pl replace "E_ttc_sdcard_command_send_" "E_ttc_sdcard_command_read_"
ttc_manage.pl replace "E_ttc_sdcard_command_read_" "E_ttc_sdcard_command_get_"
ttc_manage.pl replace "_send_command" "_command_r1"
ttc_manage.pl replace "_read_command" "_command_rn"
ttc_manage.pl replace "E_ttc_sdcard_command_go_idle_state" "E_ttc_sdcard_cmd0_go_idle_state"
ttc_manage.pl replace "E_ttc_sdcard_command_get_operating_condition" "E_ttc_sdcard_cmd1_get_operating_condition"
ttc_manage.pl replace "E_ttc_sdcard_command_get_relative_address" "E_ttc_sdcard_cmd3_get_relative_address"
ttc_manage.pl replace "E_ttc_sdcard_command_get_interface_condition" "E_ttc_sdcard_cmd8_get_interface_condition"
ttc_manage.pl replace "E_ttc_sdcard_command_get_card_specific_data" "E_ttc_sdcard_cmd9_get_card_specific_data"
ttc_manage.pl replace "E_ttc_sdcard_command_get_card_identification" "E_ttc_sdcard_cmd10_get_card_identification"
ttc_manage.pl replace "E_ttc_sdcard_command_sd_status" "E_ttc_sdcard_cmd13_sd_status"
ttc_manage.pl replace "E_ttc_sdcard_command_set_blocklength" "E_ttc_sdcard_cmd16_set_blocklength"
ttc_manage.pl replace "E_ttc_sdcard_command_block_read_single" "E_ttc_sdcard_cmd17_block_read_single"
ttc_manage.pl replace "E_ttc_sdcard_command_set_pre_erase_amount" "E_ttc_sdcard_cmd23_set_pre_erase_amount"
ttc_manage.pl replace "E_ttc_sdcard_command_block_write_single" "E_ttc_sdcard_cmd24_block_write_single"
ttc_manage.pl replace "E_ttc_sdcard_command_block_write_multiple" "E_ttc_sdcard_cmd25_block_write_multiple"
ttc_manage.pl replace "E_ttc_sdcard_command_block_erase_start" "E_ttc_sdcard_cmd32_block_erase_start"
ttc_manage.pl replace "E_ttc_sdcard_command_block_erase_end" "E_ttc_sdcard_cmd33_block_erase_end"
ttc_manage.pl replace "E_ttc_sdcard_command_block_erase" "E_ttc_sdcard_cmd38_block_erase"
ttc_manage.pl replace "E_ttc_sdcard_command_sd_send_operating_condition" "E_ttc_sdcard_cmd41_sd_send_operating_condition"
ttc_manage.pl replace "E_ttc_sdcard_command_application_cmd" "E_ttc_sdcard_cmd55_application_cmd"
ttc_manage.pl replace "E_ttc_sdcard_command_get_ocr" "E_ttc_sdcard_cmd58_get_ocr"
ttc_manage.pl replace "E_ttc_sdcard_command_crc_on_off" "E_ttc_sdcard_cmd59_crc_on_off"
ttc_manage.pl replace "medium_wakeup" "medium_go_idle"
ttc_manage.pl replace "_calculate_crc7" "_crc7_calculate"
ttc_manage.pl replace "Card.Status" "Card.LastResponse"
ttc_manage.pl replace "_app_command" "_command_application_"
ttc_manage.pl replace "_application__" "_application_"
ttc_manage.pl replace "e_ttc_sdcard_command_application_" "e_ttc_sdcard_command_application"
ttc_manage.pl replace "_command_disable_crc" "_disable_crc"
ttc_manage.pl replace "_get_block_count" "_blocks_count"
ttc_manage.pl replace "_block_count" "_blocks_count"
ttc_manage.pl replace "_get_block_size" "_blocks_size"
ttc_manage.pl replace "sdcard_common_get_data" "sdcard_common_card_data"
ttc_manage.pl replace "ttc_sdcard_event_card" "ttc_storage_event_media"
ttc_manage.pl replace "ttc_sdcard_event" "ttc_storage_event"
ttc_manage.pl replace "s_s_ttc_heap_pooltatistics" "s_ttc_heap_pool_statistics"
ttc_manage.pl replace "t_s_ttc_heap_pooltatistics" "t_ttc_heap_pool_statistics"
ttc_manage.pl replace "InstallData/scripts/createDevelopmentVersion.pl" "scripts/createDevelopmentVersion.pl"
ttc_manage.pl replace "-2018" "-2019"
ttc_manage.pl replace "scripts/createDevelopmentVersion.pl" "bin/createDevelopmentVersion.pl"
ttc_manage.pl replace "Lenght" "Length"
ttc_manage.pl replace "ta_cpu_stm32" "E_ttc_cpu_variant_stm32"
ttc_manage.pl replace "ta_cpu_variant_" "E_ttc_cpu_variant_stm32"
ttc_manage.pl replace "E_ttc_cpu_variant_stm32None" "E_ttc_cpu_variant_None"
ttc_manage.pl replace "E_ttc_cpu_variant_stm32Illegal" "E_ttc_cpu_variant_Illegal"
ttc_manage.pl replace "ta_cpu_cortexm" "E_ttc_cpu_architecture_cortexm"
ttc_manage.pl replace "E_ttc_cpu_variant_stm32f0xx" "E_ttc_cpu_architecture_stm32f0xx"
ttc_manage.pl replace "E_ttc_cpu_variant_stm32f1xx" "E_ttc_cpu_architecture_stm32f1xx"
ttc_manage.pl replace "E_ttc_cpu_variant_stm32f2xx" "E_ttc_cpu_architecture_stm32f2xx"
ttc_manage.pl replace "E_ttc_cpu_variant_stm32f3xx" "E_ttc_cpu_architecture_stm32f3xx"
ttc_manage.pl replace "E_ttc_cpu_variant_stm32f4xx" "E_ttc_cpu_architecture_stm32f4xx"
ttc_manage.pl replace "E_ttc_cpu_variant_stm32l0xx" "E_ttc_cpu_architecture_stm32l0xx"
ttc_manage.pl replace "E_ttc_cpu_variant_stm32l1xx" "E_ttc_cpu_architecture_stm32l1xx"
ttc_manage.pl replace "E_ttc_cpu_variant_stm32w1xx" "E_ttc_cpu_architecture_stm32w1xx"
ttc_manage.pl replace "ta_cpu_None" "E_ttc_cpu_architecture_None"
ttc_manage.pl replace "E_ttc_cpu_architecture_None" "E_ttc_cpu_architecture_none"
ttc_manage.pl replace "E_ttc_cpu_variant_None" "E_ttc_cpu_variant_none"
ttc_manage.pl replace "E_ttc_cpu_variant_Illegal" "E_ttc_cpu_variant_illegal"
ttc_manage.pl replace "ec_cpu_" "E_ttc_cpu_errorcode_"
ttc_manage.pl replace "E_ttc_cpu_errorcode_unknown" "E_ttc_cpu_errorcode_Unknown"
ttc_manage.pl replace "TTC_CPU_VARIANT_stm32f100rbt6" "TTC_CPU_VARIANT_stm32f103rbt6"
ttc_manage.pl replace "Aptr" "A_pointer"
ttc_manage.pl replace "Atype" "A_type"
ttc_manage.pl replace "E_ttc_sysclock_oscillator_HighSpeedExternalBypass" "E_ttc_sysclock_oscillator_HighSpeedExternalClock"
ttc_manage.pl replace "E_ttc_gpio_error_devicenotfound" "E_ttc_gpio_error_device_not_found"
ttc_manage.pl replace "E_ttc_gpio_error_invalidimplementation" "E_ttc_gpio_error_invalid_implementation"
ttc_manage.pl replace "E_ttc_gpio_error_notimplemented" "E_ttc_gpio_error_not_implemented"
ttc_manage.pl replace "t_ttc_interrupt_configimer_t" "t_ttc_interrupt_config_timer"
ttc_manage.pl replace "t_ttc_interrupt_configimer" "ttc_interrupt_config_timer"
ttc_manage.pl replace "interrupt_driver_config_usart_t" "t_interrupt_driver_config_usart"
ttc_manage.pl replace "interrupt_driver_config_i2c_t" "t_interrupt_driver_config_i2c"
ttc_manage.pl replace "t_tit_inputarea" "t_ttc_gui_input_area"
ttc_manage.pl replace "tit_" "E_ttc_interrupt_type_"
ttc_manage.pl replace "receiveBlock" "functionReceiveBlock"
ttc_manage.pl replace "activity_tx_isr" "function_activity_tx_isr"
ttc_manage.pl replace "activity_rx_isr" "function_activity_rx_isr"
ttc_manage.pl replace "functionReceiveBlock" "function_receive_block"
ttc_manage.pl replace "function_receive_block_Argument" "function_receive_block_argument"
ttc_manage.pl replace "receiveSingleByte" "receive_single_byte"
ttc_manage.pl replace "receive_single_byte" "function_receive_single_byte"
ttc_manage.pl replace "function_activity_rx_isr" "function_Activity_Rx_ISR"
ttc_manage.pl replace "function_activity_tx_isr" "function_Activity_Tx_ISR"
ttc_manage.pl replace "function_receive_block" "function_Receive_Block"
ttc_manage.pl replace "function_Receive_Block_argument" "function_Receive_Block_Argument"
ttc_manage.pl replace "function_receive_single_byte" "function_Receive_Single_Byte"
ttc_manage.pl replace "DO NOT REMOVE THIS LINE!" "DO NOT DELETE THIS LINE!"
ttc_manage.pl replace "TTC_TASK_RETURN" "TTC_RETURN"
ttc_manage.pl replace "TTC_TASK_STACK_CHECKS_ENABLED" "TTC_TUNABLE_STACK_CHECKS_ENABLED"
ttc_manage.pl replace "TTC_TASK_MINIMAL_STACK_SIZE" "TTC_TUNABLE_TASK_MINIMAL_STACK_SIZE"
ttc_manage.pl replace "ENABLE_TTC_BASIC_SAFE_ARRAYS" "TTC_TUNABLE_BASIC_SAFE_ARRAYS"
ttc_manage.pl replace "taskBrightness" "taskLightShow"
ttc_manage.pl replace "taskControlLed" "taskLedPWM"
ttc_manage.pl replace "TTC_LED1=E_ttc_gpio_pin_" "TTC_LED1_GPIO=E_ttc_gpio_pin_"
ttc_manage.pl replace "TTC_LED2=E_ttc_gpio_pin_" "TTC_LED2_GPIO=E_ttc_gpio_pin_"
ttc_manage.pl replace "TTC_LED1=TTC_GPIO_" "TTC_LED1_PIN=TTC_GPIO_"
ttc_manage.pl replace "TTC_LIST_HEADER" "TTC_LIST_ITEM_HEADER"
ttc_manage.pl replace "s_ttc_listize" "ttc_list_size"
ttc_manage.pl replace "t_s_ttc_listtatistics" "t_ttc_list_statistics"
ttc_manage.pl replace "TTC_LIST_STATISTICS_HEADER" "TTC_LIST_HEADER_DEBUG"
ttc_manage.pl replace "t_ttc_list_statistics_header" "t_ttc_list_header_debug"
ttc_manage.pl replace "t_ttc_list_statistics" "ttc_list_debug"
ttc_manage.pl replace "ttc_list_debug" "t_ttc_list_debug"
ttc_manage.pl replace "ttc_list_statistics" "ttc_list_debug"
ttc_manage.pl replace "ttc_list_count_items" "ttc_list_items_count"
ttc_manage.pl replace "usart_tx_isr" "usart_isr_tx"
ttc_manage.pl replace "usart_rx_isr" "usart_isr_rx"
ttc_manage.pl replace "BaudRate" "BitRate"
ttc_manage.pl replace "TTC_USART_MAX_MEMORY_BUFFERS" "TTC_USART_AMOUNT_MEMORY_BUFFERS_DEFAULT"
ttc_manage.pl replace "interrupt_driver_config_gpio_t" "t_interrupt_driver_config_gpio"
ttc_manage.pl replace "register_stm32f1xx_all_t" "t_register_stm32f1xx_all"
ttc_manage.pl replace "TTC_LED1," "TTC_LED1_GPIO,"
ttc_manage.pl replace "TTC_LED2," "TTC_LED2_GPIO,"
ttc_manage.pl replace "TTC_LED1\ \)" "TTC_LED1_GPIO\ \)"
ttc_manage.pl replace "TTC_LED2\ \)" "TTC_LED2_GPIO )"
ttc_manage.pl replace "led_common.h" "light_common.h"
ttc_manage.pl replace "example_ttc_led.h" "example_ttc_light.h"
ttc_manage.pl replace "example_ttc_led.o" "example_ttc_light.o"
ttc_manage.pl replace "example_ttc_led.c" "example_ttc_light.c"
ttc_manage.pl replace "ttc_led_types.h" "ttc_light_types.h"
ttc_manage.pl replace "ttc_led.o" "ttc_light.o"
ttc_manage.pl replace "ttc_led.c" "ttc_light.c"
ttc_manage.pl replace "ttc_led_interface.h" "ttc_light_interface.h"
ttc_manage.pl replace "ttc_led_interface.o" "ttc_light_interface.o"
ttc_manage.pl replace "ttc_led_interface.c" "ttc_light_interface.c"
ttc_manage.pl replace "ttc_led.h" "ttc_light.h"
ttc_manage.pl replace "led_gpio.h" "light_gpio.h"
ttc_manage.pl replace "led_gpio.o" "light_gpio.o"
ttc_manage.pl replace "led_gpio.c" "light_gpio.c"
ttc_manage.pl replace "led_common.o" "light_common.o"
ttc_manage.pl replace "led_common.c" "light_common.c"
ttc_manage.pl replace "led_gpio_types.h" "light_gpio_types.h"
ttc_manage.pl replace "./InstallData/low_level/install_TTC_LED_GPIO.sh" "./InstallData/low_level/install_TTC_LIGHT_GPIO.sh"
ttc_manage.pl replace "./InstallData/install_TTC_LED.sh" "./InstallData/install_TTC_LIGHT.sh"
ttc_manage.pl replace "TTC_LED" "TTC_LIGHT"
ttc_manage.pl replace "led_gpio" "light_gpio"
ttc_manage.pl replace "LED_GPIO" "LIGHT_GPIO"
ttc_manage.pl replace "Assert_LED" "Assert_LIGHT"
ttc_manage.pl replace "t_ttc_light.config" "t_ttc_light_config"
ttc_manage.pl replace "s_ttc_light.config" "s_ttc_light_config"
ttc_manage.pl replace "light_interface." "light_interface_"
ttc_manage.pl replace "light_interface_c" "light_interface.c"
ttc_manage.pl replace "light_interface_h" "light_interface.h"
ttc_manage.pl replace "light_interface.configuration" "light_interface_configuration"
ttc_manage.pl replace "light.on" "light_on"
ttc_manage.pl replace "light.off" "light_off"
ttc_manage.pl replace "ttc_led_" "ttc_light_"
ttc_manage.pl replace "driver_led_" "driver_light_"
ttc_manage.pl replace "E_example_led_" "E_example_ttc_light_"
ttc_manage.pl replace "example_led_" "example_ttc_light_"
ttc_manage.pl replace "_led_" "_light_"
ttc_manage.pl replace "/led/" "/light/"
ttc_manage.pl replace "led/led" "light/light"
ttc_manage.pl replace "light_gpio.configuration" "light_gpio_configuration"
ttc_manage.pl replace "_gpio.off" "_gpio_off"
ttc_manage.pl replace "_gpio.on" "_gpio_on"
ttc_manage.pl replace "_gpio.config" "_gpio_config"
ttc_manage.pl replace "ttc_led" "ttc_light"
ttc_manage.pl replace "ttc_light.configuration" "ttc_light_configuration"
ttc_manage.pl replace "ttc_lisrt" "ttc_list"
ttc_manage.pl replace "_light_on" "_light_channel_on"
ttc_manage.pl replace "ttc_light_channel_on" "ttc_light_on"
ttc_manage.pl replace "_light_channel_on" "_light_on"
ttc_manage.pl replace "TTC_LIGHT1_GPIO=" "TTC_LIGHT1_GPIO1="
ttc_manage.pl replace "TTC_LIGHT2_GPIO=" "TTC_LIGHT2_GPIO1="
ttc_manage.pl replace "TTC_LIGHT3_GPIO=" "TTC_LIGHT3_GPIO1="
ttc_manage.pl replace "TTC_LIGHT1_GPIO" "TTC_LIGHT1_GPIO1"
ttc_manage.pl replace "TTC_LIGHT2_GPIO" "TTC_LIGHT2_GPIO1"
ttc_manage.pl replace "TTC_LIGHT3_GPIO" "TTC_LIGHT3_GPIO1"
ttc_manage.pl replace "TTC_LIGHT4_GPIO" "TTC_LIGHT4_GPIO1"
ttc_manage.pl replace "TTC_LIGHT3_GPIO11" "TTC_LIGHT3_GPIO1"
ttc_manage.pl replace "TTC_LIGHT2_GPIO11" "TTC_LIGHT2_GPIO1"
ttc_manage.pl replace "TTC_LIGHT1_GPIO11" "TTC_LIGHT1_GPIO1"
ttc_manage.pl warn_deleted TTC-Library/ttc_pwm_types.h
ttc_manage.pl warn_deleted TTC-Library/pwm/pwm_common.c
ttc_manage.pl warn_deleted TTC-Library/pwm/pwm_common.h
ttc_manage.pl warn_deleted TTC-Library/pwm/pwm_stm32l1xx.c
ttc_manage.pl warn_deleted TTC-Library/pwm/pwm_stm32l1xx.h
ttc_manage.pl warn_deleted TTC-Library/pwm/pwm_stm32l1xx_types.h
ttc_manage.pl warn_deleted TTC-Library/ttc_pwm.h
ttc_manage.pl warn_deleted TTC-Library/ttc_pwm.c
ttc_manage.pl warn_deleted TTC-Library/interfaces/ttc_pwm_interface.c
ttc_manage.pl warn_deleted TTC-Library/interfaces/ttc_pwm_interface.h
ttc_manage.pl warn_deleted Template/regressions/regression_ttc_pwm_stm32l1xx.h
ttc_manage.pl warn_deleted Template/regressions/regression_ttc_pwm.c
ttc_manage.pl warn_deleted Template/regressions/regression_ttc_pwm.h
ttc_manage.pl warn_deleted Template/regressions/regression_ttc_pwm_stm32l1xx.c
ttc_manage.pl warn_deleted Template/examples/example_ttc_pwm_stm32l1xx.c
ttc_manage.pl warn_deleted Template/examples/example_ttc_pwm.h
ttc_manage.pl warn_deleted Template/examples/example_ttc_pwm.c
ttc_manage.pl warn_deleted Template/examples/example_ttc_pwm_stm32l1xx.h
ttc_manage.pl warn_deleted Template/examples/DEPRECATED_example_ttc_timer_pwm.c
ttc_manage.pl warn_deleted Template/examples/DEPRECATED_example_ttc_timer_pwm.h
ttc_manage.pl warn_deleted InstallData/low_level/install_TTC_PWM_STM32L1XX.sh
ttc_manage.pl warn_deleted InstallData/install_TTC_PWM.sh
